package ai.group_template;

import net.sf.l2j.gameserver.model.actor.instance.L2NpcInstance;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.network.serverpackets.NpcSay;
import net.sf.l2j.util.Rnd;

/**
 * @author Maxi
 */
public class TurekOrcFootman extends L2AttackableAIScript
{
	private static final int TUREKF = 20499;

	private static boolean _FirstAttacked;

	public TurekOrcFootman(int questId, String name, String descr)
	{
		super(questId, name, descr);
		int[] mobs = {TUREKF};
		registerMobs(mobs);
		_FirstAttacked = false;
	}

	public String onAttack (L2NpcInstance npc, L2PcInstance attacker, int damage, boolean isPet)
	{
		if (npc.getNpcId() == TUREKF)
			if (_FirstAttacked)
			{
				if (Rnd.get(100) == 40)
					npc.broadcastPacket(new NpcSay(npc.getObjectId(),0,npc.getNpcId(),"There is no reason for you to kill me! I have nothing you need!"));
			}
			else
			{
				_FirstAttacked = true;
				npc.broadcastPacket(new NpcSay(npc.getObjectId(),0,npc.getNpcId(),"We shall see about that!"));
			}
		return super.onAttack(npc, attacker, damage, isPet);
	}

	public String onKill(L2NpcInstance npc, L2PcInstance killer, boolean isPet)
	{
		int npcId = npc.getNpcId();
		if (npcId == TUREKF)
			_FirstAttacked = false;
		return super.onKill(npc,killer,isPet);
	}

	public static void main(String[] args)
	{
		new TurekOrcFootman(-1, "TurekOrcFootman", "ai");
	}
}