package ai.group_template;

import net.sf.l2j.gameserver.model.actor.instance.L2NpcInstance;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.network.serverpackets.NpcSay;
import net.sf.l2j.util.Rnd;

/**
 * @author Maxi
 */
public class TurekOrcWarlord extends L2AttackableAIScript
{
	private static final int TUREKW = 20495;

	private static boolean _FirstAttacked;

	public TurekOrcWarlord(int questId, String name, String descr)
	{
		super(questId, name, descr);
		int[] mobs = {TUREKW};
		registerMobs(mobs);
		_FirstAttacked = false;
	}

	public String onAttack (L2NpcInstance npc, L2PcInstance attacker, int damage, boolean isPet)
	{
		if (npc.getNpcId() == TUREKW)
			if (_FirstAttacked)
			{
				if (Rnd.get(100) == 40)
					npc.broadcastPacket(new NpcSay(npc.getObjectId(),0,npc.getNpcId(),"You wont take me down easily."));
			}
			else
			{
				_FirstAttacked = true;
				npc.broadcastPacket(new NpcSay(npc.getObjectId(),0,npc.getNpcId(),"The battle has just begun!"));
			}
		return super.onAttack(npc, attacker, damage, isPet);
	}

	public String onKill(L2NpcInstance npc, L2PcInstance killer, boolean isPet)
	{
		int npcId = npc.getNpcId();
		if (npcId == TUREKW)
			_FirstAttacked = false;
		return super.onKill(npc,killer,isPet);
	}

	public static void main(String[] args)
	{
		new TurekOrcWarlord(-1, "TurekOrcWarlord", "ai");
	}
}