import sys
import time
from net.sf.l2j.gameserver.ai import CtrlIntention
from net.sf.l2j.gameserver.datatables import SkillTable
from net.sf.l2j.gameserver.instancemanager.lastimperialtomb import FrintezzaManager
from net.sf.l2j.gameserver.model import L2Character
from net.sf.l2j.gameserver.model.actor.instance import L2NpcInstance 
from net.sf.l2j.gameserver.model.actor.instance import L2PcInstance
from net.sf.l2j.gameserver.model.quest import State
from net.sf.l2j.gameserver.model.quest import QuestState
from net.sf.l2j.gameserver.model.quest.jython import QuestJython as JQuest
from net.sf.l2j.gameserver.network.serverpackets import NpcSay
from net.sf.l2j.gameserver.network.serverpackets import Earthquake
from net.sf.l2j.gameserver.network.serverpackets import PlaySound
from net.sf.l2j.gameserver.network.serverpackets import SocialAction

IMPERIAL_TOMB_GUIDE = 32011
HALISHWEAK = 29046
HALISHSTRONG = 29047

SCROLL = 8073

MSG1 = "<html><body>You do not have the proper scroll needed for teleport.<br>It is for the teleport where does 1 scroll to you need.</body></html>"

class frintezza(JQuest) :
  def __init__(self,id,name,descr) :
      JQuest.__init__(self,id,name,descr)

  def onTalk (self,npc,player):
     st = player.getQuestState("frintezza")
     st2 = player.getQuestState("654_JourneytoaSettlement")
     if not st : return
     Enable = FrintezzaManager.getInstance().isEnableEnterToLair() and st.getQuestItemsCount(SCROLL)
     npcId = npc.getNpcId()
     if st2:
        if st2.getState() == State.COMPLETED :
           if Enable :
              FrintezzaManager.getInstance().setScarletSpawnTask()
              st.player.teleToLocation(174243,-86318,-5107)
           else:
              st.exitQuest(1)
              return MSG1
        else:
           st.exitQuest(1)
           return MSG1
     else:
        st.exitQuest(1)
        return MSG1
     return

  def onAttack (self,npc,player,damage,isPet):
     npcId = npc.getNpcId()
     objId = npc.getObjectId()
     heading = npc.getHeading()
     if npcId == HALISHWEAK :
        if npc.getCurrentHp() < npc.getMaxHp() * 0.25 :
           npc.reduceCurrentHp(9999999,npc)
           newNpc = self.addSpawn(HALISHSTRONG, npc)
           newNpc.setHeading(heading)
           newNpc.broadcastPacket(SocialAction(objId,3))
           newNpc.getAI().setIntention(CtrlIntention.AI_INTENTION_ATTACK, player);
     return

  def onKill(self,npc,player,isPet):
     st = player.getQuestState("frintezza")
     npcId = npc.getNpcId()
     objId = npc.getObjectId()
     heading = npc.getHeading()
     if npcId == HALISHSTRONG :
        FrintezzaManager.getInstance().setCubeSpawn()
        FrintezzaManager.getInstance().setBossDead()
        if not st : return
        st.exitQuest(1)
     return

QUEST = frintezza(-1,"frintezza","ai")

QUEST.addStartNpc(IMPERIAL_TOMB_GUIDE)
QUEST.addTalkId(IMPERIAL_TOMB_GUIDE)
QUEST.addKillId(HALISHSTRONG)
QUEST.addAttackId(HALISHWEAK)
QUEST.addAttackId(HALISHSTRONG)