package net.sf.PowerPack.Buffer;

import javolution.util.FastMap;
import net.sf.PowerPack.PowerPackConfig;
import net.sf.l2j.L2DatabaseFactory;

import java.sql.*;
import java.util.*;

/**
 * @update S-Project
 */
public class BuffTable
{
	public class Buff
	{
		public int _skillId;
		public int _skillLevel;
		public boolean _force;
		public int _minLevel;
		public int _maxLevel;
		public int _price;

		public Buff(ResultSet r) throws SQLException
		{
			_skillId = r.getInt(2);
			_skillLevel = r.getInt(3);
			_force = r.getInt(4) == 1;
			_minLevel = r.getInt(5);
			_maxLevel = r.getInt(6);
			_price = r.getInt(7);
			if(_price == -1)
			{
				_price = PowerPackConfig.BUFFER_PRICE;
			}
		}
	}

	private static BuffTable _instance = null;
	private Map<String, ArrayList<Buff>> _buffs;

	public static BuffTable getInstance()
	{
		if(_instance == null)
		{
			_instance = new BuffTable();
		}
		return _instance;
	}

	private BuffTable()
	{
		_buffs = new FastMap<String, ArrayList<Buff>>();
		try
		{
			Connection con = L2DatabaseFactory.getInstance().getConnection();
			PreparedStatement stm = con.prepareStatement("select name,skill_id,skill_level,skill_force,char_min_level,char_max_level,price_adena from buff_templates");
			ResultSet rs = stm.executeQuery();
			while(rs.next())
			{
				if(_buffs.get(rs.getString(1)) == null)
				{
					_buffs.put(rs.getString(1), new ArrayList<Buff>());
				}
				ArrayList<Buff> a = _buffs.get(rs.getString(1));
				a.add(new Buff(rs));
			}
			rs.close();
			stm.close();
			try
            {
                con.close();
            }
            catch(Exception e)
            {
            }
			System.out.println("...Loaded " + _buffs.size() + " buff templates");
		}
		catch(Exception e)
		{
			System.out.println("...Error while loading buffs. Please, check buff_templates table");
		}
	}

	public ArrayList<Buff> getBuffsForName(String name)
	{
		return _buffs.get(name);
	}
}