package net.sf.PowerPack.Donate;

import net.sf.PowerPack.PowerPackConfig;
import net.sf.l2j.gameserver.cache.HtmCache;
import net.sf.l2j.gameserver.handler.IBBSHandler;
import net.sf.l2j.gameserver.handler.ICustomByPassHandler;
import net.sf.l2j.gameserver.handler.IVoicedCommandHandler;
import net.sf.l2j.gameserver.model.L2Multisell;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.network.serverpackets.NpcHtmlMessage;
import net.sf.olympiad.Olympiad;

/**
 * @author TheFosT
 * @update S-Project
 */
public class Donate
  implements IVoicedCommandHandler, ICustomByPassHandler, IBBSHandler
{
   private static String[] _CMD =
   {
        "donate"
   };

  public String[] getVoicedCommandList()
  {
     return new String[]
	 {
	 PowerPackConfig.DONATE_COMMAND
	 };
  }

  private boolean checkAllowed(L2PcInstance activeChar)
  {
     String msg = null;
     if (activeChar.isSitting())
       msg = "DonateShop не доступен когда вы сидите";
     else if (PowerPackConfig.DONATE_EXCLUDE_ON.contains("ALL"))
       msg = "DonateShop не доступен в данной зоне";
     else if ((PowerPackConfig.DONATE_EXCLUDE_ON.contains("CURSED")) && (activeChar.isCursedWeaponEquiped()))
       msg = "DonateShop не доступен с проклятым оружием";
     else if ((PowerPackConfig.DONATE_EXCLUDE_ON.contains("ATTACK")) && (activeChar.isAttackingNow()))
       msg = "DonateShop не доступен во время боя";
     else if ((PowerPackConfig.DONATE_EXCLUDE_ON.contains("DUNGEON")) && (activeChar.isIn7sDungeon()))
       msg = "DonateShop не доступен в катакомбах и некрополисах";
     else if ((PowerPackConfig.DONATE_EXCLUDE_ON.contains("RB")) && (activeChar.isInsideZone(2048)))
       msg = "DonateShop не доступен в данной зоне";
     else if ((PowerPackConfig.DONATE_EXCLUDE_ON.contains("PVP")) && (activeChar.isInsideZone(1)))
       msg = "DonateShop не доступен в данной зоне";
     else if ((PowerPackConfig.DONATE_EXCLUDE_ON.contains("PEACE")) && (activeChar.isInsideZone(2)))
       msg = "DonateShop не доступен в данной зоне";
     else if ((PowerPackConfig.DONATE_EXCLUDE_ON.contains("SIEGE")) && (activeChar.isInsideZone(4)))
       msg = "DonateShop не доступен в данной зоне";
     else if ((PowerPackConfig.DONATE_EXCLUDE_ON.contains("OLYMPIAD")) && (((activeChar.isInOlympiadMode()) || (activeChar.isInsideZone(4096)) || (Olympiad.getInstance().isRegistered(activeChar)) || (Olympiad.getInstance().isRegisteredInComp(activeChar)))))
     {
       msg = "DonateShop не доступен на Великой Олимпиаде";
     }
      else if ((PowerPackConfig.DONATE_EXCLUDE_ON.contains("EVENT")) && activeChar.isInEvent())
        msg = "DonateShop не доступен на эвенте";
      else if(activeChar.isDead())
			msg = "Донат Шоп не доступен когда вы мертвы";
     if (msg != null)
	 {
       activeChar.sendMessage(msg);
    }
     return (msg == null);
  }

  public boolean useVoicedCommand(String command, L2PcInstance activeChar, String params)
  {
     if (activeChar == null)
         return
                 false;
     if (!(checkAllowed(activeChar)))
         return
             false;
     String index = "";
     if ((params != null) && (params.length() != 0) && 
       (!(params.equals("0"))))
       index = "-" + params;
     String text = HtmCache.getInstance().getHtm("data/custom/S-Project/PowerPack/Donate/Donate" + index + ".htm");
     activeChar.sendPacket(new NpcHtmlMessage(5, text));
     return
             false;
  }

  public String[] getByPassCommands()
  {
     return _CMD;
  }

  public void handleCommand(String command, L2PcInstance player, String parameters)
  {
     if (player == null)
         return;
     if ((parameters == null) || (parameters.length() == 0))
         return;
     if (!(checkAllowed(player)))
         return;
     if (parameters.startsWith("multisell"))
	 {
      try
	  {
         L2Multisell.getInstance().SeparateAndSend(Integer.parseInt(parameters.substring(9).trim()), player, false, 0.0D);
      }
	  catch (Exception e)
	  {
         player.sendMessage("Данный список не существует");
      }
    }
     else if (parameters.startsWith("Chat"))
       useVoicedCommand("", player, parameters.substring(4).trim());
  }

  public String[] getBBSCommands()
  {
     return _CMD;
  }
}