/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.PowerPack;

import net.sf.PowerPack.Buffer.*;
import net.sf.PowerPack.Donate.Donate;
import net.sf.PowerPack.RaidInfo.RaidInfoHandler;
import net.sf.PowerPack.globalGK.GKHandler;
import net.sf.PowerPack.gmshop.GMShop;
import net.sf.PowerPack.vote.L2TopDeamon;
import net.sf.l2j.gameserver.communitybbs.CommunityBoard;
import net.sf.l2j.gameserver.handler.VoicedCommandHandler;
import net.sf.l2j.gameserver.handler.custom.CustomBypassHandler;
import net.sf.l2j.util.Prints;

/**
 * @author Nick
 * @update S-Project
 */
public class PowerPack
{
	private static PowerPack _instance = null;

	public static PowerPack getInstance()
	{
		if(_instance == null)
		{
			_instance = new PowerPack();
		}
		return _instance;
	}

	private PowerPack()
	{
        Prints.printSection("Load PowerPack");
		PowerPackConfig.load();
		if(PowerPackConfig.BUFFER_ENABLED)
		{
			System.out.println("Buffer:");
			BuffTable.getInstance();
			BuffHandler handler = new BuffHandler();
			if(PowerPackConfig.BUFFER_COMMAND != null && PowerPackConfig.BUFFER_COMMAND.length() > 0)
			{
				VoicedCommandHandler.getInstance().registerVoicedCommandHandler(handler);
			}
			if(PowerPackConfig.BUFFER_USEBBS)
			{
				CommunityBoard.getInstance().registerBBSHandler(handler);
			}
			CustomBypassHandler.getInstance().registerCustomBypassHandler(handler);
			System.out.println("...Enabled");
		}
		if(PowerPackConfig.GLOBALGK_ENABDLED)
		{
			System.out.println("Global Gatekeeper:");
			GKHandler handler = new GKHandler();
			if(PowerPackConfig.GLOBALGK_COMMAND != null && PowerPackConfig.GLOBALGK_COMMAND.length() > 0)
			{
				VoicedCommandHandler.getInstance().registerVoicedCommandHandler(handler);
			}
			if(PowerPackConfig.GLOBALGK_USEBBS)
			{
				CommunityBoard.getInstance().registerBBSHandler(handler);
			}
			CustomBypassHandler.getInstance().registerCustomBypassHandler(handler);
			System.out.println("...Enabled");
		}
		if(PowerPackConfig.GMSHOP_ENABLED)
        {
			System.out.println("GM-Shop:");
			GMShop gs = new GMShop();
			CustomBypassHandler.getInstance().registerCustomBypassHandler(gs);
			if(PowerPackConfig.GLOBALGK_COMMAND!=null && PowerPackConfig.GLOBALGK_COMMAND.length()>0)
				VoicedCommandHandler.getInstance().registerVoicedCommandHandler(gs);
			if(PowerPackConfig.GMSHOP_USEBBS)
				CommunityBoard.getInstance().registerBBSHandler(gs);
			System.out.println("...Enabled");
		}

		if(PowerPackConfig.L2Top_ENABLE)
			L2TopDeamon.getInstance();

		if (PowerPackConfig.DONATE_ENABLED)
		{
             System.out.println("Donate-Shop:");
             Donate gs = new Donate();
             CustomBypassHandler.getInstance().registerCustomBypassHandler(gs);
             if (PowerPackConfig.DONATE_COMMAND !=null && PowerPackConfig.DONATE_COMMAND.length() > 0)
                   VoicedCommandHandler.getInstance().registerVoicedCommandHandler(gs);
             if (PowerPackConfig.DONATE_USEBBS)
             CommunityBoard.getInstance().registerBBSHandler(gs);
             System.out.println("...Enabled");
        }
        if (PowerPackConfig.Raid_Info)
		{
			System.out.println("Raid Info:");
			RaidInfoHandler handler = new RaidInfoHandler();
			CustomBypassHandler.getInstance().registerCustomBypassHandler(handler);
			System.out.println("...Enabled");
        }
	}
}