/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.PowerPack;

import javolution.util.FastList;
import net.sf.l2j.gameserver.datatables.ItemTable;
import net.sf.l2j.gameserver.templates.L2Item;

import java.util.*;
import net.sf.l2j.Config;

/**
 * @author Nick
 * @update S-Project
 */
public class PowerPackConfig
{
	private static String PP_CONFIG_FILE = Config.PowerPack_FILE;

	public static boolean BUFFER_ENABLED;
	public static List<String> BUFFER_EXCLUDE_ON = new FastList<String>();
	public static String BUFFER_COMMAND;
	public static int BUFFER_PRICE;
	public static boolean BUFFER_USEBBS;

	public static List<String> GLOBALGK_EXCLUDE_ON;
	public static boolean GLOBALGK_ENABDLED;
	public static boolean GLOBALGK_USEBBS;
	public static int GLOBALGK_PRICE;
	public static int GLOBALGK_TIMEOUT;
	public static String GLOBALGK_COMMAND;

	public static boolean GMSHOP_ENABLED;
	public static boolean GMSHOP_USEBBS;
	public static String GMSHOP_COMMAND;
	public static List<String> GMSHOP_EXCLUDE_ON;

    public static boolean DONATE_ENABLED;
    public static boolean DONATE_USEBBS;
    public static String DONATE_COMMAND;
    public static List<String> DONATE_EXCLUDE_ON;

    public static boolean L2Top_ENABLE;
    public static long L2Top_DELAY;
    public static String L2Top_PREFIX;
    public static String L2Top_WEB_VOTE_URL;
    public static String L2Top_SMS_VOTE_URL;
    public static int L2Top_WEB_REWARD_ITEMID;
    public static int L2Top_WEB_REWARD_ITEMCOUNT;
    public static int L2Top_SMS_REWARD_ITEMID;
    public static int L2Top_SMS_REWARD_ITEMCOUNT;
    public static boolean L2Top_SMS_REWARD_VOTE_MULTI;

    public static boolean Raid_Info;

	public static void load()
	{
		try
		{
			L2Properties p = new L2Properties(PP_CONFIG_FILE);
			BUFFER_ENABLED = Boolean.parseBoolean(p.getProperty("BufferEnabled", "True"));
			StringTokenizer st = new StringTokenizer(p.getProperty("BufferExcludeOn", ""), " ");
			while(st.hasMoreTokens())
			{
				BUFFER_EXCLUDE_ON.add(st.nextToken());
			}
			BUFFER_COMMAND = p.getProperty("BufferCommand", "buffme");
			BUFFER_PRICE = Integer.parseInt(p.getProperty("BufferPrice", "-1"));
			BUFFER_USEBBS = Boolean.parseBoolean(p.getProperty("BufferUseBBS", "True"));

			GLOBALGK_ENABDLED = Boolean.parseBoolean(p.getProperty("GKEnabled", "True"));
			GLOBALGK_COMMAND = p.getProperty("GKCommand", "teleport");
			GLOBALGK_TIMEOUT = Integer.parseInt(p.getProperty("GKTimeout", "10"));
			if(GLOBALGK_TIMEOUT < 1)
			{
				GLOBALGK_TIMEOUT = 1;
			}
			GLOBALGK_PRICE = Integer.parseInt(p.getProperty("GKPrice", "-1"));
			GLOBALGK_USEBBS = Boolean.parseBoolean(p.getProperty("GKUseBBS", "True"));
			GLOBALGK_EXCLUDE_ON = new FastList<String>();
			st = new StringTokenizer(p.getProperty("GKExcludeOn", ""), " ");
			while(st.hasMoreTokens())
			{
				GLOBALGK_EXCLUDE_ON.add(st.nextToken().toUpperCase());
			}

			GMSHOP_ENABLED = Boolean.parseBoolean(p.getProperty("GMShopEnabled","True"));
			GMSHOP_COMMAND = p.getProperty("GMShopCommand", "gmshop");
			GMSHOP_USEBBS = Boolean.parseBoolean(p.getProperty("GMShopUseBBS","True"));
			GMSHOP_EXCLUDE_ON = new FastList<String>();
			st = new StringTokenizer(p.getProperty("GMShopExcludeOn", ""), " ");
			while(st.hasMoreTokens())
			{
				GMSHOP_EXCLUDE_ON.add(st.nextToken().toUpperCase());
			}

			DONATE_ENABLED = Boolean.parseBoolean(p.getProperty("DonateEnabled", "True"));
            DONATE_COMMAND = p.getProperty("DonateCommand", "donate");
            DONATE_USEBBS = Boolean.parseBoolean(p.getProperty("DonateUseBBS", "True"));
            DONATE_EXCLUDE_ON = new FastList<String>();
            st = new StringTokenizer(p.getProperty("DonateExcludeOn", ""), " ");
            while (st.hasMoreTokens())
                DONATE_EXCLUDE_ON.add(st.nextToken().toUpperCase());

			 L2Top_ENABLE = Boolean.parseBoolean(p.getProperty("L2TopRuEnable", "True")); 
             L2Top_DELAY = Integer.parseInt(p.getProperty("L2TopRuDelay", "1")) * 1000 * 60;
             L2Top_PREFIX = p.getProperty("L2TopRuServerPrefix");
             L2Top_WEB_VOTE_URL = p.getProperty("L2TopRuWebURL");
             L2Top_SMS_VOTE_URL = p.getProperty("L2TopRuSMSURL");
             L2Top_WEB_REWARD_ITEMID = Integer.parseInt(p.getProperty("L2TopRuWebRewardItemId", "57"));
             L2Top_WEB_REWARD_ITEMCOUNT = Integer.parseInt(p.getProperty("L2TopRuWebRewardItemCount", "1"));
             L2Top_SMS_REWARD_ITEMID = Integer.parseInt(p.getProperty("L2TopRuSMSRewardItemId", "57"));
             L2Top_SMS_REWARD_ITEMCOUNT = Integer.parseInt(p.getProperty("L2TopRuSMSRewardItemCount", "1"));
             L2Top_SMS_REWARD_VOTE_MULTI = Boolean.parseBoolean(p.getProperty("L2TopRuSMSRewardMultiVote", "False"));
       	      if (ItemTable.getInstance().getTemplate(L2Top_WEB_REWARD_ITEMID)==null)
               {
				    L2Top_ENABLE = false;
				    System.err.println("PowerPack: Unknown item ("+L2Top_WEB_REWARD_ITEMID+") as vote reward. Vote disabled");
			   }
            Raid_Info = Boolean.parseBoolean(p.getProperty("RaidInfo", "False"));
		}
		catch(Exception e)
		{
			System.err.println("PowerPack: Unable to read  " + PP_CONFIG_FILE);
		}
	}
}