/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.PowerPack.RaidInfo;

import javolution.text.TextBuilder;
import net.sf.l2j.gameserver.datatables.NpcTable;
import net.sf.l2j.gameserver.handler.ICustomByPassHandler;
import net.sf.l2j.gameserver.instancemanager.GrandBossManager;
import net.sf.l2j.gameserver.model.actor.instance.*;
import net.sf.l2j.gameserver.network.serverpackets.NpcHtmlMessage;
import net.sf.l2j.gameserver.templates.StatsSet;

/**
 * @author Enzo
 * @update S-Project
 */
public class RaidInfoHandler implements ICustomByPassHandler
{
        private static final int NPC_ID = 93000;
        private static final String [] _BYPASSCMD = {"raidinfo"};
        private static final int[] BOSSES = {29001, 29006, 29014, 29019, 29020, 29022, 29028, 29045};

        @Override
        public String[] getByPassCommands()
        {
                return _BYPASSCMD;
        }

        @Override
        public void handleCommand(String command, L2PcInstance player, String parameters)
        {
                if(player==null)
                        return;
                if(!(player.getTarget() instanceof L2NpcInstance))
                        return;
                if( ((L2NpcInstance)player.getTarget()).getNpcId()!=NPC_ID)
                        return;
                sendInfo(player);
        }

        private static void sendInfo(L2PcInstance activeChar)
        {
                TextBuilder tb = new TextBuilder();
                tb.append("<html><title>Grand Boss Info 'S-Project'</title><body><br><center>");
                tb.append("<img src=\"L2UI_CH3.herotower_deco\" width=256 height=32><br><br>");
                for(int boss : BOSSES)
                {
                        String name = NpcTable.getInstance().getTemplate(boss).getName();
                        StatsSet actual_boss_stat = GrandBossManager.getInstance().getStatsSet(boss);

                        long delay = 0;

                        if(actual_boss_stat!=null)
                                delay = actual_boss_stat.getLong("respawn_time");

                        if (delay <= System.currentTimeMillis())
                        {
                                tb.append("<font color=\"00C3FF\">" + name + "</color>: " + "<font color=\"9CC300\">Is Alive</color>"+"<br1>");
                        }
                        else
                        {
                                int hours = (int) ((delay - System.currentTimeMillis()) / 1000 / 60 / 60);
                                int mins = (int) (((delay - (hours * 60 * 60 * 1000)) - System.currentTimeMillis()) / 1000 / 60);
                                int seconts = (int) (((delay - ((hours * 60 * 60 * 1000) + (mins * 60 * 1000))) - System.currentTimeMillis()) / 1000);
                                tb.append("<font color=\"00C3FF\">" + name + "</color>" + "<font color=\"FFFFFF\">" +" " + "Respawn in :</color>" + " " + " <font color=\"32C332\">" + hours + " : " + mins + " : " + seconts + "</color><br1>");
                        }
                }

                tb.append("<br><img src=\"L2UI_CH3.herotower_deco\" width=256 height=32><br>");
                tb.append("</center></body></html>");

                NpcHtmlMessage msg = new NpcHtmlMessage(NPC_ID);
                msg.setHtml(tb.toString());

                activeChar.sendPacket(msg);

        }
}