package net.sf.l2j.gameserver.ai.special;

import net.sf.l2j.gameserver.ai.*;
import net.sf.l2j.gameserver.datatables.SkillTable;
import net.sf.l2j.gameserver.model.L2Skill;
import net.sf.l2j.gameserver.model.actor.instance.*;
import net.sf.l2j.gameserver.network.serverpackets.CreatureSay;
import net.sf.l2j.util.Rnd;

/**
 * @update S-Project
 */
public class Benom extends L2AttackableAIScript
{
	private final static int BENOM = 29054;

	public Benom(int questId, String name, String descr)
	{
		super(questId, name, descr);
		int[] mob = new int[] { BENOM };
		registerMobs(mob);
	}

	private final static String[] WORDS = new String []
            {
                    "You should have finished me when you had the chance!",
                    "I will crush all of you!", "I am not finished here, come face me!",
                    "You cowards! I will torture each and everyone of you!"
            };

	public String onAttack(L2NpcInstance npc, L2PcInstance attacker, int damage, boolean isPet, L2Skill skill)
	{
		if (npc == null || attacker == null)
			return super.onAttack(npc, attacker, damage, isPet);
		if (npc.getNpcId() == 29054)
			if (!npc.isCastingNow() && attacker.getClassId().isMage() && Rnd.get(1000) < 15)
			{
				SkillTable.getInstance().getInfo(4996, 1);
				npc.getAI().notifyEvent(CtrlEvent.EVT_AGGRESSION, attacker, 50000);
				npc.broadcastPacket(new CreatureSay(npc.getObjectId(), 0, "Benom",
						WORDS[Rnd.get(WORDS.length)]));
				npc.setTarget(attacker);
				npc.doCast(skill);
			}
		return super.onAttack(npc, attacker, damage, isPet);
	}

	@Override
	public String onKill(L2NpcInstance npc, L2PcInstance killer, boolean isPet)
	{
		if (npc != null && npc.getNpcId() == 29054)
		{
			npc.broadcastPacket(new CreatureSay(npc.getObjectId(), 0, "Benom", "I leave my house this time."));
			npc.broadcastPacket(new CreatureSay(npc.getObjectId(), 0, "Benom", "But you can not take it to paradise."));
		}
		return super.onKill(npc, killer, isPet);
	}

	public static void main(String[] args)
	{
		new Benom(-1, "benom", "ai");
	}
}