/*
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.l2j.gameserver.communitybbs.Manager;

import net.sf.l2j.gameserver.cache.HtmCache;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.Config;

import java.util.StringTokenizer;

/**
 * @update S-Project
 */
public class TopBBSManager extends BaseBBSManager
{
	/*
	 * (non-Javadoc)
	 * @see net.sf.l2j.gameserver.communitybbs.Manager.BaseBBSManager#parsecmd(java.lang.String, net.sf.l2j.gameserver.model.actor.instance.L2PcInstance)
	 */
	@Override
	public void parsecmd(String command, L2PcInstance activeChar)
	{
		if (command.equals("_bbstop"))
		{
			String content = HtmCache.getInstance().getHtm((new StringBuilder()).append("data/").append(Config.HTML_DIR).append("/CommunityBoard/index.htm").toString());
			if (content == null)
			{
				content = (new StringBuilder()).append("<html><body><br><br><center>404 :File Not foud: 'data/").append(Config.HTML_DIR).append("/CommunityBoard/index.htm' </center></body></html>").toString();
			}
			separateAndSend(content, activeChar);
		}
		else if (command.equals("_bbshome"))
		{
			String content = HtmCache.getInstance().getHtm((new StringBuilder()).append("data/").append(Config.HTML_DIR).append("/CommunityBoard/index.htm").toString());
			if (content == null)
			{
				content = (new StringBuilder()).append("<html><body><br><br><center>404 :File Not foud: 'data/").append(Config.HTML_DIR).append("/CommunityBoard/index.htm' </center></body></html>").toString();
			}
			separateAndSend(content, activeChar);
		}
		else if (command.startsWith("_bbstop;"))
		{
			StringTokenizer st = new StringTokenizer(command, ";");
			st.nextToken();
			int idp = Integer.parseInt(st.nextToken());
			String content = HtmCache.getInstance().getHtm((new StringBuilder()).append("data/").append(Config.HTML_DIR).append("/CommunityBoard/").append(idp).append(".htm").toString());
			if (content == null)
			{
				content = (new StringBuilder()).append("<html><body><br><br><center>404 :File Not foud: 'data/").append(Config.HTML_DIR).append("/CommunityBoard/").append(idp).append(".htm' </center></body></html>").toString();
			}
			separateAndSend(content, activeChar);
		}
		else
		{
			String content = HtmCache.getInstance().getHtm((new StringBuilder()).append("data/").append(Config.HTML_DIR).append("/CommunityBoard/favorites.htm").toString());
			if (content == null)
			{
				content = (new StringBuilder()).append("<html><body><br><br><center>404 :File Not foud: 'data/").append(Config.HTML_DIR).append("/CommunityBoard/favorites.htm' </center></body></html>").toString();
			}
			separateAndSend(content, activeChar);
		}
	}

	/*
	 * (non-Javadoc)
	 * @see net.sf.l2j.gameserver.communitybbs.Manager.BaseBBSManager#parsewrite(java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String, net.sf.l2j.gameserver.model.actor.instance.L2PcInstance)
	 */
	@Override
	public void parsewrite(String ar1, String ar2, String ar3, String ar4, String ar5, L2PcInstance activeChar)
	{
		// TODO Auto-generated method stub
	}

	private static TopBBSManager _instance = new TopBBSManager();

	/**
	 * @return
	 */
	public static TopBBSManager getInstance()
	{
		return _instance;
	}
}