package net.sf.l2j.gameserver.handler.itemhandlers;

import java.sql.*;

import net.sf.l2j.L2DatabaseFactory;
import net.sf.l2j.gameserver.model.L2ItemInstance;
import org.apache.commons.logging.*;

import net.sf.l2j.Config;
import net.sf.l2j.gameserver.handler.IItemHandler;
import net.sf.l2j.gameserver.model.actor.instance.*;
import net.sf.l2j.gameserver.network.serverpackets.SocialAction;

/**
 * @ypdate S-Project
 */
public class HeroCustomItem implements IItemHandler
{
	public HeroCustomItem()
	{
	//null
	}

	private final static Log _log = LogFactory.getLog(HeroCustomItem.class.getName());

	String INSERT_DATA = "REPLACE INTO characters_data (obj_Id, char_name, hero, noble, hero_end_date) VALUES (?,?,?,?,?,?)";

	public void useItem(L2PlayableInstance playable, L2ItemInstance item)
	{
		if(Config.HERO_CUSTOM_ITEMS)
		{
			if(!(playable instanceof L2PcInstance))
				return;

			L2PcInstance activeChar = (L2PcInstance) playable;

			if(activeChar.isInOlympiadMode())
			{
				activeChar.sendMessage("Этот итем нельзя использовать когда вы на Олимпиаде.");
                return;
			}
            if(activeChar.isInFunEvent())
			{
				activeChar.sendMessage("Вы не можете использовать итем на Евенте");
				return;
			}
			if(activeChar.isHero())
			{
				activeChar.sendMessage("Вы уже Герой!");
			}
			else
			{
				activeChar.broadcastPacket(new SocialAction(activeChar.getObjectId(), 16));
				activeChar.setHero(true);
				updateDatabase(activeChar, Config.HERO_CUSTOM_DAY * 24L * 60L * 60L * 1000L);
				activeChar.sendMessage("Поздравляем теперь вы герой, Ваш статус: Герой, + новые скилы, Геройство пропадет после рестарта");
				activeChar.broadcastUserInfo();
				playable.destroyItem("Consume", item.getObjectId(), 1, null, false);
				activeChar.getInventory().addItem("Wings", 6842, 1, activeChar, null);
			}
			activeChar = null;
		}
	}

	public int[] getItemIds()
	{
		return ITEM_IDS;
	}
	
	private void updateDatabase(L2PcInstance player, long heroTime)
	{
		Connection con = null;
		try
		{
			if(player == null)
				return;

			con = L2DatabaseFactory.getInstance().getConnection();
			PreparedStatement stmt = con.prepareStatement(INSERT_DATA);

			stmt.setInt(1, player.getObjectId());
			stmt.setString(2, player.getName());
			stmt.setInt(3, 1);
			stmt.setInt(4, player.isNoble() ? 1 : 0);
			stmt.setLong(5, heroTime == 0 ? 0 : System.currentTimeMillis() + heroTime);
			stmt.execute();
			stmt.close();
			stmt = null;
		}
		catch(Exception e)
		{
			_log.error("Error: could not update database: ", e);
		}
		finally
		{
			try
			{
			con.close();
			}
			catch(Exception e)
			{
			}
			con = null;
		}
	}

	private static final int ITEM_IDS[] =
	{
		Config.HERO_CUSTOM_ITEM_ID
	};
}