package net.sf.l2j.gameserver.handler.itemhandlers;

import net.sf.l2j.Config;
import net.sf.l2j.gameserver.handler.IItemHandler;
import net.sf.l2j.gameserver.model.L2ItemInstance;
import net.sf.l2j.gameserver.model.actor.instance.*;
import net.sf.l2j.gameserver.network.serverpackets.SocialAction;

/**
 * @update S-Project
 */
public class NobleCustomItem implements IItemHandler
{
	public NobleCustomItem()
	{
	//null
	}

	public void useItem(L2PlayableInstance playable, L2ItemInstance item)
	{
		if(Config.NOBLE_CUSTOM_ITEMS)
		{
			if(!(playable instanceof L2PcInstance))
				return;

			L2PcInstance activeChar = (L2PcInstance) playable;

			if(activeChar.isInOlympiadMode())
			{
				activeChar.sendMessage("Этот итем нельзя использовать когда вы на Олимпиаде.");
                return;
			}
            if(activeChar.isInFunEvent())
			{
				activeChar.sendMessage("Вы не можете использовать итем на евенте");
				return;
			}
			if(activeChar.isNoble())
			{
				activeChar.sendMessage("Вы уже Нублесс!.");
			}
			else
			{
				activeChar.broadcastPacket(new SocialAction(activeChar.getObjectId(), 16));
				activeChar.setNoble(true);
				activeChar.sendMessage("Поздравляем теперь вы нублесс, ваш статус Noblesse , And Noblesse Skills.");
				activeChar.broadcastUserInfo();
				playable.destroyItem("Consume", item.getObjectId(), 1, null, false);
				activeChar.getInventory().addItem("Tiara", 7694, 1, activeChar, null);
			}
			activeChar = null;
		}
	}

	public int[] getItemIds()
	{
		return ITEM_IDS;
	}

	private static final int ITEM_IDS[] =
	{
		Config.NOOBLE_CUSTOM_ITEM_ID
	};
}