package net.sf.l2j.gameserver.handler.skillhandlers;

import net.sf.Event.CTF;
import net.sf.Event.DM;
import net.sf.Event.TvT;
import net.sf.l2j.gameserver.datatables.MapRegionTable;
import net.sf.l2j.gameserver.handler.ISkillHandler;
import net.sf.l2j.gameserver.instancemanager.CustomZoneManager;
import net.sf.l2j.gameserver.model.*;
import net.sf.l2j.gameserver.model.L2Skill.SkillType;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.network.serverpackets.ActionFailed;
import net.sf.l2j.gameserver.network.serverpackets.SystemMessage;

/**
 * @update S-Project
 */
public class Recall implements ISkillHandler
{
	private static final SkillType[] SKILL_IDS =
            {
                    SkillType.RECALL
            };

 	public void useSkill(@SuppressWarnings("unused") L2Character activeChar, @SuppressWarnings("unused") L2Skill skill, L2Object[] targets)
	{
        if (activeChar instanceof L2PcInstance)
        {
        }

		try
        {
			for (int index = 0; index < targets.length; index++)
			{
				if (!(targets[index] instanceof L2Character))
					continue;

				L2Character target = (L2Character)targets[index];

                if (target instanceof L2PcInstance)
                {
                    L2PcInstance targetChar = (L2PcInstance)target;

	                if(CustomZoneManager.getInstance().checkIfInZone("NoEscape", targetChar))
                    {
                        targetChar.sendPacket(SystemMessage.sendString("Невозможно использовать в этой местности"));
                        targetChar.sendPacket(new ActionFailed());
                        break;                   
                    }
                    // Check to see if the current player target is in a festival.
                    if (targetChar.isFestivalParticipant())
                    {
                        targetChar.sendPacket(SystemMessage.sendString("You may not use an escape skill in a festival."));
                        continue;
                    }

	                if((targetChar._inEventCTF && CTF.is_started()) || (targetChar._inEventTvT && TvT.is_started()) || (targetChar._inEventDM && DM.is_started()))
					{
						targetChar.sendMessage("You can't use escape skill in Event.");
						continue;
					}
                    if (targetChar.isInFunEvent())
                    {
                        targetChar.sendPacket(SystemMessage.sendString("Вы не можете использовать это на Евенте."));
                        continue;
                    }

                    if (targetChar.isInOlympiadMode())
                    {
                         targetChar.sendPacket(SystemMessage.sendString("Вы не можете использовать это на Олимпиаде."));
                         continue;
                    }
                    // Check to see if player is in jail
                    if (targetChar.isInJail())
                    {
                        targetChar.sendPacket(SystemMessage.sendString("Вы не можете использовать сое в тюрьме."));
                        continue;
                    }

                    // Check to see if player is in a duel
                    if (targetChar.isInDuel())
                    {
                        targetChar.sendPacket(SystemMessage.sendString("Нельзя использовать сое в дуэле."));
                        continue;
                    }
                }

                target.teleToLocation(MapRegionTable.TeleportWhereType.Town);
			}
        }
        catch (Throwable e)
        {
 	 	}
 	}

	public SkillType[] getSkillIds()
	{
		return SKILL_IDS;
	}
}