package net.sf.l2j.gameserver.handler.voicedcommandhandlers;

import net.sf.l2j.Config;
import net.sf.l2j.gameserver.handler.IVoicedCommandHandler;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.network.serverpackets.ItemList;
import net.sf.l2j.gameserver.util.FloodProtector;

/**
 * @update S-Project
 */
public class Banking implements IVoicedCommandHandler
{
	private static String[] _voicedCommands =
	{
			"bank",
            "withdraw",
            "deposit"
	};

	/**
	 * @see net.sf.l2j.gameserver.handler.IVoicedCommandHandler#useVoicedCommand(java.lang.String,
	 *      net.sf.l2j.gameserver.model.actor.instance.L2PcInstance, java.lang.String)
	 */
	public boolean useVoicedCommand(String command, L2PcInstance activeChar, String target)
	{
		if(!FloodProtector.getInstance().tryPerformAction(activeChar.getObjectId(), FloodProtector.PROTECTED_UseCommand))
        {
               activeChar.sendMessage("Флуд защита");
               return true;
        }

		if(command.equalsIgnoreCase("bank"))
		{
			activeChar.sendMessage(".deposit (" + Config.BANKING_SYSTEM_ADENA + " Adena = " + Config.BANKING_SYSTEM_GOLDBARS + " Goldbar) / .withdraw (" + Config.BANKING_SYSTEM_GOLDBARS + " Goldbar = " + Config.BANKING_SYSTEM_ADENA + " Adena)");
		}
		else if(command.equalsIgnoreCase("deposit"))
		{
			if(activeChar.getInventory().getInventoryItemCount(57, 0) >= Config.BANKING_SYSTEM_ADENA)
			{
				activeChar.getInventory().reduceAdena("Goldbar", Config.BANKING_SYSTEM_ADENA, activeChar, null);
				activeChar.getInventory().addItem("Goldbar", 3470, Config.BANKING_SYSTEM_GOLDBARS, activeChar, null);
				activeChar.getInventory().updateDatabase();
				activeChar.sendPacket(new ItemList(activeChar, true));
				activeChar.sendMessage("Спасибо, теперь вы имеете " + Config.BANKING_SYSTEM_GOLDBARS + " Goldbar(s), и на " + Config.BANKING_SYSTEM_ADENA + " меньше adena.");
			}
			else
			{
				activeChar.sendMessage("У вас нет достаточного количества Adena, чтобы преобразовать в Goldbar(s), Вам нужно " + Config.BANKING_SYSTEM_ADENA + " Adena.");
			}
		}
		else if(command.equalsIgnoreCase("withdraw"))
		{
			if(activeChar.getInventory().getInventoryItemCount(3470, 0) >= Config.BANKING_SYSTEM_GOLDBARS)
			{
				activeChar.getInventory().destroyItemByItemId("Adena", 3470, Config.BANKING_SYSTEM_GOLDBARS, activeChar, null);
				activeChar.getInventory().addAdena("Adena", Config.BANKING_SYSTEM_ADENA, activeChar, null);
				activeChar.getInventory().updateDatabase();
				activeChar.sendPacket(new ItemList(activeChar, true));
				activeChar.sendMessage("Спасибо, теперь вы имеете " + Config.BANKING_SYSTEM_ADENA + " Adena, и на" + Config.BANKING_SYSTEM_GOLDBARS + " меньше Goldbar(s).");
			}
			else
			{
				activeChar.sendMessage("У вас нету Goldbars, чтобы преобразовать " + Config.BANKING_SYSTEM_ADENA + " Adena.");
			}
		}
		return true;
	}

	/**
	 * @see net.sf.l2j.gameserver.handler.IVoicedCommandHandler#getVoicedCommandList()
	 */
	public String[] getVoicedCommandList()
	{
		return _voicedCommands;
	}
}