package net.sf.l2j.gameserver.handler.voicedcommandhandlers;

import net.sf.l2j.gameserver.handler.IVoicedCommandHandler;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.network.SystemMessageId;
import net.sf.l2j.gameserver.network.serverpackets.SystemMessage;
import net.sf.l2j.gameserver.util.FloodProtector;

/**
 * @update S-Project
 */
public class ExpGain implements IVoicedCommandHandler
{
	private static final String[] VOICED_COMMANDS = { "exp" };

	public boolean useVoicedCommand(String command, L2PcInstance activeChar, String target)
	{
        if(!FloodProtector.getInstance().tryPerformAction(activeChar.getObjectId(), FloodProtector.PROTECTED_UseCommand))
        {
               activeChar.sendMessage("Флуд защита");
               return true;
        }
		if (command.equalsIgnoreCase("exp"))
			if (activeChar != null)
				if (activeChar.canGetExp())
				{
					activeChar.setCanGetExp(false);
					showGainExpOn(activeChar);
				}
				else
				{
					activeChar.setCanGetExp(true);
					showGainExpOff(activeChar);
				}
		return true;
	}

	public void showGainExpOn (L2PcInstance player)
	{
		{
			SystemMessage sm;
			sm = new SystemMessage(SystemMessageId.S1_S2);
			sm.addString("Блокировка EXP и SP включена");
			player.sendPacket(sm);
		}
	}

	public void showGainExpOff (L2PcInstance player)
	{
		{
			SystemMessage sm;
			sm = new SystemMessage(SystemMessageId.S1_S2);
			sm.addString("Блокировка EXP и SP выключена");
			player.sendPacket(sm);
		}
	}

	public String[] getVoicedCommandList()
	{
		return VOICED_COMMANDS;
	}
}