package net.sf.l2j.gameserver.handler.voicedcommandhandlers;

import net.sf.l2j.L2DatabaseFactory;
import net.sf.l2j.gameserver.handler.IVoicedCommandHandler;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.util.FloodProtector;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Logger;

public class ipblock implements IVoicedCommandHandler
{
  private static Logger _log = Logger.getLogger(ipblock.class.getName());
  private static final String[] VOICED_COMMANDS =
          {
                  "ipblock"
          };

  public boolean useVoicedCommand(String s, L2PcInstance l2pcinstance, String s1)
  {
    if (s.startsWith("ipblock"))
    {
      if(!FloodProtector.getInstance().tryPerformAction(l2pcinstance.getObjectId(), FloodProtector.PROTECTED_UseCommand))
        {
               l2pcinstance.sendMessage("Флуд защита");
               return true;
        }
      Object obj = null;
      Object obj1 = null;
      try
      {
        Connection connection = L2DatabaseFactory.getInstance().getConnection();
        PreparedStatement preparedstatement = connection.prepareStatement("SELECT * FROM accounts WHERE login=?");
        preparedstatement.setString(1, l2pcinstance.getAccountName());
        ResultSet resultset = preparedstatement.executeQuery();
        resultset.next();
        if (resultset.getBoolean("IPBlock"))
        {
          PreparedStatement preparedstatement1 = connection.prepareStatement("UPDATE accounts SET ipblock = 0 WHERE login=?");
          preparedstatement1.setString(1, l2pcinstance.getAccountName());
          preparedstatement1.execute();
          l2pcinstance.sendMessage("Ваш аккаунт больше не привязан к ip-адресу");
          _log.info("changing ip block mode for account " + l2pcinstance.getAccountName() + ": Blocking off");
        }
        else
        {
          PreparedStatement preparedstatement2 = connection.prepareStatement("UPDATE accounts SET ipblock = 1 WHERE login=?");
          preparedstatement2.setString(1, l2pcinstance.getAccountName());
          preparedstatement2.execute();
          l2pcinstance.sendMessage("Ваш аккаунт был привязан к ip-адресу " + resultset.getString("lastIP"));
          _log.info("changing ip block mode for account " + l2pcinstance.getAccountName() + ": Blocking on");
        }
      }
      catch (SQLException sqlexception)
      {
        _log.warning("Could not store IPBlock mode: " + sqlexception);
      }
    }
    return true;
  }
  public String[] getVoicedCommandList()
  {
    return VOICED_COMMANDS;
  }
}