package net.sf.l2j.gameserver.handler.voicedcommandhandlers;

import net.sf.l2j.gameserver.handler.IVoicedCommandHandler;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.network.SystemMessageId;
import net.sf.l2j.gameserver.network.serverpackets.SystemMessage;
import net.sf.l2j.gameserver.util.FloodProtector;

/**
 * @update S-Project
 */
public class set implements IVoicedCommandHandler
{
	private static final String[] VOICED_COMMANDS =
            {
                    "set name",
                    "set home",
                    "set group"
            };

    public boolean useVoicedCommand(String command, L2PcInstance activeChar, String target)
    {
        if(!FloodProtector.getInstance().tryPerformAction(activeChar.getObjectId(), FloodProtector.PROTECTED_UseCommand))
        {
               activeChar.sendMessage("Флуд защита");
               return true;
        }
    	if(command.startsWith("set privileges"))
		{
    		int n = Integer.parseInt(command.substring(15));
    		L2PcInstance pc = (L2PcInstance) activeChar.getTarget();
    		if(pc!=null)
            {
    			if(activeChar.getClan().getClanId()==pc.getClan().getClanId()&&(activeChar.getClanPrivileges()>n)||activeChar.isClanLeader())
                {
    				pc.setClanPrivileges(n);
    				SystemMessage sm = new SystemMessage(SystemMessageId.S1_S2);
    	            sm.addString("Your clan privileges have been set to " + n + " by " + activeChar.getName());
    	            activeChar.sendPacket(sm);
    			}

    		}

     	}
    	return true;
    }

    public String[] getVoicedCommandList()
    {
        return VOICED_COMMANDS;
    }
}