package net.sf.l2j.gameserver.model.actor.instance;

import net.sf.l2j.gameserver.model.*;
import net.sf.l2j.gameserver.templates.L2NpcTemplate;

public final class L2GrandBossInstance extends L2MonsterInstance
{
    private static final int BOSS_MAINTENANCE_INTERVAL = 10000;

	public L2GrandBossInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

    @Override
	protected int getMaintenanceInterval() { return BOSS_MAINTENANCE_INTERVAL; }

    @Override
	public void onSpawn()
    {
    	setIsRaid(true);
    	super.onSpawn();
    }

    @Override
	public void reduceCurrentHp(double damage, L2Character attacker, boolean awake)
    {
        if (this.IsInSocialAction() || this.isInvul()) return;
        super.reduceCurrentHp(damage, attacker, awake);
    }

    protected boolean _isInSocialAction = false;

    public boolean IsInSocialAction()
    {
        return _isInSocialAction;
    }

    public void setIsInSocialAction(boolean value)
    {
        _isInSocialAction = value;
    }

    @Override
    public void doAttack(L2Character target)
    {
    	if(_isInSocialAction) return;
    	else super.doAttack(target);
    }

    @Override
    public void doCast(L2Skill skill)
    {
    	if(_isInSocialAction) return;
    	else super.doCast(skill);
    }
}