package net.sf.l2j.gameserver.skills.effects;

import net.sf.l2j.gameserver.model.L2Effect;
import net.sf.l2j.gameserver.model.actor.instance.*;
import net.sf.l2j.gameserver.network.serverpackets.*;
import net.sf.l2j.gameserver.skills.Env;

/**
 * @update S-Project
 */
final class EffectBluff extends L2Effect
{
    public EffectBluff(Env env, EffectTemplate template)
    {
        super(env, template);
    }

	@Override
	public EffectType getEffectType()
    {
        return EffectType.BLUFF;
    }

    @Override
	public boolean onStart()
	{
		if (getEffected() instanceof L2FolkInstance)
			return false;
		if (getEffected() instanceof L2NpcInstance && ((L2NpcInstance) getEffected()).getNpcId() == 35062 || getSkill().getId() != 358)
			return false;
		if (getEffected() instanceof L2SiegeSummonInstance)
			return false;
		BeginRotation br = new BeginRotation(getEffected().getObjectId(), getEffected().getHeading(), 1);
		getEffected().broadcastPacket(br);
		StopRotation sr = new StopRotation(getEffected().getObjectId(), getEffector().getHeading());
		getEffected().broadcastPacket(sr);
		getEffected().setHeading(getEffector().getHeading());
		getEffected().setTarget(null);
		getEffected().startStunning();
		onActionTime();
		return true;
	}
	
	@Override
	public void onExit()
	{
		getEffected().stopStunning(this);
	}
	
	@Override
	public boolean onActionTime()
	{
		return false;
	}
}