/**
 * 
 */
package org.mmocore.test.testserver;

import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.util.concurrent.*;

import org.mmocore.network.*;

/**
 * @author KenM
 * @update S-Project
 */
public class SelectorHelper extends TCPHeaderHandler<ServerClient> implements IPacketHandler<ServerClient>, IMMOExecutor<ServerClient>, IClientFactory<ServerClient>
{
    public SelectorHelper()
    {
        super(null);
    }

    ExecutorService _tpe = Executors.newFixedThreadPool(4);
    
    public ReceivablePacket<ServerClient> handlePacket(ByteBuffer buf, ServerClient client)
    {
        return new TestRecvPacket();
    }

    public void execute(ReceivablePacket<ServerClient> packet)
    {
        _tpe.execute(packet);
    }

    public ServerClient create(MMOConnection<ServerClient> con)
    {
        System.out.println("new client");
        ServerClient sc = new ServerClient(con);
        return sc;
    }

    @Override
    public HeaderInfo<ServerClient> handleHeader(SelectionKey key, ByteBuffer buf)
    {
        int avaliable = buf.remaining();
        if (avaliable >= 2)
        {
            int dataSize = buf.getShort() & 0xFFFF;
            System.err.println("DATASIZE: "+dataSize);
            return this.getHeaderInfoReturn().set(0, dataSize - 2, false, null);
        }
        else
        {
            System.err.println("HEADER PENDING: "+(2 - avaliable));
            return this.getHeaderInfoReturn().set(2 - avaliable, 0, false, null);
        }
    }
}