import sys
from java.lang import String
from java.lang import Integer
from net.sf.l2j.util import Rnd
from net.sf.l2j import L2DatabaseFactory
from net.sf.l2j.gameserver.model.quest import State
from net.sf.l2j.gameserver.model import L2ItemInstance
from net.sf.l2j.gameserver.network.serverpackets import ItemList
from net.sf.l2j.gameserver.network.serverpackets import UserInfo
from net.sf.l2j.gameserver.network.serverpackets import CharInfo
from net.sf.l2j.gameserver.network.serverpackets import InventoryUpdate
from net.sf.l2j.gameserver.model.quest.jython import QuestJython as JQuest

Qn = "919_Enchanter"
Npc = 300300

MaxEnchantWeapon = 20 # . 
MaxEnchantArmor = 15  # . 
MaxEnchantJewel = 15  # . 

Adena = 4037 # Id 

JPrice = [0,1,2,3,4,5] #      +1
JPrice10 = [6,7,8,9,10,11] #      +10
JPriceRnd = [12,13,14,15,16,17] #     

APrice = [0,1,2,3,4,6] #      +1
APrice10 = [6,7,8,9,10,11] #      +10
APriceRnd = [12,13,14,15,16,17] #     

WPrice = [0,1,2,3,4,7] #      +1
WPrice10 = [6,7,8,9,10,11] #      +10
WPriceRnd = [12,13,14,15,16,17] #     

Jewel = ["None"]
Armor = ["Light","Heavy","Magic"]
Weapon = ["Sword","Blunt","Dagger","Bow","Etc","Pole","Fist","Dual Sword","Dual Fist","Big Sword","Big Blunt","Shield"]

SlotForEnchant = [7,8,6,10,11,9,12,3,1,2,4,5] #     [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17]
NoEnchantItem = [] # Id    


def getItemIcon(ItemId):
  con=L2DatabaseFactory.getInstance().getConnection()
  II=con.prepareStatement("SELECT itemIcon FROM z_market_icons WHERE itemId=?")
  II.setInt(1, ItemId)
  rs=II.executeQuery()
  ItemIcon = ""
  if rs.next() :
    ItemIcon = rs.getString("itemIcon")
  else :
    ItemIcon = "icon.etc_adena_i00"
  try :
    con.close()
  except :
    pass
  return ItemIcon

def validateItem(ItemId) :
  for itm in NoEnchantItem :
    if itm == ItemId :
      return False
  return True

def getHexSlot(Slot) :
  if Slot == 0 :
    return 0x01
  elif Slot == 1 :	#  
    return 0x04
  elif Slot == 2 :	#  
    return 0x02
  elif Slot == 3 :	# 
    return 0x08
  elif Slot == 4 :	#  
    return 0x20
  elif Slot == 5 :	#  
    return 0x10
  elif Slot == 6 :	# 
    return 0x40
  elif Slot == 7 :	#  
    return 0x80
  elif Slot == 8 :	#  
    return 0x0100
  elif Slot == 9 :	# 
    return 0x0200
  elif Slot == 10 :	#  
    return 0x0400
  elif Slot == 11 :	#  
    return 0x0800
  elif Slot == 12 :	# 
    return 0x1000
  elif Slot == 13 :	#
    return 0x2000
  elif Slot == 14 :	# / 
    return 0x4000
  elif Slot == 15 :	#
    return 0x040000
  elif Slot == 16 :	#
    return 0x010000
  elif Slot == 17 :	#
    return 0x080000
  return 0x00

print "Loaded: 919_Enchanter - OK"

class Quest (JQuest) :

  def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

  def onTalk (Self,npc,player) :
    st = player.getQuestState(Qn)
    npcId = npc.getNpcId()
    htmltext = u"<html><title>Donate Shop</title><body><br><br><br><center>\u041c\u043d\u0435 \u043d\u0435 \u0447\u0435\u0433\u043e \u0441\u043a\u0430\u0437\u0430\u0442\u044c \u0432\u0430\u043c !</center></body></html>"
    if not st : return htmltext
    htmltext = u"<html><title>Donate Shop</title><body><center><br><font color=\"00FF00\">\u0412\u044b\u0431\u0435\u0440\u0438\u0442\u0435 \u0432\u0435\u0449\u044c \u043a\u0430\u0442\u043e\u0440\u0443\u044e \u0445\u043e\u0442\u0438\u0442\u0435 \u0437\u0430\u0442\u043e\u0447\u0438\u0442\u044c<br>"
    for Slot in SlotForEnchant :
      Item1 = player.getInventory().getPaperdollItemByL2ItemId(getHexSlot(Slot))
      if Item1 != None :
        if validateItem(Item1.getItemId()) :
          Grade = Item1.getItem().getCrystalType()
          if Grade not in [0] :
            if Grade == 1:
              pgrade = str("[D]")
            elif Grade == 2:
              pgrade = str("[C]")
            elif Grade == 3:
              pgrade = str("[B]")
            elif Grade == 4:
              pgrade = str("[A]")
            elif Grade == 5:
             pgrade = str("[S]")
            else:
              pgrade = str("")
            htmltext = htmltext + "<img src=\"" + getItemIcon(Item1.getItemId()) + "\" width=32 height=32><a action=\"bypass -h Quest 919_Enchanter slot_" + str(Slot) + "\">" + Item1.getItemName() + " " + str(pgrade) + " +" + str(Item1.getEnchantLevel()) + "</a><br>"
    htmltext = htmltext + "</font></center></body></html>"
    return htmltext

  def onAdvEvent (self,event,npc,player) :
    st = player.getQuestState(Qn)
    htmltext = u"<html><title>Donate Shop</title><body><br><br><br><center>\u041c\u043d\u0435 \u043d\u0435 \u0447\u0435\u0433\u043e \u0441\u043a\u0430\u0437\u0430\u0442\u044c \u0432\u0430\u043c !</center></body></html>"
    if not st : return htmltext
    strEvent = String(event)
    if strEvent.startsWith("slot") :
      intEvent = Integer.parseInt(strEvent.substring(5))
      htmltext = "<html><title>Donate Shop</title><body><br><center>"
      Item1 = player.getInventory().getPaperdollItemByL2ItemId(getHexSlot(intEvent))
      if Item1 != None :
        if validateItem(Item1.getItemId()) :
          ItemEnchant = Item1.getEnchantLevel()
          htmltext = htmltext + "<img src=\"" + getItemIcon(Item1.getItemId()) + "\" width=32 height=32><br>"
          htmltext = htmltext + u"\u0418\u043c\u044f: " + Item1.getItemName() + "<br>"
          htmltext = htmltext + u"\u0417\u0430\u0442\u043e\u0447\u043a\u0430 \u043f\u0440\u0435\u0434\u043c\u0435\u0442\u0430 : " + str(ItemEnchant) + "<br>"
          Grade = Item1.getItem().getCrystalType()
          Itype = str(Item1.getItemType())
          if Itype in Jewel and ItemEnchant < MaxEnchantJewel :
            if ItemEnchant < MaxEnchantJewel :
              htmltext = htmltext + u"\u0421\u0442\u043e\u0438\u043c\u043e\u0441\u0442\u044c +1 : " + str(JPrice[Grade]) + "<br>"
            if ItemEnchant + 10 <= MaxEnchantJewel :
              htmltext = htmltext + u"\u0421\u0442\u043e\u0438\u043c\u043e\u0441\u0442\u044c +10 : " + str(JPrice10[Grade]) + "<br>"
            if ItemEnchant < MaxEnchantJewel :
              htmltext = htmltext + u"\u0421\u0442\u043e\u0438\u043c\u043e\u0441\u0442\u044c \u0440\u0435\u043d\u0434\u043e\u043c\u0430 : " + str(JPriceRnd[Grade]) + "<br><br>"
            if ItemEnchant < MaxEnchantJewel :
              htmltext = htmltext + "<a action=\"bypass -h Quest 919_Enchanter plusone_" + str(intEvent) + u"\">\u0414\u043e\u0431\u0430\u0432\u0438\u0442\u044c +1 \u043a \u0437\u0430\u0442\u043e\u0447\u043a\u0435 \u043f\u0440\u0435\u0434\u043c\u0435\u0442\u0430</a><br>"
            if ItemEnchant + 10 <= MaxEnchantJewel :
              htmltext = htmltext + "<a action=\"bypass -h Quest 919_Enchanter plusten_" + str(intEvent) + u"\">\u0414\u043e\u0431\u0430\u0432\u0438\u0442\u044c +10 \u043a \u0437\u0430\u0442\u043e\u0447\u043a\u0435 \u043f\u0440\u0435\u0434\u043c\u0435\u0442\u0430</a><br>"
            if ItemEnchant < MaxEnchantJewel :
              htmltext = htmltext + "<a action=\"bypass -h Quest 919_Enchanter rnd_" + str(intEvent) + u"\">\u0418\u0441\u043f\u044b\u0442\u0430\u0442\u044c \u0443\u0434\u0430\u0447\u0443 \u0441\u043b\u0443\u0447\u0430\u0439\u043d\u043e\u0439 \u0437\u0430\u0442\u043e\u0447\u043a\u043e\u0439</a>"
          elif Itype in Armor and ItemEnchant < MaxEnchantArmor :
            if ItemEnchant < MaxEnchantArmor :
              htmltext = htmltext + u"\u0421\u0442\u043e\u0438\u043c\u043e\u0441\u0442\u044c +1 : " + str(APrice[Grade]) + "<br>"
            if ItemEnchant + 10 <= MaxEnchantArmor :
              htmltext = htmltext + u"\u0421\u0442\u043e\u0438\u043c\u043e\u0441\u0442\u044c +10 : " + str(APrice10[Grade]) + "<br>"
            if ItemEnchant < MaxEnchantArmor :
              htmltext = htmltext + u"\u0421\u0442\u043e\u0438\u043c\u043e\u0441\u0442\u044c \u0440\u0435\u043d\u0434\u043e\u043c\u0430 : " + str(APriceRnd[Grade]) + "<br><br>"
            if ItemEnchant < MaxEnchantArmor :
              htmltext = htmltext + "<a action=\"bypass -h Quest 919_Enchanter plusone_" + str(intEvent) + u"\">\u0414\u043e\u0431\u0430\u0432\u0438\u0442\u044c +1 \u043a \u0437\u0430\u0442\u043e\u0447\u043a\u0435 \u043f\u0440\u0435\u0434\u043c\u0435\u0442\u0430</a><br>"
            if ItemEnchant + 10 <= MaxEnchantArmor :
              htmltext = htmltext + "<a action=\"bypass -h Quest 919_Enchanter plusten_" + str(intEvent) + u"\">\u0414\u043e\u0431\u0430\u0432\u0438\u0442\u044c +10 \u043a \u0437\u0430\u0442\u043e\u0447\u043a\u0435 \u043f\u0440\u0435\u0434\u043c\u0435\u0442\u0430</a><br>"
            if ItemEnchant < MaxEnchantArmor :
              htmltext = htmltext + "<a action=\"bypass -h Quest 919_Enchanter rnd_" + str(intEvent) + u"\">\u0418\u0441\u043f\u044b\u0442\u0430\u0442\u044c \u0443\u0434\u0430\u0447\u0443 \u0441\u043b\u0443\u0447\u0430\u0439\u043d\u043e\u0439 \u0437\u0430\u0442\u043e\u0447\u043a\u043e\u0439</a>"
          elif Itype in Weapon and ItemEnchant < MaxEnchantWeapon :
            if ItemEnchant < MaxEnchantWeapon :
              htmltext = htmltext + u"\u0421\u0442\u043e\u0438\u043c\u043e\u0441\u0442\u044c +1 : " + str(WPrice[Grade]) + "<br>"
            if ItemEnchant + 10 <= MaxEnchantWeapon :
              htmltext = htmltext + u"\u0421\u0442\u043e\u0438\u043c\u043e\u0441\u0442\u044c +10 : " + str(WPrice10[Grade]) + "<br>"
            if ItemEnchant < MaxEnchantWeapon :
              htmltext = htmltext + u"\u0421\u0442\u043e\u0438\u043c\u043e\u0441\u0442\u044c \u0440\u0435\u043d\u0434\u043e\u043c\u0430 : " + str(WPriceRnd[Grade]) + "<br><br>"
            if ItemEnchant < MaxEnchantWeapon :
              htmltext = htmltext + "<a action=\"bypass -h Quest 919_Enchanter plusone_" + str(intEvent) + u"\">\u0414\u043e\u0431\u0430\u0432\u0438\u0442\u044c +1 \u043a \u0437\u0430\u0442\u043e\u0447\u043a\u0435 \u043f\u0440\u0435\u0434\u043c\u0435\u0442\u0430</a><br>"
            if ItemEnchant + 10 <= MaxEnchantWeapon :
              htmltext = htmltext + "<a action=\"bypass -h Quest 919_Enchanter plusten_" + str(intEvent) + u"\">\u0414\u043e\u0431\u0430\u0432\u0438\u0442\u044c +10 \u043a \u0437\u0430\u0442\u043e\u0447\u043a\u0435 \u043f\u0440\u0435\u0434\u043c\u0435\u0442\u0430</a><br>"
            if ItemEnchant < MaxEnchantWeapon :
              htmltext = htmltext + "<a action=\"bypass -h Quest 919_Enchanter rnd_" + str(intEvent) + u"\">\u0418\u0441\u043f\u044b\u0442\u0430\u0442\u044c \u0443\u0434\u0430\u0447\u0443 \u0441\u043b\u0443\u0447\u0430\u0439\u043d\u043e\u0439 \u0437\u0430\u0442\u043e\u0447\u043a\u043e\u0439</a>"
        else :
          htmltext = htmltext + u"\u042d\u0442\u0443 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u043b\u044c\u0437\u044f"
      else :
        htmltext = htmltext + u"\u0412\u044b \u0441\u043d\u044f\u043b\u0438 \u0432\u0435\u0449\u044c \u043f\u043e\u043a\u0430 \u043d\u0430 \u043a\u043d\u043e\u043f\u043a\u0443 \u0436\u0430\u043b\u0438"
    elif strEvent.startsWith("plusone") :
      intEvent = Integer.parseInt(strEvent.substring(8))
      htmltext = "<html><title>Donate Shop</title><body><br><br><br><center>"
      Item1 = player.getInventory().getPaperdollItemByL2ItemId(getHexSlot(intEvent))
      if Item1 != None :
        if validateItem(Item1.getItemId()) :
          Grade = Item1.getItem().getCrystalType()
          if Grade not in [0] :
            ItemEnchant = Item1.getEnchantLevel()
            Itype = str(Item1.getItemType())
            if Itype in Jewel :
              if ItemEnchant < MaxEnchantJewel :
                iu = InventoryUpdate()
                player.sendPacket(iu)
                player.broadcastPacket(CharInfo(player))
                player.sendPacket(UserInfo(player))
                if st.getQuestItemsCount(Adena) >= JPrice[Grade]:
                  st.takeItems(Adena,JPrice[Grade])
                  Item1.setEnchantLevel(ItemEnchant+1)
		  ItemEnchant = Item1.getEnchantLevel()
                  st.playSound("ItemSound.quest_itemget")
                  player.sendPacket(ItemList(player,False))
                  htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0443\u0441\u043f\u0435\u0448\u043d\u043e \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043d\u0430 <font color=FF0000>+" + str(ItemEnchant) + "</font> !"
                else :
                  htmltext = htmltext + u"\u0423 \u0432\u0430\u0441 \u043d\u0435 \u0434\u043e\u0441\u0442\u0430\u0442\u043e\u0447\u043d\u043e \u0441\u0440\u0435\u0434\u0441\u0442\u0432 !"
              else :
                htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043c\u0430\u043a\u0441\u0438\u043c\u0443\u043c !"
            elif Itype in Armor :
              if ItemEnchant < MaxEnchantArmor :
                iu = InventoryUpdate()
                player.sendPacket(iu)
                player.broadcastPacket(CharInfo(player))
                player.sendPacket(UserInfo(player))
                if st.getQuestItemsCount(Adena) >= APrice[Grade]:
                  st.takeItems(Adena,APrice[Grade])
                  Item1.setEnchantLevel(ItemEnchant+1)
		  ItemEnchant = Item1.getEnchantLevel()
                  st.playSound("ItemSound.quest_itemget")
                  player.sendPacket(ItemList(player,False))
                  htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0443\u0441\u043f\u0435\u0448\u043d\u043e \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043d\u0430 <font color=FF0000>+" + str(ItemEnchant) + "</font> !"
                else :
                  htmltext = htmltext + u"\u0423 \u0432\u0430\u0441 \u043d\u0435 \u0434\u043e\u0441\u0442\u0430\u0442\u043e\u0447\u043d\u043e \u0441\u0440\u0435\u0434\u0441\u0442\u0432 !"
              else :
                htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043c\u0430\u043a\u0441\u0438\u043c\u0443\u043c !"
            elif Itype in Weapon :
              if ItemEnchant < MaxEnchantWeapon :
                iu = InventoryUpdate()
                player.sendPacket(iu)
                player.broadcastPacket(CharInfo(player))
                player.sendPacket(UserInfo(player))
                if st.getQuestItemsCount(Adena) >= WPrice[Grade]:
                  st.takeItems(Adena,WPrice[Grade])
                  Item1.setEnchantLevel(ItemEnchant+1)
		  ItemEnchant = Item1.getEnchantLevel()
                  st.playSound("ItemSound.quest_itemget")
                  player.sendPacket(ItemList(player,False))
                  htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0443\u0441\u043f\u0435\u0448\u043d\u043e \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043d\u0430 <font color=FF0000>+" + str(ItemEnchant) + "</font> !"
                else :
                  htmltext = htmltext + u"\u0423 \u0432\u0430\u0441 \u043d\u0435 \u0434\u043e\u0441\u0442\u0430\u0442\u043e\u0447\u043d\u043e \u0441\u0440\u0435\u0434\u0441\u0442\u0432 !"
              else :
                htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043c\u0430\u043a\u0441\u0438\u043c\u0443\u043c !"
            else :
              htmltext = htmltext + u"\u042f \u043d\u0435 \u043c\u043e\u0433\u0443 \u0437\u0430\u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u0438\u0437\u0432\u0435\u0441\u0442\u043d\u044b\u0439 \u043c\u043d\u0435 \u043f\u0440\u0435\u0434\u043c\u0435\u0442 !"
          else :
            htmltext = htmltext + u"<font color=LEVEL>[NG]</font> \u0432\u0435\u0449\u0438 \u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u043b\u044c\u0437\u044f !"
        else :
          htmltext = htmltext + u"\u042d\u0442\u0443 \u0432\u0435\u0449\u044c \u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u043b\u044c\u0437\u044f !"
      else :
        htmltext = htmltext + u"\u0412\u044b \u0441\u043d\u044f\u043b\u0438 \u0432\u0435\u0449\u044c \u0432\u043e \u0432\u0440\u0435\u043c\u044f \u0437\u0430\u0442\u043e\u0447\u043a\u0438 !"
    elif strEvent.startsWith("plusten") :
      intEvent = Integer.parseInt(strEvent.substring(8))
      htmltext = "<html><title>Donate Shop</title><body><br><br><br><center>"
      Item1 = player.getInventory().getPaperdollItemByL2ItemId(getHexSlot(intEvent))
      if Item1 != None :
        if validateItem(Item1.getItemId()) :
          Grade = Item1.getItem().getCrystalType()
          if Grade not in [0] :
            ItemEnchant = Item1.getEnchantLevel()
            Itype = str(Item1.getItemType())
            if Itype in Jewel :
              if ItemEnchant+10 < MaxEnchantJewel+1 :
                iu = InventoryUpdate()
                player.sendPacket(iu)
                player.broadcastPacket(CharInfo(player))
                player.sendPacket(UserInfo(player))
                if st.getQuestItemsCount(Adena) >= JPrice10[Grade]:
                  st.takeItems(Adena,JPrice10[Grade])
                  Item1.setEnchantLevel(ItemEnchant+10)
		  ItemEnchant = Item1.getEnchantLevel()
                  st.playSound("ItemSound.quest_itemget")
                  player.sendPacket(ItemList(player,False))
                  htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0443\u0441\u043f\u0435\u0448\u043d\u043e \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043d\u0430 <font color=FF0000>+" + str(ItemEnchant) + "</font> !"
                else :
                  htmltext = htmltext + u"\u0423 \u0432\u0430\u0441 \u043d\u0435 \u0434\u043e\u0441\u0442\u0430\u0442\u043e\u0447\u043d\u043e \u0441\u0440\u0435\u0434\u0441\u0442\u0432 !"
              else :
                htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043c\u0430\u043a\u0441\u0438\u043c\u0443\u043c !"
            elif Itype in Armor :
              if ItemEnchant+10 < MaxEnchantArmor+1 :
                iu = InventoryUpdate()
                player.sendPacket(iu)
                player.broadcastPacket(CharInfo(player))
                player.sendPacket(UserInfo(player))
                if st.getQuestItemsCount(Adena) >= APrice10[Grade]:
                  st.takeItems(Adena,APrice10[Grade])
                  Item1.setEnchantLevel(ItemEnchant+10)
		  ItemEnchant = Item1.getEnchantLevel()
                  st.playSound("ItemSound.quest_itemget")
                  player.sendPacket(ItemList(player,False))
                  htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0443\u0441\u043f\u0435\u0448\u043d\u043e \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043d\u0430 <font color=FF0000>+" + str(ItemEnchant) + "</font> !"
                else :
                  htmltext = htmltext + u"\u0423 \u0432\u0430\u0441 \u043d\u0435 \u0434\u043e\u0441\u0442\u0430\u0442\u043e\u0447\u043d\u043e \u0441\u0440\u0435\u0434\u0441\u0442\u0432 !"
              else :
                htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043c\u0430\u043a\u0441\u0438\u043c\u0443\u043c !"
            elif Itype in Weapon :
              if ItemEnchant+10 < MaxEnchantWeapon+1 :
                iu = InventoryUpdate()
                player.sendPacket(iu)
                player.broadcastPacket(CharInfo(player))
                player.sendPacket(UserInfo(player))
                if st.getQuestItemsCount(Adena) >= WPrice10[Grade]:
                  st.takeItems(Adena,WPrice10[Grade])
                  Item1.setEnchantLevel(ItemEnchant+10)
		  ItemEnchant = Item1.getEnchantLevel()
                  st.playSound("ItemSound.quest_itemget")
                  player.sendPacket(ItemList(player,False))
                  htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0443\u0441\u043f\u0435\u0448\u043d\u043e \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043d\u0430 <font color=FF0000>+" + str(ItemEnchant) + "</font> !"
                else :
                  htmltext = htmltext + u"\u0423 \u0432\u0430\u0441 \u043d\u0435 \u0434\u043e\u0441\u0442\u0430\u0442\u043e\u0447\u043d\u043e \u0441\u0440\u0435\u0434\u0441\u0442\u0432 !"
              else :
                htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043c\u0430\u043a\u0441\u0438\u043c\u0443\u043c !"
            else :
              htmltext = htmltext + u"\u042f \u043d\u0435 \u043c\u043e\u0433\u0443 \u0437\u0430\u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u0438\u0437\u0432\u0435\u0441\u0442\u043d\u044b\u0439 \u043c\u043d\u0435 \u043f\u0440\u0435\u0434\u043c\u0435\u0442 !"
          else :
            htmltext = htmltext + u"<font color=LEVEL>[NG]</font> \u0432\u0435\u0449\u0438 \u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u043b\u044c\u0437\u044f !"
        else :
          htmltext = htmltext + u"\u042d\u0442\u0443 \u0432\u0435\u0449\u044c \u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u043b\u044c\u0437\u044f !"
      else :
        htmltext = htmltext + u"\u0412\u044b \u0441\u043d\u044f\u043b\u0438 \u0432\u0435\u0449\u044c \u0432\u043e \u0432\u0440\u0435\u043c\u044f \u0437\u0430\u0442\u043e\u0447\u043a\u0438 !"
    elif strEvent.startsWith("rnd") :
      intEvent = Integer.parseInt(strEvent.substring(4))
      htmltext = "<html><title>Donate Shop</title><body><br><br><br><center>"
      Item1 = player.getInventory().getPaperdollItemByL2ItemId(getHexSlot(intEvent))
      if Item1 != None :
        if validateItem(Item1.getItemId()) :
          Grade = Item1.getItem().getCrystalType()
          if Grade not in [0] :
            ItemEnchant = Item1.getEnchantLevel()
            Itype = str(Item1.getItemType())
            if Itype in Jewel :
              if ItemEnchant < MaxEnchantJewel :
                iu = InventoryUpdate()
                player.sendPacket(iu)
                player.broadcastPacket(CharInfo(player))
                player.sendPacket(UserInfo(player))
                if st.getQuestItemsCount(Adena) >= JPriceRnd[Grade]:
                  ItemEnchant = Rnd.get(MaxEnchantJewel)
                  st.takeItems(Adena,JPriceRnd[Grade])
                  Item1.setEnchantLevel(ItemEnchant)
                  st.playSound("ItemSound.quest_itemget")
                  player.sendPacket(ItemList(player,False))
                  htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0443\u0441\u043f\u0435\u0448\u043d\u043e \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043d\u0430 <font color=FF0000>+" + str(ItemEnchant) + "</font> !"
                else :
                  htmltext = htmltext + u"\u0423 \u0432\u0430\u0441 \u043d\u0435 \u0434\u043e\u0441\u0442\u0430\u0442\u043e\u0447\u043d\u043e \u0441\u0440\u0435\u0434\u0441\u0442\u0432 !"
              else :
                htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043c\u0430\u043a\u0441\u0438\u043c\u0443\u043c !"
            elif Itype in Armor :
              if ItemEnchant < MaxEnchantArmor :
                iu = InventoryUpdate()
                player.sendPacket(iu)
                player.broadcastPacket(CharInfo(player))
                player.sendPacket(UserInfo(player))
                if st.getQuestItemsCount(Adena) >= APriceRnd[Grade]:
                  ItemEnchant = Rnd.get(MaxEnchantArmor)
                  st.takeItems(Adena,APriceRnd[Grade])
                  Item1.setEnchantLevel(ItemEnchant)
                  st.playSound("ItemSound.quest_itemget")
                  player.sendPacket(ItemList(player,False))
                  htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0443\u0441\u043f\u0435\u0448\u043d\u043e \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043d\u0430 <font color=FF0000>+" + str(ItemEnchant) + "</font> !"
                else :
                  htmltext = htmltext + u"\u0423 \u0432\u0430\u0441 \u043d\u0435 \u0434\u043e\u0441\u0442\u0430\u0442\u043e\u0447\u043d\u043e \u0441\u0440\u0435\u0434\u0441\u0442\u0432 !"
              else :
                htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043c\u0430\u043a\u0441\u0438\u043c\u0443\u043c !"
            elif Itype in Weapon :
              if ItemEnchant < MaxEnchantWeapon :
                iu = InventoryUpdate()
                player.sendPacket(iu)
                player.broadcastPacket(CharInfo(player))
                player.sendPacket(UserInfo(player))
                if st.getQuestItemsCount(Adena) >= WPriceRnd[Grade]:
                  ItemEnchant = Rnd.get(MaxEnchantWeapon)
                  st.takeItems(Adena,WPriceRnd[Grade])
                  Item1.setEnchantLevel(ItemEnchant)
                  st.playSound("ItemSound.quest_itemget")
                  player.sendPacket(ItemList(player,False))
                  htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0443\u0441\u043f\u0435\u0448\u043d\u043e \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043d\u0430 <font color=FF0000>+" + str(ItemEnchant) + "</font> !"
                else :
                  htmltext = htmltext + u"\u0423 \u0432\u0430\u0441 \u043d\u0435 \u0434\u043e\u0441\u0442\u0430\u0442\u043e\u0447\u043d\u043e \u0441\u0440\u0435\u0434\u0441\u0442\u0432 !"
              else :
                htmltext = htmltext + u"\u0412\u0430\u0448\u0430 \u0432\u0435\u0449\u044c \u0437\u0430\u0442\u043e\u0447\u0435\u043d\u0430 \u043c\u0430\u043a\u0441\u0438\u043c\u0443\u043c !"
            else :
              htmltext = htmltext + u"\u042f \u043d\u0435 \u043c\u043e\u0433\u0443 \u0437\u0430\u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u0438\u0437\u0432\u0435\u0441\u0442\u043d\u044b\u0439 \u043c\u043d\u0435 \u043f\u0440\u0435\u0434\u043c\u0435\u0442 !"
          else :
            htmltext = htmltext + u"<font color=LEVEL>[NG]</font> \u0432\u0435\u0449\u0438 \u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u043b\u044c\u0437\u044f !"
        else :
          htmltext = htmltext + u"\u042d\u0442\u0443 \u0432\u0435\u0449\u044c \u0442\u043e\u0447\u0438\u0442\u044c \u043d\u0435\u043b\u044c\u0437\u044f !"
      else :
        htmltext = htmltext + u"\u0412\u044b \u0441\u043d\u044f\u043b\u0438 \u0432\u0435\u0449\u044c \u0432\u043e \u0432\u0440\u0435\u043c\u044f \u0437\u0430\u0442\u043e\u0447\u043a\u0438 !"
    htmltext = htmltext + "</font></center></body></html>"
    return htmltext

QUEST    = Quest(919,Qn,"custom")

QUEST.addStartNpc(300300)
QUEST.addTalkId(300300)