package net.sf.l2j;

import javolution.text.TypeFormat;
import javolution.util.FastList;
import javolution.util.FastMap;
import net.sf.l2j.gameserver.model.actor.instance.L2PcInstance;
import net.sf.l2j.gameserver.util.StringUtil;
import net.sf.olympiad.OlympiadPeriod;

import java.io.*;
import java.math.BigInteger;
import java.util.*;
import java.util.logging.Logger;

/**
 * @update S-Project
 */
public final class Config
{
  protected static final Logger _log = Logger.getLogger(Config.class.getName());
	// Skill Duration - OPEN
	public static boolean	ENABLE_MODIFY_SKILL_DURATION;
	public static			Map<Integer, Integer> SKILL_DURATION_LIST;
	// Skill Duration - CLOSE
	public static int DUEL_SPAWN_X;
	public static int DUEL_SPAWN_Y;
	public static int DUEL_SPAWN_Z;
	public static int CLAN_MEMBER_LVLUP6;
	public static int CLAN_MEMBER_LVLUP7;
	public static int CLAN_MEMBER_LVLUP8;
	public static boolean DUEL_ALLOW;
	public static int REWARD_KILL_WAR;
	public static int BONUS_CLAN_SCORE_SIEGE;
	public static int CLAN_SCORE_SIEGE;
	public static int DAY_TO_SIEGE;
	public static boolean KICK_L2WALKER;
	public static boolean SHOW_NPC_LVL;
	public static long CS_TELE_FEE_RATIO;
	public static int CS_TELE1_FEE;
	public static int CS_TELE2_FEE;
	public static long CS_MPREG_FEE_RATIO;
	public static int CS_MPREG1_FEE;
	public static int CS_MPREG2_FEE;
	public static int CS_MPREG3_FEE;
	public static int CS_MPREG4_FEE;
	public static long CS_HPREG_FEE_RATIO;
	public static int CS_HPREG1_FEE;
	public static int CS_HPREG2_FEE;
	public static int CS_HPREG3_FEE;
	public static int CS_HPREG4_FEE;
	public static int CS_HPREG5_FEE;
	public static long CS_EXPREG_FEE_RATIO;
	public static int CS_EXPREG1_FEE;
	public static int CS_EXPREG2_FEE;
	public static int CS_EXPREG3_FEE;
	public static int CS_EXPREG4_FEE;
	public static long CS_SUPPORT_FEE_RATIO;
	public static int CS_SUPPORT1_FEE;
	public static int CS_SUPPORT2_FEE;
	public static int CS_SUPPORT3_FEE;
	public static int CS_SUPPORT4_FEE;
	public static boolean ONLINE_PLAYERS_AT_STARTUP;
	public static boolean CHAR_VIP_SKIP_SKILLS_CHECK;
	public static int LEVEL_CHAR_VIP_SKIP_SKILLS_CHECK;
	public static boolean CHAR_VIP_COLOR_ENABLED;
	public static int LEVEL_CHAR_VIP_COLOR_ENABLED;
	public static int CHAR_VIP_COLOR;
	public static int LEVEL_CHAR_VIP_COLOR;
	public static float CHAR_VIP_REWARD;
	public static int LEVEL_CHAR_VIP_REWARD;
	public static float CHAR_VIP_DROP_REWARD;
	public static int LEVEL_CHAR_VIP_DROP_REWARD;
	public static int LEVEL_CHAR_VIP_ANONS_LOGIN;
	public static boolean ALT_DIFF_MAGIC;
	public static int MAX_MULTISELL;
	public static int MAX_SUBCLASS;
    public static boolean RWHO_LOG;
	public static String RWHO_CLIENT;
    public static int RWHO_FORCE_INC;
    public static int RWHO_KEEP_STAT;
    public static int RWHO_MAX_ONLINE;
    public static boolean RWHO_SEND_TRASH;
    public static int RWHO_ONLINE_INCREMENT;
    public static float RWHO_PRIV_STORE_FACTOR;
    public static final int[] RWHO_ARRAY = new int[13];
	public static boolean EXPERTISE_PENALTY;
	public static int FS_TIME_ATTACK;
	public static int FS_TIME_COOLDOWN;
	public static int FS_TIME_ENTRY;
	public static int FS_TIME_WARMUP;
	public static int FS_PARTY_MEMBER_COUNT;
	public static byte LEVEL_ON_ENTER;
	public static int SP_ON_ENTER;
	public static float ALT_CRIT_DAMAGE;
	public static float BLOW_DAMAGE_HEAVY;
	public static float BLOW_DAMAGE_LIGHT;
	public static float BLOW_DAMAGE_ROBE;
	public static float ALT_MAGES_PHYSICAL_DAMAGE_MULTI;
	public static float ALT_MAGES_MAGICAL_DAMAGE_MULTI;
	public static float ALT_FIGHTERS_PHYSICAL_DAMAGE_MULTI;
	public static float ALT_FIGHTERS_MAGICAL_DAMAGE_MULTI;
	public static float ALT_PETS_PHYSICAL_DAMAGE_MULTI;
	public static float ALT_PETS_MAGICAL_DAMAGE_MULTI;
	public static float ALT_NPC_PHYSICAL_DAMAGE_MULTI;
	public static float ALT_NPC_MAGICAL_DAMAGE_MULTI;
	public static int SUBCLASS_PROTECT;
	public static boolean NOT_CONSUME_SHOTS;
	public static int MAX_MESSAGE_LENGHT;
	public static int ATTACK_STANCE_TASKS;
	public static int ALT_PCRITICAL_CAP;
	public static int ALT_MCRITICAL_CAP;
	public static int MAX_PATK_SPEED;
	public static int MAX_MATK_SPEED;
	public static boolean ALT_DROP_ADENA;
	public static String NON_CHECK_SKILLS;
	public static List<Integer> LIST_NON_CHECK_SKILLS = new FastList<Integer>();
	public static boolean CHECK_NOBLE_SKILLS;
	public static boolean CHECK_HERO_SKILLS;
	public static boolean NPC_ATTACKABLE;
	public static boolean pccafe_event;
	public static int pccafe_min_lvl;
	public static int pccafe_score_min;
	public static int pccafe_score_max;
	public static int pccafe_score_double;
	public static int pccafe_interval;
	public static List INVUL_NPC_LIST;
	public static boolean CHECK_SKILLS_ON_ENTER;
	public static int PVPPK_PROTECT;
	public static int PVP_ITEM_ID;
	public static int PVP_ITEM_COUNT;
	public static long PVP_EXP_COUNT;
	public static int PVP_SP_COUNT;
	public static int PVP_LEVEL_DIFFERENCE;
	public static int PK_ITEM_ID;
	public static int PK_ITEM_COUNT;
	public static long PK_EXP_COUNT;
	public static int PK_SP_COUNT;
	public static int PK_LEVEL_DIFFERENCE;
	public static boolean PVP_STRICT_IP;
	public static boolean PK_STRICT_IP;
    public static boolean DEBUG;
	public static String CLASS_MASTER_SETTINGS_LINE;
	public static boolean CLASS_MASTER_STRIDER_UPDATE;
	public static int STRIDER_LEVEL_FOR_UP;
	public static int PRICE_FOR_STRIDER;
	public static ClassMasterSettings CLASS_MASTER_SETTINGS;
	public static boolean CLASSMASTER_MSG;
	public static float BUFF_TIME_MULTIPLIER;
	public static float SPIRIT_TIME_MULTIPLIER;
	public static boolean VIEW_SKILL_CHANCE;
	public static int ALT_MINIMUM_FALL_HEIGHT;
	public static float DANCE_TIME_MULTIPLIER;
	public static int FRONT_CHANCE;
	public static int SIDE_CHANCE;
	public static int BEHIND_CHANCE;
	public static boolean LIMITED_ENTRY_CATACOMB;
	public static boolean LIMITED_ENTRY_NECRO;
    public static boolean ASSERT;
    public static boolean DEVELOPER;
    public static boolean TEST_SERVER;
    public static boolean ALT_DEV_NO_HTMLS;
    public static int PORT_GAME;
    public static int PORT_LOGIN;
    public static String LOGIN_BIND_ADDRESS;
    public static int LOGIN_TRY_BEFORE_BAN;
    public static int LOGIN_BLOCK_AFTER_BAN;
    public static String GAMESERVER_HOSTNAME;
    public static String DATABASE_DRIVER;
    public static String DATABASE_URL;
    public static String DATABASE_LOGIN;
    public static String DATABASE_PASSWORD;
    public static int DATABASE_MAX_CONNECTIONS;
    public static int   MAXIMUM_ONLINE_USERS;
    public static boolean SERVER_LIST_BRACKET;
    public static boolean SERVER_LIST_CLOCK;
    public static boolean SERVER_LIST_TESTSERVER;
    public static boolean SERVER_GMONLY;
    public static int THREAD_P_EFFECTS;
    public static int THREAD_P_GENERAL;
    public static int GENERAL_PACKET_THREAD_CORE_SIZE;
    public static int IO_PACKET_THREAD_CORE_SIZE;
    public static int GENERAL_THREAD_CORE_SIZE;
    public static int AI_MAX_THREAD;
    public static boolean AUTO_LOOT;
	public static boolean BOSS_AUTO_LOOT;
    public static boolean AUTO_LOOT_HERBS;
    public static String CNAME_TEMPLATE;
    public static String PET_NAME_TEMPLATE;
    public static int MAX_CHARACTERS_NUMBER_PER_ACCOUNT;
    public static String  DEFAULT_GLOBAL_CHAT;
    public static String  DEFAULT_TRADE_CHAT;
    public static boolean EVERYBODY_HAS_ADMIN_RIGHTS;
    public static boolean ALT_GAME_CREATION;
    public static double ALT_GAME_CREATION_SPEED;
    public static double ALT_GAME_CREATION_XP_RATE;
    public static double ALT_GAME_CREATION_SP_RATE;
    public static boolean ALT_BLACKSMITH_USE_RECIPES;
	public static boolean REMOVE_CASTLE_CIRCLETS;
    public static double ALT_WEIGHT_LIMIT;
    public static boolean ALT_GAME_SKILL_LEARN;
    public static boolean AUTO_LEARN_SKILLS;
    public static boolean ALT_GAME_CANCEL_BOW;
    public static boolean ALT_GAME_CANCEL_CAST;
    public static boolean ALT_GAME_TIREDNESS;
    public static int ALT_PARTY_RANGE;
    public static int ALT_PARTY_RANGE2;
    public static boolean ALT_GAME_SHIELD_BLOCKS;
    public static int ALT_PERFECT_SHLD_BLOCK;
    public static boolean ALT_GAME_MOB_ATTACK_AI;
    public static boolean ALT_MOB_AGRO_IN_PEACEZONE;
    public static boolean ALT_GAME_FREIGHTS;
    public static int ALT_GAME_FREIGHT_PRICE;
    public static float ALT_GAME_SKILL_HIT_RATE;
    public static boolean ALT_GAME_DELEVEL;
    public static boolean ALT_GAME_MAGICFAILURES;
    public static boolean ALT_GAME_REQUIRE_CASTLE_DAWN;
    public static boolean ALT_GAME_REQUIRE_CLAN_CASTLE;
    public static boolean ALT_GAME_FREE_TELEPORT;
    public static boolean ALT_RECOMMEND;
    public static boolean ALT_GAME_SUBCLASS_WITHOUT_QUESTS;
    public static boolean ALT_GAME_VIEWNPC;
    public static int ALT_FESTIVAL_MIN_PLAYER;
    public static int ALT_MAXIMUM_PLAYER_CONTRIB;
    public static long ALT_FESTIVAL_MANAGER_START;
    public static long ALT_FESTIVAL_LENGTH;
    public static long ALT_FESTIVAL_CYCLE_LENGTH;
    public static long ALT_FESTIVAL_FIRST_SPAWN;
    public static long ALT_FESTIVAL_FIRST_SWARM;
    public static long ALT_FESTIVAL_SECOND_SPAWN;
    public static long ALT_FESTIVAL_SECOND_SWARM;
    public static long ALT_FESTIVAL_CHEST_SPAWN;
    public static int ALT_CLAN_MEMBERS_FOR_WAR;
    public static int ALT_CLAN_JOIN_DAYS;
    public static int ALT_CLAN_CREATE_DAYS;
    public static int ALT_CLAN_DISSOLVE_DAYS;
    public static int ALT_ALLY_JOIN_DAYS_WHEN_LEAVED;
    public static int ALT_ALLY_JOIN_DAYS_WHEN_DISMISSED;
    public static int ALT_ACCEPT_CLAN_DAYS_WHEN_DISMISSED;
    public static int ALT_CREATE_ALLY_DAYS_WHEN_DISSOLVED;
    public static boolean ALT_MEMBERS_CAN_WITHDRAW_FROM_CLANWH;
    public static int ALT_MAX_NUM_OF_CLANS_IN_ALLY;
    public static boolean LIFE_CRYSTAL_NEEDED;
    public static boolean SP_BOOK_NEEDED;
    public static boolean ES_SP_BOOK_NEEDED;
    public static boolean LOG_CHAT;
    public static boolean LOG_ITEMS;
    public static boolean ALT_PRIVILEGES_ADMIN;
    public static boolean ALT_PRIVILEGES_SECURE_CHECK;
    public static int ALT_PRIVILEGES_DEFAULT_LEVEL;
    public static int ALT_MANOR_REFRESH_TIME;
    public static int ALT_MANOR_REFRESH_MIN;
    public static int ALT_MANOR_APPROVE_TIME;
    public static int ALT_MANOR_APPROVE_MIN;
    public static int ALT_MANOR_MAINTENANCE_PERIOD;
    public static boolean ALT_MANOR_SAVE_ALL_ACTIONS;
    public static int ALT_MANOR_SAVE_PERIOD_RATE;
    public static int ALT_LOTTERY_PRIZE;
    public static int ALT_LOTTERY_TICKET_PRICE;
    public static float ALT_LOTTERY_5_NUMBER_RATE;
    public static float ALT_LOTTERY_4_NUMBER_RATE;
    public static float ALT_LOTTERY_3_NUMBER_RATE;
    public static int ALT_LOTTERY_2_AND_1_NUMBER_PRIZE;
    public static int RIFT_MIN_PARTY_SIZE;
    public static int RIFT_SPAWN_DELAY;
    public static int RIFT_MAX_JUMPS;
    public static int RIFT_AUTO_JUMPS_TIME_MIN;
    public static int RIFT_AUTO_JUMPS_TIME_MAX;
    public static int RIFT_ENTER_COST_RECRUIT;
    public static int RIFT_ENTER_COST_SOLDIER;
    public static int RIFT_ENTER_COST_OFFICER;
    public static int RIFT_ENTER_COST_CAPTAIN;
    public static int RIFT_ENTER_COST_COMMANDER;
    public static int RIFT_ENTER_COST_HERO;
    public static float RIFT_BOSS_ROOM_TIME_MUTIPLY;
    public static int     GM_ACCESSLEVEL;
    public static int     GM_MIN;
    public static int     GM_ALTG_MIN_LEVEL;
    public static int     GM_ANNOUNCE;
    public static int     GM_BAN;
    public static int     GM_BAN_CHAT;
    public static int     GM_CREATE_ITEM;
    public static int     GM_DELETE;
    public static int     GM_KICK;
    public static int     GM_MENU;
    public static int     GM_GODMODE;
    public static int     GM_CHAR_EDIT;
    public static int     GM_CHAR_EDIT_OTHER;
    public static int     GM_CHAR_VIEW;
    public static int     GM_NPC_EDIT;
    public static int     GM_NPC_VIEW;
    public static int     GM_TELEPORT;
    public static int     GM_TELEPORT_OTHER;
    public static int     GM_RESTART;
    public static int     GM_MONSTERRACE;
    public static int     GM_RIDER;
    public static int     GM_ESCAPE;
    public static int     GM_FIXED;
    public static int     GM_CREATE_NODES;
    public static int     GM_ENCHANT;
    public static int     GM_DOOR;
    public static int     GM_RES;
    public static int     GM_PEACEATTACK;
    public static int     GM_HEAL;
    public static int     GM_UNBLOCK;
    public static int     GM_CACHE;
    public static int     GM_TALK_BLOCK;
    public static int     GM_TEST;
    public static boolean GM_DISABLE_TRANSACTION;
    public static int     GM_TRANSACTION_MIN;
    public static int     GM_TRANSACTION_MAX;
    public static int     GM_CAN_GIVE_DAMAGE;
    public static int     GM_DONT_TAKE_EXPSP;
    public static int     GM_DONT_TAKE_AGGRO;
    public static int GM_REPAIR = 75;
    public static float   RATE_XP;
    public static float   RATE_SP;
    public static float   RATE_PARTY_XP;
    public static float   RATE_PARTY_SP;
    public static float   RATE_QUESTS_REWARD;
    public static float   RATE_DROP_ADENA;
    public static float   RATE_CONSUMABLE_COST;
    public static float   RATE_DROP_ITEMS;
	public static float RATE_DROP_STONE;
	public static float RATE_DROP_ITEMS_BY_RAID;
	public static float RATE_DROP_ITEMS_BY_GRAND;
    public static float   RATE_DROP_SPOIL;
    public static int   RATE_DROP_MANOR;
    public static float   RATE_DROP_QUEST;
    public static float   RATE_KARMA_EXP_LOST;
    public static float   RATE_SIEGE_GUARDS_PRICE;
    public static float   ALT_GAME_EXPONENT_XP;
    public static float   ALT_GAME_EXPONENT_SP;
    public static float   RATE_DROP_COMMON_HERBS;
    public static float   RATE_DROP_MP_HP_HERBS;
    public static float   RATE_DROP_GREATER_HERBS;
    public static float   RATE_DROP_SUPERIOR_HERBS;
    public static float   RATE_DROP_SPECIAL_HERBS;
    public static int   PLAYER_DROP_LIMIT;
    public static int   PLAYER_RATE_DROP;
    public static int   PLAYER_RATE_DROP_ITEM;
    public static int   PLAYER_RATE_DROP_EQUIP;
    public static int   PLAYER_RATE_DROP_EQUIP_WEAPON;
    public static float         PET_XP_RATE;
    public static int           PET_FOOD_RATE;
    public static float         SINEATER_XP_RATE;
    public static int   KARMA_DROP_LIMIT;
    public static int   KARMA_RATE_DROP;
    public static int   KARMA_RATE_DROP_ITEM;
    public static int   KARMA_RATE_DROP_EQUIP;
    public static int   KARMA_RATE_DROP_EQUIP_WEAPON;
    public static int     AUTODESTROY_ITEM_AFTER;
    public static int     HERB_AUTO_DESTROY_TIME;
    public static String  PROTECTED_ITEMS;
    public static List<Integer> LIST_PROTECTED_ITEMS = new FastList<Integer>();
    public static boolean     DESTROY_DROPPED_PLAYER_ITEM;
    public static boolean     DESTROY_EQUIPABLE_PLAYER_ITEM;
    public static boolean     SAVE_DROPPED_ITEM;
    public static boolean     EMPTY_DROPPED_ITEM_TABLE_AFTER_LOAD;
    public static int         SAVE_DROPPED_ITEM_INTERVAL;
    public static boolean     CLEAR_DROPPED_ITEM_TABLE;
    public static boolean PRECISE_DROP_CALCULATION;
    public static boolean MULTIPLE_ITEM_DROP;
    public static int     DELETE_DAYS;
    public static File    DATAPACK_ROOT;
    public static int MAX_DRIFT_RANGE;
    public static boolean ALLOWFISHING;
    public static boolean ALLOW_MANOR;
    public static boolean JAIL_IS_PVP;
    public static boolean JAIL_DISABLE_CHAT;
    public static enum L2WalkerAllowed
    {
        True,
        False,
        GM
    }
    public static L2WalkerAllowed ALLOW_L2WALKER_CLIENT;
    public static boolean         AUTOBAN_L2WALKER_ACC;
    public static int             L2WALKER_REVISION;
    public static boolean         ALLOW_DISCARDITEM;
    public static boolean         ALLOW_FREIGHT;
    public static boolean         ALLOW_WAREHOUSE;
    public static boolean         WAREHOUSE_CACHE;
    public static int             WAREHOUSE_CACHE_TIME;
    public static boolean           ALLOW_WEAR;
    public static int               WEAR_DELAY;
    public static int               WEAR_PRICE;
    public static boolean           ALLOW_LOTTERY;
    public static boolean           ALLOW_RACE;
    public static boolean         ALLOW_RENTPET;
    public static boolean           ALLOW_BOAT;
    public static boolean           ALLOW_CURSED_WEAPONS;
    public static int WYVERN_SPEED;
    public static int STRIDER_SPEED;
    public static int MIN_PROTOCOL_REVISION;
    public static int MAX_PROTOCOL_REVISION;
    public static int MIN_NPC_ANIMATION;
    public static int MAX_NPC_ANIMATION;
    public static int MIN_MONSTER_ANIMATION;
    public static int MAX_MONSTER_ANIMATION;
    public static boolean ACTIVATE_POSITION_RECORDER;
    public static boolean USE_3D_MAP;
    public static String COMMUNITY_TYPE;
    public static String BBS_DEFAULT;
    public static boolean SHOW_LEVEL_COMMUNITYBOARD;
    public static boolean SHOW_STATUS_COMMUNITYBOARD;
    public static int     NAME_PAGE_SIZE_COMMUNITYBOARD;
    public static int     NAME_PER_ROW_COMMUNITYBOARD;
    public static int MAX_ITEM_IN_PACKET;
    public static boolean CHECK_KNOWN;
    public static int        GAME_SERVER_LOGIN_PORT;
    public static String     GAME_SERVER_LOGIN_HOST;
    public static String     INTERNAL_HOSTNAME;
    public static String     EXTERNAL_HOSTNAME;
    public static int        NEW_NODE_ID;
    public static int        SELECTED_NODE_ID;
    public static int        LINKED_NODE_ID;
    public static String     NEW_NODE_TYPE;
    public static boolean SERVER_NEWS;
    public static boolean    FORCE_INVENTORY_UPDATE;
    public static boolean    ALLOW_GUARDS;
    public static boolean    ALLOW_CLASS_MASTERS;
    public static int        IP_UPDATE_TIME;
    public static int ZONE_TOWN;
    public static boolean IS_CRAFTING_ENABLED;
    public static int INVENTORY_MAXIMUM_NO_DWARF;
    public static int INVENTORY_MAXIMUM_DWARF;
    public static int INVENTORY_MAXIMUM_GM;
    public static int WAREHOUSE_SLOTS_NO_DWARF;
    public static int WAREHOUSE_SLOTS_DWARF;
    public static int WAREHOUSE_SLOTS_CLAN;
    public static int FREIGHT_SLOTS;
    public static int     KARMA_MIN_KARMA;
    public static int     KARMA_MAX_KARMA;
    public static int     KARMA_XP_DIVIDER;
    public static int     KARMA_LOST_BASE;
    public static boolean KARMA_DROP_GM;
    public static boolean KARMA_AWARD_PK_KILL;
    public static int     KARMA_PK_LIMIT;
    public static String        KARMA_NONDROPPABLE_PET_ITEMS;
    public static String        KARMA_NONDROPPABLE_ITEMS;
    public static List<Integer> KARMA_LIST_NONDROPPABLE_PET_ITEMS   = new FastList<Integer>();
    public static List<Integer> KARMA_LIST_NONDROPPABLE_ITEMS       = new FastList<Integer>();
    public static String        NONDROPPABLE_ITEMS;
    public static List<Integer> LIST_NONDROPPABLE_ITEMS       = new FastList<Integer>();
    public static String        PET_RENT_NPC;
    public static List<Integer> LIST_PET_RENT_NPC   = new FastList<Integer>();
    public static int PVP_NORMAL_TIME;
    public static int PVP_PVP_TIME;
    public static boolean ALT_GAME_KARMA_PLAYER_CAN_BE_KILLED_IN_PEACEZONE;
    public static boolean ALT_GAME_KARMA_PLAYER_CAN_SHOP;
    public static boolean ALT_GAME_KARMA_PLAYER_CAN_USE_GK;
    public static boolean ALT_GAME_KARMA_PLAYER_CAN_TELEPORT;
    public static boolean ALT_GAME_KARMA_PLAYER_CAN_TRADE;
    public static boolean ALT_GAME_KARMA_PLAYER_CAN_USE_WAREHOUSE;
	
    public static boolean L2JMOD_ALLOW_WEDDING;
    public static int L2JMOD_WEDDING_PRICE;
    public static boolean L2JMOD_WEDDING_PUNISH_INFIDELITY;
    public static boolean L2JMOD_WEDDING_TELEPORT;
    public static int L2JMOD_WEDDING_TELEPORT_PRICE;
    public static int L2JMOD_WEDDING_TELEPORT_DURATION;
    public static boolean L2JMOD_WEDDING_SAMESEX;
    public static boolean L2JMOD_WEDDING_FORMALWEAR;
    public static int L2JMOD_WEDDING_DIVORCE_COSTS;
	public static boolean COLOR_WEDDING_NAME;
	public static int COLOR_WEDDING_NAMES;
	public static int COLOR_WEDDING_NAMES_GEY;
	public static int COLOR_WEDDING_NAMES_LIZ;
	public static boolean	BANKING_SYSTEM_ENABLED;
	public static int		BANKING_SYSTEM_GOLDBARS;
	public static int		BANKING_SYSTEM_ADENA;
	public static int		BANKING_SYSTEM_ITEM;
    public static enum IdFactoryType
    {
        Compaction,
        BitSet,
        Stack
    }
    public static IdFactoryType IDFACTORY_TYPE;
    public static boolean BAD_ID_CHECKING;
    public static enum ObjectMapType
    {
        L2ObjectHashMap,
        WorldObjectMap
    }
    public static enum ObjectSetType
    {
        L2ObjectHashSet,
        WorldObjectSet
    }
    public static ObjectMapType   MAP_TYPE;
    public static ObjectSetType   SET_TYPE;
    public static boolean EFFECT_CANCELING;
    public static boolean AUTODELETE_INVALID_QUEST_DATA;
	public static boolean ENABLE_MODIFY_ENCHANT_CHANCE_WEAPON;
	public static Map<Integer, Integer> ENCHANT_CHANCE_LIST_WEAPON;
	public static boolean ENABLE_MODIFY_ENCHANT_CHANCE_ARMOR;
	public static Map<Integer, Integer> ENCHANT_CHANCE_LIST_ARMOR;
	public static boolean ENABLE_MODIFY_ENCHANT_CHANCE_JEWELRY;
	public static Map<Integer, Integer> ENCHANT_CHANCE_LIST_JEWELRY;
	public static boolean ENABLE_MODIFY_ENCHANT_MULTISELL;
	public static Map<Integer, Integer> ENCHANT_MULTISELL_LIST;
	public static int ENCHANT_CHANCE_WEAPON;
	public static int ENCHANT_CHANCE_ARMOR;
	public static int ENCHANT_CHANCE_JEWELRY;
	public static int ENCHANT_CHANCE_WEAPON_1015;
	public static int ENCHANT_CHANCE_ARMOR_1015;
	public static int ENCHANT_CHANCE_JEWELRY_1015;
	public static int ENCHANT_CHANCE_WEAPON_16;
	public static int ENCHANT_CHANCE_ARMOR_16;
	public static int ENCHANT_CHANCE_JEWELRY_16;
	public static int BLESSED_CHANCE_WEAPON;
	public static int BLESSED_CHANCE_ARMOR;
	public static int BLESSED_CHANCE_JEWELRY;
	public static int BLESSED_CHANCE_WEAPON_1015;
	public static int BLESSED_CHANCE_ARMOR_1015;
	public static int BLESSED_CHANCE_JEWELRY_1015;
	public static int BLESSED_CHANCE_WEAPON_16;
	public static int BLESSED_CHANCE_ARMOR_16;
	public static int BLESSED_CHANCE_JEWELRY_16;
	public static int CRYSTAL_CHANCE_WEAPON;
	public static int CRYSTAL_CHANCE_ARMOR;
	public static int CRYSTAL_CHANCE_JEWELRY;
	public static int CRYSTAL_CHANCE_WEAPON_1015;
	public static int CRYSTAL_CHANCE_ARMOR_1015;
	public static int CRYSTAL_CHANCE_JEWELRY_1015;
	public static int CRYSTAL_CHANCE_WEAPON_16;
	public static int CRYSTAL_CHANCE_ARMOR_16;
	public static int CRYSTAL_CHANCE_JEWELRY_16;
	public static int ENCHANT_MAX_WEAPON;
	public static int ENCHANT_MAX_ARMOR;
	public static int ENCHANT_MAX_JEWELRY;
	public static int ENCHANT_SAFE_MAX;
	public static int ENCHANT_SAFE_MAX_FULL;
	public static int ENCHANT_BREAK;
    public static double  HP_REGEN_MULTIPLIER;
    public static double  MP_REGEN_MULTIPLIER;
    public static double  CP_REGEN_MULTIPLIER;
    public static double   RAID_HP_REGEN_MULTIPLIER;
    public static double   RAID_MP_REGEN_MULTIPLIER;
    public static double   RAID_DEFENCE_MULTIPLIER;
    public static double   RAID_MINION_RESPAWN_TIMER;
    public static float   RAID_MIN_RESPAWN_MULTIPLIER;
    public static float   RAID_MAX_RESPAWN_MULTIPLIER;
    public static int STARTING_ADENA;
    public static boolean NUM_JVM1;
    public static boolean DEEPBLUE_DROP_RULES;
    public static int     UNSTUCK_INTERVAL;
    public static boolean IS_TELNET_ENABLED;
    public static int   DEATH_PENALTY_CHANCE;
    public static int   PLAYER_SPAWN_PROTECTION;
    public static int   PLAYER_FAKEDEATH_UP_PROTECTION;
    public static String  PARTY_XP_CUTOFF_METHOD;
    public static int PARTY_XP_CUTOFF_LEVEL;
    public static double  PARTY_XP_CUTOFF_PERCENT;
    public static double  RESPAWN_RESTORE_CP;
    public static double  RESPAWN_RESTORE_HP;
    public static double  RESPAWN_RESTORE_MP;
    public static boolean RESPAWN_RANDOM_ENABLED;
    public static int RESPAWN_RANDOM_MAX_OFFSET;
    public static int  MAX_PVTSTORE_SLOTS_DWARF;
    public static int  MAX_PVTSTORE_SLOTS_OTHER;
    public static boolean STORE_SKILL_COOLTIME;
    public static boolean SHOW_LICENCE;
    public static int DEFAULT_PUNISH;
    public static int DEFAULT_PUNISH_PARAM;
    public static boolean ACCEPT_NEW_GAMESERVER;
    public static int SERVER_ID;
    public static byte[] HEX_ID;
    public static boolean ACCEPT_ALTERNATE_ID;
    public static int REQUEST_ID;
    public static boolean RESERVE_HOST_ON_LOGIN = false;
    public static boolean LAZY_CACHE;
    public static boolean GM_HERO_AURA;
    public static boolean GM_STARTUP_INVULNERABLE;
    public static boolean GM_STARTUP_INVISIBLE;
    public static boolean GM_STARTUP_SILENCE;
    public static boolean GM_STARTUP_AUTO_LIST;
    public static String GM_ADMIN_MENU_STYLE;
    public static boolean PETITIONING_ALLOWED;
    public static int     MAX_PETITIONS_PER_PLAYER;
    public static int     MAX_PETITIONS_PENDING;
    public static boolean BYPASS_VALIDATION;
    public static boolean ONLY_GM_ITEMS_FREE;
    public static boolean GMAUDIT;
    public static boolean AUTO_CREATE_ACCOUNTS;
	public static boolean ENABLE_PACKET_PROTECTION;
	public static int MAX_UNKNOWN_PACKETS;
	public static int UNKNOWN_PACKETS_PUNISHMENT;
    public static int     FAST_CONNECTION_LIMIT;
    public static int     NORMAL_CONNECTION_TIME;
    public static int     FAST_CONNECTION_TIME;
    public static int     MAX_CONNECTION_PER_IP;
    public static boolean GAMEGUARD_ENFORCE;
    public static boolean GAMEGUARD_PROHIBITACTION;
    public static int DWARF_RECIPE_LIMIT;
    public static int COMMON_RECIPE_LIMIT;
    public static boolean GRIDS_ALWAYS_ON;
    public static int GRID_NEIGHBOR_TURNON_TIME;
    public static int GRID_NEIGHBOR_TURNOFF_TIME;
    public static String HTML_CACHE_FILE;
	public static int CH_RATE;
    public static long CH_TELE_FEE_RATIO;
    public static int CH_TELE1_FEE;
    public static int CH_TELE2_FEE;
    public static long CH_ITEM_FEE_RATIO;
    public static int CH_ITEM1_FEE;
    public static int CH_ITEM2_FEE;
    public static int CH_ITEM3_FEE;
    public static long CH_MPREG_FEE_RATIO;
    public static int CH_MPREG1_FEE;
    public static int CH_MPREG2_FEE;
    public static int CH_MPREG3_FEE;
    public static int CH_MPREG4_FEE;
    public static int CH_MPREG5_FEE;
    public static long CH_HPREG_FEE_RATIO;
    public static int CH_HPREG1_FEE;
    public static int CH_HPREG2_FEE;
    public static int CH_HPREG3_FEE;
    public static int CH_HPREG4_FEE;
    public static int CH_HPREG5_FEE;
    public static int CH_HPREG6_FEE;
    public static int CH_HPREG7_FEE;
    public static int CH_HPREG8_FEE;
    public static int CH_HPREG9_FEE;
    public static int CH_HPREG10_FEE;
    public static int CH_HPREG11_FEE;
    public static int CH_HPREG12_FEE;
    public static int CH_HPREG13_FEE;
    public static long CH_EXPREG_FEE_RATIO;
    public static int CH_EXPREG1_FEE;
    public static int CH_EXPREG2_FEE;
    public static int CH_EXPREG3_FEE;
    public static int CH_EXPREG4_FEE;
    public static int CH_EXPREG5_FEE;
    public static int CH_EXPREG6_FEE;
    public static int CH_EXPREG7_FEE;
    public static long CH_SUPPORT_FEE_RATIO;
    public static int CH_SUPPORT1_FEE;
    public static int CH_SUPPORT2_FEE;
    public static int CH_SUPPORT3_FEE;
    public static int CH_SUPPORT4_FEE;
    public static int CH_SUPPORT5_FEE;
    public static int CH_SUPPORT6_FEE;
    public static int CH_SUPPORT7_FEE;
    public static int CH_SUPPORT8_FEE;
    public static long CH_CURTAIN_FEE_RATIO;
    public static int CH_CURTAIN1_FEE;
    public static int CH_CURTAIN2_FEE;
    public static long CH_FRONT_FEE_RATIO;
    public static int CH_FRONT1_FEE;
    public static int CH_FRONT2_FEE;
    public static byte BUFFS_MAX_AMOUNT;
    public static boolean ALT_DEV_NO_AI;
    //__________________________________________________
    //Protected
    public static boolean IPTABLES;
    public static String IPTABLES_URL;
    public static boolean BOT_PROTECTOR;
	public static int BOT_PROTECTOR_FIRST_CHECK;
	public static int BOT_PROTECTOR_NEXT_CHECK;
	public static int BOT_PROTECTOR_WAIT_ANSVER;
    public static boolean ALLOW_DUALBOX;
	public static int ALLOWED_BOXES;
	public static boolean ALLOW_DUALBOX_OLY;
	public static boolean ALLOW_DUALBOX_EVENT;
    public static ArrayList<String> QUESTION_LIST = new ArrayList<String>();
    //CrazyEvent
    public static boolean Announce_CrazyEvent;
    public static int Enchant_Chance_CrazyEvent;
    public static int Duration_CrazyEvent;
    public static int Delay_Start_CrazyEvent;
    public static int Return_Time_CrazyEvent;
    public static byte Allow_EnebleTime_CrazyEvent;
    public static byte Allow_EnebleMinutes_CrazyEvent;
    //Network
    public static String NETWORK_IP_LIST;
    //AllowClassMaster
    public static boolean ALLOW_REMOTE_CLASS_MASTERS;
    //CustomItem
    public static boolean NOBLE_CUSTOM_ITEMS;
	public static boolean HERO_CUSTOM_ITEMS;
    public static int HERO_CUSTOM_ITEM_ID;
	public static int NOOBLE_CUSTOM_ITEM_ID;
	public static int HERO_CUSTOM_DAY;
    //Skills
    public static boolean ALLOW_HERO_SUBSKILL;
    public static int HERO_COUNT;
    //newCharacter loc
    public static boolean SPAWN_CHAR;
    public static int SPAWN_X;
    public static int SPAWN_Y;
    public static int SPAWN_Z;
    //Geodata S-Project
    public static int GEODATA;
    public static boolean FORCE_GEODATA;
    public static boolean ALLOW_WATER;
    public static int  COORD_SYNCHRONIZE;
    public static boolean MOVE_BASED_KNOWNLIST;
    public static long KNOWNLIST_UPDATE_INTERVAL;
	public static boolean ACCEPT_GEOEDITOR_CONN;
    //other
    public static boolean FLYING_WYVERN_DURING_SIEGE;
    //Olympiad augment weapon
    public static boolean ALT_ALLOW_AUGMENT_ON_OLYMP;
    //l2top fake online
    public static String    SAVE_FILE_ROOT;
	public static boolean   SAVE_ONLINE;
	public static int       FAKE_ONLINE;
	public static int       ONLINE_PLAYERS_ANNOUNCE_INTERVAL;
    // свечения под чемпионами
    public static int Champion_Swet;
    //удалять баффы от актив\пассив лс при смене или снятии пухи?
    public static boolean DELETE_AUGM_PASSIVE_ON_CHANGE;
	public static boolean DELETE_AUGM_ACTIVE_ON_CHANGE;
    // телепорт в круму
    public static int CRUMA_TOWER_LEVEL_RESTRICT;
    // разговарить с нпс если вы мертвы, используете фейк деат, либо сидите
    public static boolean ALLOW_TALK_WHILE_SITTING;
    //New flood protected
	public static int FLOODPROTECTOR_INITIALSIZE;
	public static int PROTECTED_BYPASS_C;
	public static int PROTECTED_HEROVOICE_C;
	public static int PROTECTED_MULTISELL_C;
	public static int PROTECTED_SUBCLASS_C;
	public static int GLOBAL_CHAT_DELAY;
	public static int PROTECTED_DROP_C;
	public static int PROTECTED_ENCHANT_C;
	public static int PROTECTED_UseCommand;
	public static int PROTECTED_WEREHOUSE_C;
	public static int PROTECTED_USE_ITEM_C;
    public static boolean FLOOD_PROTECTION;
    // Tank cannot use bow
    public static boolean ALT_DISABLE_BOW_CLASSES;
    public static String DISABLE_BOW_CLASSES_STRING;
    public static FastList<Integer> DISABLE_BOW_CLASSES = new FastList<Integer>();
    //protected restart
    public static boolean       SAFE_REBOOT;
    public static int           SAFE_REBOOT_TIME = 10;
    public static boolean       SAFE_REBOOT_DISABLE_ENCHANT;
	public static boolean       SAFE_REBOOT_DISABLE_TELEPORT;
	public static boolean       SAFE_REBOOT_DISABLE_CREATEITEM;
	public static boolean       SAFE_REBOOT_DISABLE_TRANSACTION;
	public static boolean       SAFE_REBOOT_DISABLE_PC_ITERACTION;
	public static boolean       SAFE_REBOOT_DISABLE_NPC_ITERACTION;
    //protected or html error
    public static boolean       BLOCK_BAD_HTML_LINK;
    //teleport to siege town
    public static boolean ALLOW_TELE_IN_SIEGE_TOWN;
    //buffer in java
    public static int		NPCBUFFER_MAX_SCHEMES;
    public static int		NPCBUFFER_MAX_SKILLS;
    public static boolean	NPCBUFFER_STORE_SCHEMES;
    public static List<String> BUFFER_PROTECTION = new FastList<String>();
    //html директория
    public static String HTML_DIR;
    //craftmanager
    public static double		ALT_CRAFT_PRICE;
	public static int			ALT_CRAFT_DEFAULT_PRICE;
	public static boolean		ALT_CRAFT_ALLOW_CRAFT;
	public static boolean		ALT_CRAFT_ALLOW_CRYSTALLIZE;
	public static boolean		ALT_CRAFT_ALLOW_COMMON;
    // употреблять стрелы при атаке с лука
    public static boolean DONT_DESTROY_ARROWS;
    //бафф при смерти
    public static boolean Buff_On_Death;
    //servername
    public static boolean ALT_Server_Name_Enabled;
    public static String ALT_Server_Name;
    //приз за взятие клана
    public static int Owned_Item_Id;
    public static int Owned_Item_Count;
    //load manager frintezza
     public static boolean Loaded_Frintezza;
    //поддержка из ядра на заточки в одну ячейку
    public static boolean Enchant_Stacktable;
    //update raidboss status to db?
    public static boolean  FORCE_UPDATE_RAIDBOSS_ON_DB;
    //announce spawn\death raidboss

    //nickname GM or announce
    public static boolean GM_DISPLAY_NAME;
    //curse lvl,raidboss
    public static boolean RAID_DISABLE_CURSE;
    //heal rb\gb
    public static boolean PLAYERS_CAN_HEAL_RB;
    //active skill on augment from reuse time
    public static int ACTIVE_AUGMENTS_START_REUSE_TIME;
    //other developer config
    public static boolean ENABLE_ALL_EXCEPTIONS = true;
    //Event DM
    public static boolean DM_ALLOW_INTERFERENCE;
	public static boolean DM_ALLOW_POTIONS;
	public static boolean DM_ALLOW_SUMMON;
	public static boolean DM_JOIN_CURSED;
	public static boolean DM_ON_START_REMOVE_ALL_EFFECTS;
	public static boolean DM_ON_START_UNSUMMON_PET;
	public static long DM_REVIVE_DELAY;
	public static boolean DM_COMMAND;
	public static boolean DM_ENABLE_KILL_REWARD;
	public static int DM_KILL_REWARD_ID;
	public static int DM_KILL_REWARD_AMOUNT;
	public static boolean DM_ANNOUNCE_REWARD;
	public static boolean DM_REVIVE_RECOVERY;
	public static int DM_SPAWN_OFFSET;
	public static boolean DM_STATS_LOGGER;
	public static boolean DM_ALLOW_HEALER_CLASSES;
	public static boolean DM_REMOVE_BUFFS_ON_DIE;
    //Event CTF
    public static String CTF_EVEN_TEAMS;
	public static boolean CTF_ALLOW_INTERFERENCE;
	public static boolean CTF_ALLOW_POTIONS;
	public static boolean CTF_ALLOW_SUMMON;
	public static boolean CTF_ON_START_REMOVE_ALL_EFFECTS;
	public static boolean CTF_ON_START_UNSUMMON_PET;
	public static boolean CTF_ANNOUNCE_TEAM_STATS;
	public static boolean CTF_ANNOUNCE_REWARD;
	public static boolean CTF_JOIN_CURSED;
	public static boolean CTF_REVIVE_RECOVERY;
	public static boolean CTF_COMMAND;
	public static boolean CTF_AURA;
	public static boolean CTF_STATS_LOGGER;
	public static int CTF_SPAWN_OFFSET;
    //Event TvT
    public static String TVT_EVEN_TEAMS;
	public static boolean TVT_ALLOW_INTERFERENCE;
	public static boolean TVT_ALLOW_POTIONS;
	public static boolean TVT_ALLOW_SUMMON;
	public static boolean TVT_ON_START_REMOVE_ALL_EFFECTS;
	public static boolean TVT_ON_START_UNSUMMON_PET;
	public static boolean TVT_REVIVE_RECOVERY;
	public static boolean TVT_ANNOUNCE_TEAM_STATS;
	public static boolean TVT_ANNOUNCE_REWARD;
	public static boolean TVT_PRICE_NO_KILLS;
	public static boolean TVT_JOIN_CURSED;
	public static boolean TVT_COMMAND;
	public static long TVT_REVIVE_DELAY;
	public static boolean TVT_OPEN_FORT_DOORS;
	public static boolean TVT_CLOSE_FORT_DOORS;
	public static boolean TVT_OPEN_ADEN_COLOSSEUM_DOORS;
	public static boolean TVT_CLOSE_ADEN_COLOSSEUM_DOORS;
	public static int TVT_TOP_KILLER_REWARD;
	public static int TVT_TOP_KILLER_QTY;
	public static boolean TVT_AURA;
	public static boolean TVT_STATS_LOGGER;
    //Olympiad
    public static int ALT_OLY_START_TIME;
	public static int ALT_OLY_MIN;
	public static long ALT_OLY_CPERIOD;
	public static long ALT_OLY_BATTLE;
	public static long ALT_OLY_BWAIT;
	public static long ALT_OLY_IWAIT;
	public static long ALT_OLY_WPERIOD;
	public static long ALT_OLY_VPERIOD;
	public static int ALT_OLY_CLASSED;
	public static int ALT_OLY_NONCLASSED;
	public static int ALT_OLY_BATTLE_REWARD_ITEM;
	public static int ALT_OLY_CLASSED_RITEM_C;
	public static int ALT_OLY_NONCLASSED_RITEM_C;
	public static int ALT_OLY_COMP_RITEM;
	public static int ALT_OLY_GP_PER_POINT;
	public static int ALT_OLY_MIN_POINT_FOR_EXCH;
	public static int ALT_OLY_HERO_POINTS;
	public static String ALT_OLY_RESTRICTED_ITEMS;
	public static List<Integer> LIST_OLY_RESTRICTED_ITEMS = new FastList<Integer>();
	public static OlympiadPeriod ALT_OLY_PERIOD;
	public static int ALT_OLY_PERIOD_MULTIPLIER;
	public static boolean ALLOW_EVENTS_DURING_OLY;
    public static boolean ALT_OLY_RECHARGE_SKILLS;
    //offline trade
    public static boolean OFFLINE_TRADE_ENABLE;
	public static boolean OFFLINE_CRAFT_ENABLE;
	public static boolean OFFLINE_SET_NAME_COLOR;
	public static int OFFLINE_NAME_COLOR;
	public static boolean RESTORE_OFFLINERS;
	public static int OFFLINE_MAX_DAYS;
	public static boolean OFFLINE_DISCONNECT_FINISHED;
    //voiced command
    public static boolean ALLOW_EXP_GAIN_COMMAND;
    public static boolean ALLOW_ONLINE;
    public static boolean ALLOW_IpBlock;
    public static boolean ALLOW_PLAYERS_REFUSAL;
    public static boolean ALLOW_TRADEOFF_COMMAND;
    //GrandBossManager
    public static boolean Sailren_Load;
    public static boolean Core_Load;
    public static boolean Zaken_Load;
    public static boolean Orfen_Load;
    public static boolean QueentAnt_Load;
    public static boolean Baium_Load;
    public static boolean Antharas_Load;
    public static boolean Valakas_Load;
    public static boolean Frintezza_Load;
    public static boolean VanHalter_Load;
        //config grandbosses
    public static int Interval_Of_Frintezza_Spawn;
    public static int Random_Of_Frintezza_Spawn;
    public static int Interval_Of_Sailren_Spawn;
    public static int Random_Of_Sailren_Spawn;
    public static int LIT_REGISTRATION_MODE;
    public static int LIT_REGISTRATION_TIME;
    public static int LIT_MIN_PARTY_CNT;
    public static int LIT_MAX_PARTY_CNT;
    public static int LIT_MIN_PLAYER_CNT;
    public static int LIT_MAX_PLAYER_CNT;
    public static int LIT_TIME_LIMIT;
    public static int LIT_FIXINTERVALOFFRINTEZZA;
    public static int LIT_RANDOMINTERVALOFFRINTEZZA;
    public static int LIT_APPTIMEOFFRINTEZZA;
    public static int LIT_ACTIVITYTIMEOFFRINTEZZA;
    public static int Antharas_Wait_Time;
    public static int Valakas_Wait_Time;
    public static int Interval_Of_Antharas_Spawn;
    public static int Random_Of_Antharas_Spawn;
    public static int Interval_Of_Valakas_Spawn;
    public static int Random_Of_Valakas_Spawn;
    public static int Interval_Of_Baium_Spawn;
    public static int Random_Of_Baium_Spawn;
    public static int Interval_Of_Core_Spawn;
    public static int Random_Of_Core_Spawn;
    public static int Interval_Of_Orfen_Spawn;
    public static int Random_Of_Orfen_Spawn;
    public static int Interval_Of_QueenAnt_Spawn;
    public static int Random_Of_QueenAnt_Spawn;
    public static int Interval_Of_Zaken_Spawn;
    public static int Random_Of_Zaken_Spawn;
    public static int HPH_FIXINTERVALOFHALTER;
    public static int HPH_RANDOMINTERVALOFHALTER;
    public static int HPH_APPTIMEOFHALTER;
    public static int HPH_ACTIVITYTIMEOFHALTER;
    public static int HPH_FIGHTTIMEOFHALTER;
    public static int HPH_CALLROYALGUARDHELPERCOUNT;
    public static int HPH_CALLROYALGUARDHELPERINTERVAL;
    public static int HPH_INTERVALOFDOOROFALTER;
    public static int HPH_TIMEOFLOCKUPDOOROFALTAR;
    //Event TownWar
    public static int TW_TOWN_ID;
	public static boolean TW_ALL_TOWNS;
	public static int TW_ITEM_ID;
	public static int TW_ITEM_AMOUNT;
	public static boolean TW_ALLOW_KARMA;
	public static boolean TW_DISABLE_GK;
	public static boolean TW_RESS_ON_DIE;
    //announce
    public static boolean ANNOUNCE_CASTLE_LORDS;
    public static Boolean CHAR_HERO_ANONS_LOGIN;
    public static boolean ANNOUNCE_PVP_KILL;
    public static boolean ANNOUNCE_PK_KILL;
    public static boolean ANNOUNCE_ALL_KILL;
    public static boolean ANNOUNCE_TRY_BANNED_ACCOUNT;
    //public static boolean ANNOUNCE_TRY_BANNED_CHAT;
    public static boolean ANNOUNCE_MAMMON_SPAWN;
    public static boolean ANNOUNCE_JAIL_CHAR;
    public static boolean ANNOUNCE_WEDDING;
    public static boolean CHAR_VIP_ANONS_LOGIN;
    public static boolean ANNOUNCE_RB_ON_DEAD;
    public static boolean ANNOUNCE_RB_ON_SPAWN;
    //nobleisstart
    public static boolean Allow_Noble_Is_Start;
    //new character item
    public static boolean STARTING_CUSTOM_ITEMS;
    public static List<int[]> STARTING_CUSTOM_ITEMS_F = new FastList<int[]>();
    public static List<int[]> STARTING_CUSTOM_ITEMS_M = new FastList<int[]>();
    //manapotion
    public static int MANA_POTION_RES;
    //blockbuff
    public static int ID_BLOCK_BUFF;
    //premium enchant chance bonus
    public static boolean PREMIUM_ENCH_BONUS;
    public static int PREMIUM_ENCH_CHANCE_BONUS;
    //spower
    public static boolean ENABLE_ITEM_SERVICE;
	public static int DELEVEL_MIN_LEVEL;
	public static int DELEVEL_ITEM_ID;
	public static int DELEVEL_ITEM_COUNT;
	public static int COLOR_ITEM_ID;
	public static int COLOR_ITEM_COUNT;
	public static int NOOBL_ITEM_ID;
	public static int NOOBL_ITEM_COUNT;
	public static int RENAME_ITEM_ID;
	public static int RENAME_ITEM_COUNT;
    //premium
    public static int PREMIUM_PRICE_ITEM_ID;
	public static int PREMIUM_PRICE_ITEM_COUNT;
    public static boolean USE_PREMIUMSERVICE;
    public static float PREMIUM_RATE_XP;
    public static float PREMIUM_RATE_SP;
	public static float PREMIUM_RATE_DROP_ADENA;
    public static float PREMIUM_RATE_DROP_SPOIL;
    public static float PREMIUM_RATE_DROP_ITEMS;
    public static float PREMIUM_RATE_DROP_QUEST;
    public static float PREMIUM_RATE_DROP_ITEMS_BY_RAID;
	public static int PREMIUM_NICK_COLOR;
	public static int PREMIUM_TITLE_COLOR;
    //auto restart server
    public static int AutoRestartAt;
    //other
    public static int MAX_PARTY_MEMBERS;
    //__________________________________________________
	public static final String CONFIGURATION_FILE = "./Config/GameServer.ini";
	public static final String PREM_FILE = "./Config/PremiumService.ini";
	public static final String OPTIONS_FILE = "./Config/Options.ini";
	public static final String LOGIN_CONFIGURATION_FILE = "./Config/LoginServer.ini";
	public static final String ID_CONFIG_FILE = "./Config/Idfactory.ini";
	public static final String OTHER_CONFIG_FILE = "./Config/Other.ini";
	public static final String RATES_CONFIG_FILE = "./Config/Rates.ini";
	public static final String ALT_SETTINGS_FILE = "./Config/Altsettings.ini";
	public static final String PVP_CONFIG_FILE = "./Config/PvP.ini";
	public static final String GM_ACCESS_FILE = "./Config/GMAccess.ini";
	public static final String TELNET_FILE = "./Config/Telnet.ini";
	public static final String SIEGE_CONFIGURATION_FILE = "./Config/Siege.ini";
	public static final String BANNED_IP_XML = "./Config/banned.xml";
	public static final String HEXID_FILE = "./Config/hexid.txt";
	public static final String COMMAND_PRIVILEGES_FILE = "./Config/Command-privileges.ini";
	public static final String CLANHALL_CONFIG_FILE = "./Config/Clanhall.ini";
	public static final String PHYSICS_CONFIG_FILE = "./Config/Physics.ini";
	public static final String DEVELOPER_CONFIG_FILE = "./Config/Developer.ini";
	public static final String ADDITIONS_CONFIG_FILE = "./Config/Additions.ini";
	public static final String L2DDT_CONFIG_FILE = "./Config/S-Project.ini";
	public static final String GEODATA_CONFIG_FILE = "./Config/GeoData.ini";
	public static final String CHAT_CONFIG_FILE = "./Config/Chat.ini";
	public static final String ENCHANT_CONFIG_FILE = "./Config/Enchant.ini";
	public static final String PROTECT_CONFIG_FILE = "./Config/Protection.ini";
	public static final String VIP_CONFIG_FILE = "./Config/Vip.ini";
	public static final String CASTLE_CONFIG_FILE = "./Config/Castle.ini";
    public static final String PowerPack_FILE = "./Config/S-Power/PowerPack.ini";
    public static final String SEVEN_SIGNS_DATA_FILE = "./Config/SevenSings.ini";
    public static final String FakeOnline_FILE = "./Config/Online.ini";
    public static final String QUESTION_FILE = "./Config/questionwords.txt";
    public static final String Augmentation = "./Config/Augmentation.ini";
    public static final String NPC_Config = "./Config/Npc.ini";
    public static final String FLOODPROTECTOR_CONFIG_FILE = "./Config/FloodProtector.ini";
    public static final String CraftManager_FILE = "./Config/CraftManager.ini";
    public static final String Buffer_FILE = "./Config/Buffer.ini";
    //Event
    public static final String EVENT_CTF = "./Config/Event/EventCTF.ini";
    public static final String EVENT_DM = "./Config/Event/EventDM.ini";
    public static final String EVENT_TVT = "./Config/Event/EventTvT.ini";
    public static final String CrazyEvent = "./Config/Event/CrazyEventEnchant.ini";
    public static final String EVENT_TW = "./Config/Event/TownWar.ini";
    //Other
    public static final String Olympiad = "./Config/Olympiad.ini";
    public static final String OFFLINE = "./Config/Offline.ini";
    public static final String Voiced_Command = "./Config/VoicedCommand.ini";
    public static final String Announce = "./Config/Announce.ini";
    public static final String SPower_conf = "./Config/S-Power/SPower.ini";
    //GrandBoss
    public static final String GrandBossManager = "./Config/GrandBosses/GrandBossManager.ini";
    public static final String Valakas_File = "./Config/GrandBosses/Valakas.ini";
    public static final String Antharas_File = "./Config/GrandBosses/Antharas.ini";
    public static final String Zaken_File = "./Config/GrandBosses/Zaken.ini";
    public static final String Baium_File = "./Config/GrandBosses/Baium.ini";
    public static final String QueentAnt_File = "./Config/GrandBosses/QueenAnt.ini";
    public static final String Orfen_File = "./Config/GrandBosses/Orfen.ini";
    public static final String Core_File = "./Config/GrandBosses/Core.ini";
    public static final String Sailren_File = "./Config/GrandBosses/Sailren.ini";
    public static final String Frintezza_File = "./Config/GrandBosses/Frintezza.ini";
    public static final String VanHalter_File = "./Config/GrandBosses/VanHalter.ini";
    public static void load()
    {
        if(Server.serverMode == Server.MODE_GAMESERVER)
        {
            _log.info("Loading server configuration...");
			try
            {
                Properties physicsSettings    = new Properties();
                InputStream is               = new FileInputStream(new File(PHYSICS_CONFIG_FILE));
                physicsSettings.load(is);
				is.close();
				ALT_DIFF_MAGIC = Boolean.valueOf(physicsSettings.getProperty("AltDiffMagic", "false"));
				ALT_CRIT_DAMAGE = Float.parseFloat(physicsSettings.getProperty("AltCritDamage", "1.0"));
				BLOW_DAMAGE_HEAVY = Float.parseFloat(physicsSettings.getProperty("BlowDamageHeavy", "1.5"));
				BLOW_DAMAGE_LIGHT = Float.parseFloat(physicsSettings.getProperty("BlowDamageLight", "1.2"));
				BLOW_DAMAGE_ROBE = Float.parseFloat(physicsSettings.getProperty("BlowDamageRobe", "1.0"));
				ALT_MAGES_PHYSICAL_DAMAGE_MULTI = Float.parseFloat(physicsSettings.getProperty("AltPDamageMages", "1.00"));
				ALT_MAGES_MAGICAL_DAMAGE_MULTI = Float.parseFloat(physicsSettings.getProperty("AltMDamageMages", "1.00"));
				ALT_FIGHTERS_PHYSICAL_DAMAGE_MULTI = Float.parseFloat(physicsSettings.getProperty("AltPDamageFighters", "1.00"));
				ALT_FIGHTERS_MAGICAL_DAMAGE_MULTI = Float.parseFloat(physicsSettings.getProperty("AltMDamageFighters", "1.00"));
				ALT_PETS_PHYSICAL_DAMAGE_MULTI = Float.parseFloat(physicsSettings.getProperty("AltPDamagePets", "1.00"));
				ALT_PETS_MAGICAL_DAMAGE_MULTI = Float.parseFloat(physicsSettings.getProperty("AltMDamagePets", "1.00"));
				ALT_NPC_PHYSICAL_DAMAGE_MULTI = Float.parseFloat(physicsSettings.getProperty("AltPDamageNpc", "1.00"));
				ALT_NPC_MAGICAL_DAMAGE_MULTI = Float.parseFloat(physicsSettings.getProperty("AltMDamageNpc", "1.00"));
				ALT_PCRITICAL_CAP = Integer.parseInt(physicsSettings.getProperty("AltPCriticalCap", "500"));
		    	ALT_MCRITICAL_CAP = Integer.parseInt(physicsSettings.getProperty("AltMCriticalCap", "300"));
			    MAX_PATK_SPEED = Integer.parseInt(physicsSettings.getProperty("MaxPAtkSpeed", "0"));
			    MAX_MATK_SPEED = Integer.parseInt(physicsSettings.getProperty("MaxMAtkSpeed", "0"));
				FRONT_CHANCE = Integer.parseInt(physicsSettings.getProperty("FrontSuccessChance", "15"));
			 	SIDE_CHANCE = Integer.parseInt(physicsSettings.getProperty("SideSuccessChance", "45"));
			    BEHIND_CHANCE = Integer.parseInt(physicsSettings.getProperty("BehindSuccessChance", "85"));
				ALT_MINIMUM_FALL_HEIGHT = Integer.parseInt(physicsSettings.getProperty("MinimumFallHeight", "400"));
				HP_REGEN_MULTIPLIER = Double.parseDouble(physicsSettings.getProperty("HpRegenMultiplier", "100")) /100;
                MP_REGEN_MULTIPLIER = Double.parseDouble(physicsSettings.getProperty("MpRegenMultiplier", "100")) /100;
                CP_REGEN_MULTIPLIER = Double.parseDouble(physicsSettings.getProperty("CpRegenMultiplier", "100")) /100;
			 }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+PHYSICS_CONFIG_FILE+" File.");
            }

            try
		    {
			    Properties TWSettings = new Properties();
			    InputStream is = new FileInputStream(new File(EVENT_TW));
			    TWSettings.load(is);
			    is.close();
			    TW_TOWN_ID = Integer.parseInt(TWSettings.getProperty("TWTownId", "9"));
			    TW_ALL_TOWNS = Boolean.parseBoolean(TWSettings.getProperty("TWAllTowns", "False"));
			    TW_ITEM_ID = Integer.parseInt(TWSettings.getProperty("TownWarItemId", "57"));
			    TW_ITEM_AMOUNT = Integer.parseInt(TWSettings.getProperty("TownWarItemAmount", "5000"));
			    TW_ALLOW_KARMA = Boolean.parseBoolean(TWSettings.getProperty("AllowKarma", "False"));
			    TW_DISABLE_GK = Boolean.parseBoolean(TWSettings.getProperty("DisableGK", "True"));
			    TW_RESS_ON_DIE = Boolean.parseBoolean(TWSettings.getProperty("SendRessOnDeath", "False"));
		    }
		    catch(Exception e)
		    {
		    	e.printStackTrace();
		    	throw new Error("Failed to Load " + EVENT_TW + " File.");
		    }

            try
			{
				Properties spower = new Properties();
				InputStream is = new FileInputStream(new File(SPower_conf));
				spower.load(is);
				is.close();

				ENABLE_ITEM_SERVICE = Boolean.parseBoolean(spower.getProperty("AllowItemService", "false"));
				DELEVEL_MIN_LEVEL = Integer.parseInt(spower.getProperty("DelevelMinLevel", "40"));
				DELEVEL_ITEM_ID = Integer.parseInt(spower.getProperty("DelevelItemId", "57"));
				DELEVEL_ITEM_COUNT = Integer.parseInt(spower.getProperty("DelevelItemCount", "1000000"));
				COLOR_ITEM_ID = Integer.parseInt(spower.getProperty("ColorItemId", "9143"));
				COLOR_ITEM_COUNT = Integer.parseInt(spower.getProperty("ColorItemCount", "300"));
				NOOBL_ITEM_ID = Integer.parseInt(spower.getProperty("NooblesItemId", "9143"));
				NOOBL_ITEM_COUNT = Integer.parseInt(spower.getProperty("NooblesItemCount", "400"));
				RENAME_ITEM_ID = Integer.parseInt(spower.getProperty("RenameItemId", "9143"));
				RENAME_ITEM_COUNT = Integer.parseInt(spower.getProperty("RenameItemCount", "300"));
			}
			catch (Exception e)
			{
				e.printStackTrace();
				throw new Error("Failed to Load " + SPower_conf + " File.");
			}

            try
            {
                Properties announce  = new Properties();
                InputStream is    = new FileInputStream(new File(Announce));
                announce.load(is);
                is.close();
                ANNOUNCE_CASTLE_LORDS       = Boolean.parseBoolean(announce.getProperty("AnnounceCastleLords", "False"));
                CHAR_HERO_ANONS_LOGIN       = Boolean.parseBoolean(announce.getProperty("AnnounceHeroesLogin", "False"));
                ANNOUNCE_ALL_KILL           = Boolean.parseBoolean(announce.getProperty("AnnounceAllKill", "False"));
	            if(ANNOUNCE_ALL_KILL == true)
	            {
	                ANNOUNCE_PVP_KILL = Boolean.parseBoolean(announce.getProperty("AnnouncePvPKill", "False"));
	                ANNOUNCE_PK_KILL  = Boolean.parseBoolean(announce.getProperty("AnnouncePkKill", "False"));
	            }
	            else
	            {
	                ANNOUNCE_PVP_KILL = false;
	                ANNOUNCE_PK_KILL  = false;
	            }
                ANNOUNCE_TRY_BANNED_ACCOUNT = Boolean.parseBoolean(announce.getProperty("AnnounceTryBannedAccount", "False"));
                ANNOUNCE_MAMMON_SPAWN = Boolean.parseBoolean(announce.getProperty("AnnounceMammonSpawn", "False"));
                ANNOUNCE_JAIL_CHAR = Boolean.parseBoolean(announce.getProperty("AnnounceJailChar", "False"));
                ANNOUNCE_WEDDING = Boolean.parseBoolean(announce.getProperty("AnnounceWedding", "False"));
                CHAR_VIP_ANONS_LOGIN = Boolean.parseBoolean(announce.getProperty("AnnounceVipCharLogin", "False"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+ Announce +" File.");
            }

            try
		    {
			    Properties gbmanager = new Properties();
			    InputStream is = new FileInputStream(new File(GrandBossManager));
			    gbmanager.load(is);
			    is.close();
			    Sailren_Load = Boolean.parseBoolean(gbmanager.getProperty("SailrenLoad", "True"));
                Core_Load = Boolean.parseBoolean(gbmanager.getProperty("CoreLoad", "True"));
                Zaken_Load = Boolean.parseBoolean(gbmanager.getProperty("ZakenLoad", "True"));
                Orfen_Load = Boolean.parseBoolean(gbmanager.getProperty("OrfenLoad", "True"));
                QueentAnt_Load = Boolean.parseBoolean(gbmanager.getProperty("QueentAntLoad", "True"));
                Baium_Load = Boolean.parseBoolean(gbmanager.getProperty("BaiumLoad", "True"));
                Antharas_Load = Boolean.parseBoolean(gbmanager.getProperty("AntharasLoad", "True"));
                Valakas_Load = Boolean.parseBoolean(gbmanager.getProperty("ValakasLoad", "True"));
                Frintezza_Load = Boolean.parseBoolean(gbmanager.getProperty("FrintezzaLoad", "True"));
                VanHalter_Load = Boolean.parseBoolean(gbmanager.getProperty("VanHalterLoad", "True"));
            }
		    catch(Exception e)
		    {
		    	e.printStackTrace();
		    	throw new Error("Failed to Load " + GrandBossManager + " File.");
		    }

            try
		    {
			    Properties OfflineSettings = new Properties();
			    InputStream is = new FileInputStream(new File(OFFLINE));
			    OfflineSettings.load(is);
			    is.close();
			    OFFLINE_TRADE_ENABLE = Boolean.parseBoolean(OfflineSettings.getProperty("OfflineTradeEnable", "False"));
			    OFFLINE_CRAFT_ENABLE = Boolean.parseBoolean(OfflineSettings.getProperty("OfflineCraftEnable", "False"));
			    OFFLINE_SET_NAME_COLOR = Boolean.parseBoolean(OfflineSettings.getProperty("OfflineNameColorEnable", "False"));
			    OFFLINE_NAME_COLOR = Integer.decode("0x" + OfflineSettings.getProperty("OfflineNameColor", "ff00ff"));
			    RESTORE_OFFLINERS = Boolean.parseBoolean(OfflineSettings.getProperty("RestoreOffliners", "False"));
			    OFFLINE_MAX_DAYS = Integer.parseInt(OfflineSettings.getProperty("OfflineMaxDays", "10"));
			    OFFLINE_DISCONNECT_FINISHED = Boolean.parseBoolean(OfflineSettings.getProperty("OfflineDisconnectFinished", "True"));
		    }
		    catch(Exception e)
		    {
		    	e.printStackTrace();
		    	throw new Error("Failed to Load " + OFFLINE + " File.");
		    }

            try
            {
                Properties fakeonlineSettings    = new Properties();
                InputStream is                   = new FileInputStream(new File(FakeOnline_FILE));
                fakeonlineSettings.load(is);
				is.close();
                SAVE_ONLINE = Boolean.parseBoolean(fakeonlineSettings.getProperty("SaveOnline", "False"));
                FAKE_ONLINE = Integer.parseInt(fakeonlineSettings.getProperty("CountFakeOnline", "0"));
                SAVE_FILE_ROOT = String.valueOf(fakeonlineSettings.getProperty("OnllineSaveFile", "/var/www"));
                ONLINE_PLAYERS_ANNOUNCE_INTERVAL = Integer.parseInt(fakeonlineSettings.getProperty("OnlinePlayersAnnounceInterval", "900000"));
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+FakeOnline_FILE+" File.");
            }

            try
		    {
			    Properties OLYMPSetting = new Properties();
			    InputStream is = new FileInputStream(new File(Olympiad));
			    OLYMPSetting.load(is);
			    is.close();
			    ALT_OLY_START_TIME = Integer.parseInt(OLYMPSetting.getProperty("AltOlyStartTime", "18"));
			    ALT_OLY_MIN = Integer.parseInt(OLYMPSetting.getProperty("AltOlyMin", "00"));
			    ALT_OLY_CPERIOD = Long.parseLong(OLYMPSetting.getProperty("AltOlyCPeriod", "21600000"));
			    ALT_OLY_BATTLE = Long.parseLong(OLYMPSetting.getProperty("AltOlyBattle", "360000"));
			    ALT_OLY_BWAIT = Long.parseLong(OLYMPSetting.getProperty("AltOlyBWait", "600000"));
			    ALT_OLY_IWAIT = Long.parseLong(OLYMPSetting.getProperty("AltOlyIWait", "300000"));
			    ALT_OLY_WPERIOD = Long.parseLong(OLYMPSetting.getProperty("AltOlyWPeriod", "604800000"));
			    ALT_OLY_VPERIOD = Long.parseLong(OLYMPSetting.getProperty("AltOlyVPeriod", "86400000"));
			    ALT_OLY_CLASSED = Integer.parseInt(OLYMPSetting.getProperty("AltOlyClassedParticipants", "5"));
			    ALT_OLY_NONCLASSED = Integer.parseInt(OLYMPSetting.getProperty("AltOlyNonClassedParticipants", "9"));
			    ALT_OLY_BATTLE_REWARD_ITEM = Integer.parseInt(OLYMPSetting.getProperty("AltOlyBattleRewItem", "6651"));
			    ALT_OLY_CLASSED_RITEM_C = Integer.parseInt(OLYMPSetting.getProperty("AltOlyClassedRewItemCount", "50"));
			    ALT_OLY_NONCLASSED_RITEM_C = Integer.parseInt(OLYMPSetting.getProperty("AltOlyNonClassedRewItemCount", "30"));
			    ALT_OLY_COMP_RITEM = Integer.parseInt(OLYMPSetting.getProperty("AltOlyCompRewItem", "6651"));
			    ALT_OLY_GP_PER_POINT = Integer.parseInt(OLYMPSetting.getProperty("AltOlyGPPerPoint", "1000"));
			    ALT_OLY_MIN_POINT_FOR_EXCH = Integer.parseInt(OLYMPSetting.getProperty("AltOlyMinPointForExchange", "50"));
			    ALT_OLY_HERO_POINTS = Integer.parseInt(OLYMPSetting.getProperty("AltOlyHeroPoints", "300"));
			    ALT_OLY_RESTRICTED_ITEMS = OLYMPSetting.getProperty("AltOlyRestrictedItems", "0");
			    LIST_OLY_RESTRICTED_ITEMS = new FastList<Integer>();
			    for(String id : ALT_OLY_RESTRICTED_ITEMS.split(","))
			    {
			    	LIST_OLY_RESTRICTED_ITEMS.add(Integer.parseInt(id));
			    }
			    ALT_OLY_PERIOD = OlympiadPeriod.valueOf(OLYMPSetting.getProperty("AltOlyPeriod", "MONTH"));
			    ALT_OLY_PERIOD_MULTIPLIER = Integer.parseInt(OLYMPSetting.getProperty("AltOlyPeriodMultiplier", "1"));

			    ALLOW_EVENTS_DURING_OLY = Boolean.parseBoolean(OLYMPSetting.getProperty("AllowEventsDuringOly", "False"));
                ALT_ALLOW_AUGMENT_ON_OLYMP = Boolean.parseBoolean(OLYMPSetting.getProperty("AllowAugmnetOlympiad", "True"));
                ALT_OLY_RECHARGE_SKILLS = Boolean.parseBoolean(OLYMPSetting.getProperty("AltOlyRechargeSkills", "False"));
            }
		    catch(Exception e)
		    {
		    	e.printStackTrace();
		    	throw new Error("Failed to Load " + Olympiad + " File.");
		    }

            try
		    {
			    Properties TVTSettings = new Properties();
			    InputStream is = new FileInputStream(new File(EVENT_TVT));
			    TVTSettings.load(is);
			    is.close();
			    TVT_EVEN_TEAMS = TVTSettings.getProperty("TvTEvenTeams", "BALANCE");
			    TVT_ALLOW_INTERFERENCE = Boolean.parseBoolean(TVTSettings.getProperty("TvTAllowInterference", "False"));
			    TVT_ALLOW_POTIONS = Boolean.parseBoolean(TVTSettings.getProperty("TvTAllowPotions", "False"));
			    TVT_ALLOW_SUMMON = Boolean.parseBoolean(TVTSettings.getProperty("TvTAllowSummon", "False"));
			    TVT_ON_START_REMOVE_ALL_EFFECTS = Boolean.parseBoolean(TVTSettings.getProperty("TvTOnStartRemoveAllEffects", "True"));
			    TVT_ON_START_UNSUMMON_PET = Boolean.parseBoolean(TVTSettings.getProperty("TvTOnStartUnsummonPet", "True"));
			    TVT_REVIVE_RECOVERY = Boolean.parseBoolean(TVTSettings.getProperty("TvTReviveRecovery", "False"));
			    TVT_ANNOUNCE_TEAM_STATS = Boolean.parseBoolean(TVTSettings.getProperty("TvTAnnounceTeamStats", "False"));
			    TVT_ANNOUNCE_REWARD = Boolean.parseBoolean(TVTSettings.getProperty("TvTAnnounceReward", "False"));
			    TVT_PRICE_NO_KILLS = Boolean.parseBoolean(TVTSettings.getProperty("TvTPriceNoKills", "False"));
			    TVT_JOIN_CURSED = Boolean.parseBoolean(TVTSettings.getProperty("TvTJoinWithCursedWeapon", "True"));
			    TVT_COMMAND = Boolean.parseBoolean(TVTSettings.getProperty("TvTCommand", "True"));
			    TVT_REVIVE_DELAY = Long.parseLong(TVTSettings.getProperty("TvTReviveDelay", "20000"));
			    if(TVT_REVIVE_DELAY < 1000)
			    	TVT_REVIVE_DELAY = 1000; //can't be set less then 1 second
			    TVT_OPEN_FORT_DOORS = Boolean.parseBoolean(TVTSettings.getProperty("TvTOpenFortDoors", "False"));
			    TVT_CLOSE_FORT_DOORS = Boolean.parseBoolean(TVTSettings.getProperty("TvTCloseFortDoors", "False"));
			    TVT_OPEN_ADEN_COLOSSEUM_DOORS = Boolean.parseBoolean(TVTSettings.getProperty("TvTOpenAdenColosseumDoors", "False"));
			    TVT_CLOSE_ADEN_COLOSSEUM_DOORS = Boolean.parseBoolean(TVTSettings.getProperty("TvTCloseAdenColosseumDoors", "False"));
			    TVT_TOP_KILLER_REWARD = Integer.parseInt(TVTSettings.getProperty("TvTTopKillerRewardId", "5575"));
			    TVT_TOP_KILLER_QTY = Integer.parseInt(TVTSettings.getProperty("TvTTopKillerRewardQty", "2000000"));
			    TVT_AURA = Boolean.parseBoolean(TVTSettings.getProperty("TvTAura", "False"));
			    TVT_STATS_LOGGER = Boolean.parseBoolean(TVTSettings.getProperty("TvTStatsLogger", "true"));
		    }
		    catch(Exception e)
		    {
			    e.printStackTrace();
			    throw new Error("Failed to Load " + EVENT_TVT + " File.");
		    }

            try
		    {
			    Properties DMSettings = new Properties();
			    InputStream is = new FileInputStream(new File(EVENT_DM));
			    DMSettings.load(is);
			    is.close();
			    DM_ALLOW_INTERFERENCE = Boolean.parseBoolean(DMSettings.getProperty("DMAllowInterference", "False"));
			    DM_ALLOW_POTIONS = Boolean.parseBoolean(DMSettings.getProperty("DMAllowPotions", "False"));
			    DM_ALLOW_SUMMON = Boolean.parseBoolean(DMSettings.getProperty("DMAllowSummon", "False"));
			    DM_JOIN_CURSED = Boolean.parseBoolean(DMSettings.getProperty("DMJoinWithCursedWeapon", "False"));
			    DM_ON_START_REMOVE_ALL_EFFECTS = Boolean.parseBoolean(DMSettings.getProperty("DMOnStartRemoveAllEffects", "True"));
			    DM_ON_START_UNSUMMON_PET = Boolean.parseBoolean(DMSettings.getProperty("DMOnStartUnsummonPet", "True"));
			    DM_REVIVE_DELAY = Long.parseLong(DMSettings.getProperty("DMReviveDelay", "20000"));
			    if(DM_REVIVE_DELAY < 1000)
			    {
			    	DM_REVIVE_DELAY = 1000; //can't be set less then 1 second
			    }
			    DM_REVIVE_RECOVERY = Boolean.parseBoolean(DMSettings.getProperty("DMReviveRecovery", "False"));
			    DM_COMMAND = Boolean.parseBoolean(DMSettings.getProperty("DMCommand", "False"));
			    DM_ENABLE_KILL_REWARD = Boolean.parseBoolean(DMSettings.getProperty("DMEnableKillReward", "False"));
			    DM_KILL_REWARD_ID = Integer.parseInt(DMSettings.getProperty("DMKillRewardID", "6392"));
			    DM_KILL_REWARD_AMOUNT = Integer.parseInt(DMSettings.getProperty("DMKillRewardAmount", "1"));
			    DM_ANNOUNCE_REWARD = Boolean.parseBoolean(DMSettings.getProperty("DMAnnounceReward", "False"));
			    DM_SPAWN_OFFSET = Integer.parseInt(DMSettings.getProperty("DMSpawnOffset", "100"));
			    DM_STATS_LOGGER = Boolean.parseBoolean(DMSettings.getProperty("DMStatsLogger", "true"));
			    DM_ALLOW_HEALER_CLASSES = Boolean.parseBoolean(DMSettings.getProperty("DMAllowedHealerClasses", "true"));
			    DM_REMOVE_BUFFS_ON_DIE = Boolean.parseBoolean(DMSettings.getProperty("DMRemoveBuffsOnPlayerDie", "false"));
		    }
		catch(Exception e)
		{
			e.printStackTrace();
			throw new Error("Failed to Load " + EVENT_DM + " File.");
		}

            try
            {
                Properties bufferSettings    = new Properties();
                InputStream is                   = new FileInputStream(new File(Buffer_FILE));
                bufferSettings.load(is);
                is.close();
                NPCBUFFER_MAX_SCHEMES                                   = Integer.parseInt(bufferSettings.getProperty("NPCBufferMaxSchemesPerChar", "3"));
                NPCBUFFER_MAX_SKILLS                                    = Integer.parseInt(bufferSettings.getProperty("NPCBufferMaxSkllsperScheme", "24"));
                NPCBUFFER_STORE_SCHEMES                                 = Boolean.valueOf(bufferSettings.getProperty("NPCBufferStoreSchemes", "True"));
                StringTokenizer st = new StringTokenizer(bufferSettings.getProperty("BufferProtection", ""), " ");
			    while(st.hasMoreTokens())
			    {
				    BUFFER_PROTECTION.add(st.nextToken());
			    }
            }
            catch (Exception e)
            {
               e.printStackTrace();
               throw new Error("Failed to Load "+Buffer_FILE+" File.");
            }

            try
            {
                Properties craftSettings    = new Properties();
                InputStream is                   = new FileInputStream(new File(CraftManager_FILE));
                craftSettings.load(is);
				is.close();
                ALT_CRAFT_ALLOW_CRAFT = Boolean.parseBoolean(craftSettings.getProperty("CraftManagerDwarvenCraft", "True"));
			    ALT_CRAFT_ALLOW_COMMON = Boolean.parseBoolean(craftSettings.getProperty("CraftManagerCommonCraft", "False"));
			    ALT_CRAFT_ALLOW_CRYSTALLIZE = Boolean.parseBoolean(craftSettings.getProperty("CraftManagerCrystallize", "True"));
			    ALT_CRAFT_PRICE = Float.parseFloat(craftSettings.getProperty("CraftManagerPriceMultiplier", "0.1"));
			    ALT_CRAFT_DEFAULT_PRICE = Integer.parseInt(craftSettings.getProperty("CraftManagerDefaultPrice", "50000"));
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+CraftManager_FILE+" File.");
            }

	        try
	        {
	            Properties FloodSetting   = new Properties();
	            InputStream is        = new FileInputStream(new File(FLOODPROTECTOR_CONFIG_FILE));
	            FloodSetting.load(is);
	            is.close();
	            FLOODPROTECTOR_INITIALSIZE = Integer.parseInt(FloodSetting.getProperty("FloodProtectorInitialSize", "50"));
			    PROTECTED_BYPASS_C = Integer.parseInt(FloodSetting.getProperty("FloodProtectorByPass", "4"));
			    PROTECTED_HEROVOICE_C = Integer.parseInt(FloodSetting.getProperty("FloodProtectorHeroVoice", "100"));
			    PROTECTED_MULTISELL_C = Integer.parseInt(FloodSetting.getProperty("FloodProtectorMultisell", "100"));
			    PROTECTED_SUBCLASS_C = Integer.parseInt(FloodSetting.getProperty("FloodProtectorSubclass", "100"));
			    GLOBAL_CHAT_DELAY = Integer.parseInt(FloodSetting.getProperty("FloodProtectorGlobalChatDelay", "0"));
			    PROTECTED_DROP_C = Integer.parseInt(FloodSetting.getProperty("FloodProtectorDrop", "50"));
			    PROTECTED_ENCHANT_C = Integer.parseInt(FloodSetting.getProperty("FloodProtectorEnchant", "50"));
			    PROTECTED_UseCommand = Integer.parseInt(FloodSetting.getProperty("FloodProtectorBankingSystem", "50"));
			    PROTECTED_WEREHOUSE_C = Integer.parseInt(FloodSetting.getProperty("FloodProtectorWerehouse", "50"));
			    PROTECTED_USE_ITEM_C = Integer.parseInt(FloodSetting.getProperty("FloodProtectorUseItem", "10"));
            }
	        catch (Exception e)
	        {
	            e.printStackTrace();
	            throw new Error("Failed to Load "+FLOODPROTECTOR_CONFIG_FILE+" File.");
	        }

            try
            {
                Properties npcSettings    = new Properties();
                InputStream is            = new FileInputStream(new File(NPC_Config));
                npcSettings.load(is);
				is.close();
                ALLOW_TALK_WHILE_SITTING = Boolean.parseBoolean(npcSettings.getProperty("AllowTalkWhileSitting", "True"));
                FORCE_UPDATE_RAIDBOSS_ON_DB = Boolean.parseBoolean(npcSettings.getProperty("ForceUpdateRaidbossOnDb", "False"));
                ANNOUNCE_RB_ON_DEAD = Boolean.parseBoolean(npcSettings.getProperty("AnnounceRbOnDead", "False"));
                ANNOUNCE_RB_ON_SPAWN = Boolean.parseBoolean(npcSettings.getProperty("AnnounceRbOnSpawn", "False"));
                RAID_DISABLE_CURSE = Boolean.parseBoolean(npcSettings.getProperty("DisableRaidCurse", "False"));
                PLAYERS_CAN_HEAL_RB = Boolean.parseBoolean(npcSettings.getProperty("PlayersCanHealRb", "True"));
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+NPC_Config+" File.");
            }

            try
            {
                Properties augmentationSettings    = new Properties();
                InputStream is                     = new FileInputStream(new File(Augmentation));
                augmentationSettings.load(is);
				is.close();
                DELETE_AUGM_PASSIVE_ON_CHANGE = Boolean.parseBoolean(augmentationSettings.getProperty("DeleteAgmentPassiveEffectOnChangeWep", "True"));
			    DELETE_AUGM_ACTIVE_ON_CHANGE = Boolean.parseBoolean(augmentationSettings.getProperty("DeleteAgmentActiveEffectOnChangeWep", "True"));
                ACTIVE_AUGMENTS_START_REUSE_TIME = Integer.parseInt(augmentationSettings.getProperty("AugmStartReuseTime", "0"));
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+Augmentation+" File.");
            }

            try
            {
                Properties antharas    = new Properties();
                InputStream is         = new FileInputStream(new File(Antharas_File));
                antharas.load(is);
				is.close();
                Antharas_Wait_Time = Integer.parseInt(antharas.getProperty("AntharasWaitTime", "30"));
			if (Antharas_Wait_Time < 3 || Antharas_Wait_Time > 60)
				Antharas_Wait_Time = 30;
			Antharas_Wait_Time = Antharas_Wait_Time * 60000;
			Interval_Of_Antharas_Spawn = Integer.parseInt(antharas.getProperty("IntervalOfAntharasSpawn", "192"));
			if (Interval_Of_Antharas_Spawn < 1 || Interval_Of_Antharas_Spawn > 480)
				Interval_Of_Antharas_Spawn = 192;
			Interval_Of_Antharas_Spawn = Interval_Of_Antharas_Spawn * 3600000;
			Random_Of_Antharas_Spawn = Integer.parseInt(antharas.getProperty("RandomOfAntharasSpawn", "145"));
			if (Random_Of_Antharas_Spawn < 1 || Random_Of_Antharas_Spawn > 192)
				Random_Of_Antharas_Spawn = 145;
			Random_Of_Antharas_Spawn = Random_Of_Antharas_Spawn * 3600000;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+Antharas_File+" File.");
            }
            try
            {
                Properties valakas    = new Properties();
                InputStream is        = new FileInputStream(new File(Valakas_File));
                valakas.load(is);
				is.close();
                Interval_Of_Valakas_Spawn = Integer.parseInt(valakas.getProperty("IntervalOfValakasSpawn", "192"));
			if (Interval_Of_Valakas_Spawn < 1 || Interval_Of_Valakas_Spawn > 480)
				Interval_Of_Valakas_Spawn = 192;
			Interval_Of_Valakas_Spawn = Interval_Of_Valakas_Spawn * 3600000;
			Random_Of_Valakas_Spawn = Integer.parseInt(valakas.getProperty("RandomOfValakasSpawn", "145"));
			if (Random_Of_Valakas_Spawn < 1 || Random_Of_Valakas_Spawn > 192)
				Random_Of_Valakas_Spawn = 145;
			Random_Of_Valakas_Spawn = Random_Of_Valakas_Spawn * 3600000;
                Valakas_Wait_Time = Integer.parseInt(valakas.getProperty("ValakasWaitTime", "20"));
			if (Valakas_Wait_Time < 3 || Valakas_Wait_Time > 60)
				Valakas_Wait_Time = 20;
			Valakas_Wait_Time = Valakas_Wait_Time * 60000;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+Valakas_File+" File.");
            }
            try
            {
                Properties baium    = new Properties();
                InputStream is      = new FileInputStream(new File(Baium_File));
                baium.load(is);
				is.close();
                Interval_Of_Baium_Spawn = Integer.parseInt(baium.getProperty("IntervalOfBaiumSpawn", "121"));
			if (Interval_Of_Baium_Spawn < 1 || Interval_Of_Baium_Spawn > 480)
				Interval_Of_Baium_Spawn = 121;
			Interval_Of_Baium_Spawn = Interval_Of_Baium_Spawn * 3600000;
			Random_Of_Baium_Spawn = Integer.parseInt(baium.getProperty("RandomOfBaiumSpawn", "8"));
			if (Random_Of_Baium_Spawn < 1 || Random_Of_Baium_Spawn > 192)
				Random_Of_Baium_Spawn = 8;
			Random_Of_Baium_Spawn = Random_Of_Baium_Spawn * 3600000;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+Baium_File+" File.");
            }
            try
            {
                Properties core    = new Properties();
                InputStream is     = new FileInputStream(new File(Core_File));
                core.load(is);
				is.close();
                Interval_Of_Core_Spawn = Integer.parseInt(core.getProperty("IntervalOfCoreSpawn", "27"));
			if (Interval_Of_Core_Spawn < 1 || Interval_Of_Core_Spawn > 480)
				Interval_Of_Core_Spawn = 27;
			Interval_Of_Core_Spawn = Interval_Of_Core_Spawn * 3600000;
			Random_Of_Core_Spawn = Integer.parseInt(core.getProperty("RandomOfCoreSpawn", "47"));
			if (Random_Of_Core_Spawn < 1 || Random_Of_Core_Spawn > 192)
				Random_Of_Core_Spawn = 47;
			Random_Of_Core_Spawn = Random_Of_Core_Spawn * 3600000;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+Core_File+" File.");
            }
            try
            {
                Properties orfen    = new Properties();
                InputStream is      = new FileInputStream(new File(Orfen_File));
                orfen.load(is);
				is.close();
                Interval_Of_Orfen_Spawn = Integer.parseInt(orfen.getProperty("IntervalOfOrfenSpawn", "28"));
			if (Interval_Of_Orfen_Spawn < 1 || Interval_Of_Orfen_Spawn > 480)
				Interval_Of_Orfen_Spawn = 28;
			Interval_Of_Orfen_Spawn = Interval_Of_Orfen_Spawn * 3600000;
			Random_Of_Orfen_Spawn = Integer.parseInt(orfen.getProperty("RandomOfOrfenSpawn", "41"));
			if (Random_Of_Orfen_Spawn < 1 || Random_Of_Orfen_Spawn > 192)
				Random_Of_Orfen_Spawn = 41;
			Random_Of_Orfen_Spawn = Random_Of_Orfen_Spawn * 3600000;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+Orfen_File+" File.");
            }
            try
            {
                Properties queentant    = new Properties();
                InputStream is          = new FileInputStream(new File(QueentAnt_File));
                queentant.load(is);
				is.close();
                Interval_Of_QueenAnt_Spawn = Integer.parseInt(queentant.getProperty("IntervalOfQueenAntSpawn", "19"));
			if (Interval_Of_QueenAnt_Spawn < 1 || Interval_Of_QueenAnt_Spawn > 480)
				Interval_Of_QueenAnt_Spawn = 19;
			Interval_Of_QueenAnt_Spawn = Interval_Of_QueenAnt_Spawn * 3600000;
			Random_Of_QueenAnt_Spawn = Integer.parseInt(queentant.getProperty("RandomOfQueenAntSpawn", "35"));
			if (Random_Of_QueenAnt_Spawn < 1 || Random_Of_QueenAnt_Spawn > 192)
				Random_Of_QueenAnt_Spawn = 35;
			Random_Of_QueenAnt_Spawn = Random_Of_QueenAnt_Spawn * 3600000;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+QueentAnt_File+" File.");
            }
            try
            {
                Properties zaken    = new Properties();
                InputStream is      = new FileInputStream(new File(Zaken_File));
                zaken.load(is);
				is.close();
                Interval_Of_Zaken_Spawn = Integer.parseInt(zaken.getProperty("IntervalOfZakenSpawn", "19"));
			if (Interval_Of_Zaken_Spawn < 1 || Interval_Of_Zaken_Spawn > 480)
				Interval_Of_Zaken_Spawn = 19;
			Interval_Of_Zaken_Spawn = Interval_Of_Zaken_Spawn * 3600000;
			Random_Of_Zaken_Spawn = Integer.parseInt(zaken.getProperty("RandomOfZakenSpawn", "35"));
			if (Random_Of_Zaken_Spawn < 1 || Random_Of_Zaken_Spawn > 192)
				Random_Of_Zaken_Spawn = 35;
			Random_Of_Zaken_Spawn = Random_Of_Zaken_Spawn * 3600000;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+Zaken_File+" File.");
            }
            try
            {
                Properties frintezza    = new Properties();
                InputStream is          = new FileInputStream(new File(Frintezza_File));
                frintezza.load(is);
				is.close();
                Interval_Of_Frintezza_Spawn = Integer.parseInt(frintezza.getProperty("IntervalOfFrintezzaSpawn", "48"));
            if (Interval_Of_Frintezza_Spawn < 1 || Interval_Of_Frintezza_Spawn > 480)
            Interval_Of_Frintezza_Spawn = 48;
            Interval_Of_Frintezza_Spawn = Interval_Of_Frintezza_Spawn * 3600000;
            Random_Of_Frintezza_Spawn = Integer.parseInt(frintezza.getProperty("RandomOfFrintezzaSpawn", "8"));
            if (Random_Of_Frintezza_Spawn < 1 || Random_Of_Frintezza_Spawn > 192)
                Random_Of_Frintezza_Spawn = 8;
            Random_Of_Frintezza_Spawn = Random_Of_Frintezza_Spawn * 3600000;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+Frintezza_File+" File.");
            }
            try
            {
                Properties sailren    = new Properties();
                InputStream is               = new FileInputStream(new File(Sailren_File));
                sailren.load(is);
				is.close();
                Interval_Of_Sailren_Spawn = Integer.parseInt(sailren.getProperty("IntervalOfSailrenSpawn", "12"));
            if (Interval_Of_Sailren_Spawn < 1 || Interval_Of_Sailren_Spawn > 480)
            Interval_Of_Sailren_Spawn = 12;
            Interval_Of_Sailren_Spawn = Interval_Of_Sailren_Spawn * 3600000;
            Random_Of_Sailren_Spawn = Integer.parseInt(sailren.getProperty("RandomOfSailrenSpawn", "24"));
            if (Random_Of_Sailren_Spawn < 1 || Random_Of_Sailren_Spawn > 192)
                Random_Of_Sailren_Spawn = 24;
            Random_Of_Sailren_Spawn = Random_Of_Sailren_Spawn * 3600000;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+Sailren_File+" File.");
            }
            try
            {
                Properties vanhalter    = new Properties();
                InputStream is               = new FileInputStream(new File(VanHalter_File));
                vanhalter.load(is);
				is.close();
                HPH_FIXINTERVALOFHALTER = Integer.parseInt(vanhalter.getProperty("FixIntervalOfHalter", "172800"));
			if (HPH_FIXINTERVALOFHALTER < 300 || HPH_FIXINTERVALOFHALTER > 864000)
				HPH_FIXINTERVALOFHALTER = 172800;
			HPH_RANDOMINTERVALOFHALTER = Integer.parseInt(vanhalter.getProperty("RandomIntervalOfHalter", "86400"));
			if (HPH_RANDOMINTERVALOFHALTER < 300 || HPH_RANDOMINTERVALOFHALTER > 864000)
				HPH_RANDOMINTERVALOFHALTER = 86400;
			HPH_APPTIMEOFHALTER = Integer.parseInt(vanhalter.getProperty("AppTimeOfHalter", "20"));
			if (HPH_APPTIMEOFHALTER < 5 || HPH_APPTIMEOFHALTER > 60)
				HPH_APPTIMEOFHALTER = 20;
			HPH_ACTIVITYTIMEOFHALTER = Integer.parseInt(vanhalter.getProperty("ActivityTimeOfHalter", "21600"));
			if (HPH_ACTIVITYTIMEOFHALTER < 7200 || HPH_ACTIVITYTIMEOFHALTER > 86400)
				HPH_ACTIVITYTIMEOFHALTER = 21600;
			HPH_FIGHTTIMEOFHALTER = Integer.parseInt(vanhalter.getProperty("FightTimeOfHalter", "7200"));
			if (HPH_FIGHTTIMEOFHALTER < 7200 || HPH_FIGHTTIMEOFHALTER > 21600)
				HPH_FIGHTTIMEOFHALTER = 7200;
			HPH_CALLROYALGUARDHELPERCOUNT = Integer.parseInt(vanhalter.getProperty("CallRoyalGuardHelperCount", "6"));
			if (HPH_CALLROYALGUARDHELPERCOUNT < 1 || HPH_CALLROYALGUARDHELPERCOUNT > 6)
				HPH_CALLROYALGUARDHELPERCOUNT = 6;
			HPH_CALLROYALGUARDHELPERINTERVAL = Integer.parseInt(vanhalter.getProperty("CallRoyalGuardHelperInterval", "10"));
			if (HPH_CALLROYALGUARDHELPERINTERVAL < 1 || HPH_CALLROYALGUARDHELPERINTERVAL > 60)
				HPH_CALLROYALGUARDHELPERINTERVAL = 10;
			HPH_INTERVALOFDOOROFALTER = Integer.parseInt(vanhalter.getProperty("IntervalOfDoorOfAlter", "5400"));
			if (HPH_INTERVALOFDOOROFALTER < 60 || HPH_INTERVALOFDOOROFALTER > 5400)
				HPH_INTERVALOFDOOROFALTER = 5400;
			HPH_TIMEOFLOCKUPDOOROFALTAR = Integer.parseInt(vanhalter.getProperty("TimeOfLockUpDoorOfAltar", "180"));
			if (HPH_TIMEOFLOCKUPDOOROFALTAR < 60 || HPH_TIMEOFLOCKUPDOOROFALTAR > 600)
				HPH_TIMEOFLOCKUPDOOROFALTAR = 180;
            }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+VanHalter_File+" File.");
            }

            try
		    {
			    Properties crazyevent = new Properties();
			    InputStream is = new FileInputStream(new File(CrazyEvent));
			    crazyevent.load(is);
			    is.close();
                Announce_CrazyEvent = Boolean.parseBoolean(crazyevent.getProperty("AnnounceCrazyEvent", "True"));
                Enchant_Chance_CrazyEvent = Integer.valueOf(crazyevent.getProperty("EnchantChanceCrazyEvent", "15"));
                Duration_CrazyEvent = Integer.valueOf(crazyevent.getProperty("DurationCrazyEvent", "5"));
                Delay_Start_CrazyEvent = Integer.valueOf(crazyevent.getProperty("DelayCrazyEvent", "20"));
                Return_Time_CrazyEvent = Integer.valueOf(crazyevent.getProperty("ReturnTimeCrazyEvent", "120"));
                Allow_EnebleTime_CrazyEvent = Byte.parseByte(crazyevent.getProperty("AllowEnebletimeCrazyEvent", "0"));
                Allow_EnebleMinutes_CrazyEvent = Byte.parseByte(crazyevent.getProperty("AllowEnebleminutesCrazyEvent", "0"));
	        }
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load " + CrazyEvent + " File.");
		    }

			try
            {
                Properties prem    = new Properties();
                InputStream is 		= new FileInputStream(new File(PREM_FILE));
                prem.load(is);
				is.close();
                USE_PREMIUMSERVICE = Boolean.parseBoolean(prem.getProperty("UsePremiumServices", "False"));
                PREMIUM_RATE_XP = Float.parseFloat(prem.getProperty("PremiumRateXp", "2"));
                PREMIUM_RATE_SP = Float.parseFloat(prem.getProperty("PremiumRateSp", "2"));
				PREMIUM_RATE_DROP_ADENA = Float.parseFloat(prem.getProperty("PremiumRateDropAdena", "2"));
                PREMIUM_RATE_DROP_SPOIL = Float.parseFloat(prem.getProperty("PremiumRateDropSpoil", "2"));
                PREMIUM_RATE_DROP_ITEMS = Float.parseFloat(prem.getProperty("PremiumRateDropItems", "2"));
                PREMIUM_RATE_DROP_QUEST = Float.parseFloat(prem.getProperty("PremiumRateDropQuest", "2"));
                PREMIUM_RATE_DROP_ITEMS_BY_RAID = Float.parseFloat(prem.getProperty("PremiumRateRaidDropItems", "2"));
				PREMIUM_NICK_COLOR = Integer.decode((new StringBuilder()).append("0x").append(prem.getProperty("PremiumNickColor", "00CCFF")).toString());
				PREMIUM_TITLE_COLOR = Integer.decode((new StringBuilder()).append("0x").append(prem.getProperty("PremiumTitleColor", "00CCFF")).toString());
                PREMIUM_PRICE_ITEM_ID = Integer.parseInt(prem.getProperty("PremiumPriceItemId", "57"));
				PREMIUM_PRICE_ITEM_COUNT = Integer.parseInt(prem.getProperty("PremiumPriceItemCount", "1"));
			}
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+PREM_FILE+" File.");
            }

			try
            {
                Properties castleSettings    = new Properties();
                InputStream is               = new FileInputStream(new File(CASTLE_CONFIG_FILE));
                castleSettings.load(is);
				is.close();
				CS_TELE_FEE_RATIO = Long.parseLong(castleSettings.getProperty("CastleTeleportFunctionFeeRatio", "604800000"));
                CS_TELE1_FEE = Integer.parseInt(castleSettings.getProperty("CastleTeleportFunctionFeeLvl1", "7000"));
                CS_TELE2_FEE = Integer.parseInt(castleSettings.getProperty("CastleTeleportFunctionFeeLvl2", "14000"));
                CS_SUPPORT_FEE_RATIO = Long.parseLong(castleSettings.getProperty("CastleSupportFunctionFeeRatio", "86400000"));
                CS_SUPPORT1_FEE = Integer.parseInt(castleSettings.getProperty("CastleSupportFeeLvl1", "7000"));
                CS_SUPPORT2_FEE = Integer.parseInt(castleSettings.getProperty("CastleSupportFeeLvl2", "21000"));
                CS_SUPPORT3_FEE = Integer.parseInt(castleSettings.getProperty("CastleSupportFeeLvl3", "37000"));
                CS_SUPPORT4_FEE = Integer.parseInt(castleSettings.getProperty("CastleSupportFeeLvl4", "52000"));
                CS_MPREG_FEE_RATIO = Long.parseLong(castleSettings.getProperty("CastleMpRegenerationFunctionFeeRatio", "86400000"));
                CS_MPREG1_FEE = Integer.parseInt(castleSettings.getProperty("CastleMpRegenerationFeeLvl1", "2000"));
                CS_MPREG2_FEE = Integer.parseInt(castleSettings.getProperty("CastleMpRegenerationFeeLvl2", "6500"));
                CS_MPREG3_FEE = Integer.parseInt(castleSettings.getProperty("CastleMpRegenerationFeeLvl3", "13750"));
                CS_MPREG4_FEE = Integer.parseInt(castleSettings.getProperty("CastleMpRegenerationFeeLvl4", "20000"));
                CS_HPREG_FEE_RATIO = Long.parseLong(castleSettings.getProperty("CastleHpRegenerationFunctionFeeRatio", "86400000"));
                CS_HPREG1_FEE = Integer.parseInt(castleSettings.getProperty("CastleHpRegenerationFeeLvl1", "1000"));
                CS_HPREG2_FEE = Integer.parseInt(castleSettings.getProperty("CastleHpRegenerationFeeLvl2", "1500"));
                CS_HPREG3_FEE = Integer.parseInt(castleSettings.getProperty("CastleHpRegenerationFeeLvl3", "2250"));
                CS_HPREG4_FEE = Integer.parseInt(castleSettings.getProperty("CastleHpRegenerationFeeLvl14", "3270"));
                CS_HPREG5_FEE = Integer.parseInt(castleSettings.getProperty("CastleHpRegenerationFeeLvl15", "5166"));
                CS_EXPREG_FEE_RATIO = Long.parseLong(castleSettings.getProperty("CastleExpRegenerationFunctionFeeRatio", "86400000"));
                CS_EXPREG1_FEE = Integer.parseInt(castleSettings.getProperty("CastleExpRegenerationFeeLvl1", "9000"));
                CS_EXPREG2_FEE = Integer.parseInt(castleSettings.getProperty("CastleExpRegenerationFeeLvl2", "15000"));
                CS_EXPREG3_FEE = Integer.parseInt(castleSettings.getProperty("CastleExpRegenerationFeeLvl3", "21000"));
                CS_EXPREG4_FEE = Integer.parseInt(castleSettings.getProperty("CastleExpRegenerationFeeLvl4", "30000"));
			}
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+CASTLE_CONFIG_FILE+" File.");
            }

			try
            {
                Properties developerSettings    = new Properties();
                InputStream is               = new FileInputStream(new File(DEVELOPER_CONFIG_FILE));
                developerSettings.load(is);
				is.close();
				USE_3D_MAP = Boolean.valueOf(developerSettings.getProperty("Use3DMap", "False"));
                NEW_NODE_ID = Integer.parseInt(developerSettings.getProperty("NewNodeId", "7952"));
                SELECTED_NODE_ID = Integer.parseInt(developerSettings.getProperty("NewNodeId", "7952"));
                LINKED_NODE_ID = Integer.parseInt(developerSettings.getProperty("NewNodeId", "7952"));
                NEW_NODE_TYPE = developerSettings.getProperty("NewNodeType", "npc");
                CHECK_KNOWN = Boolean.valueOf(developerSettings.getProperty("CheckKnownList", "false"));
                ENABLE_ALL_EXCEPTIONS = Boolean.parseBoolean(developerSettings.getProperty("EnableAllExceptionsLog", "false"));
			}
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+DEVELOPER_CONFIG_FILE+" File.");
            }

			try
            {
                Properties enchantSettings    = new Properties();
                InputStream is               = new FileInputStream(new File(ENCHANT_CONFIG_FILE));
                enchantSettings.load(is);
				is.close();
				ENCHANT_CHANCE_WEAPON  = Integer.parseInt(enchantSettings.getProperty("EnchantChanceWeaponToTen", "66"));
                ENCHANT_CHANCE_ARMOR  = Integer.parseInt(enchantSettings.getProperty("EnchantChanceArmorToTen", "66"));
                ENCHANT_CHANCE_JEWELRY  = Integer.parseInt(enchantSettings.getProperty("EnchantChanceJewelryToTen", "66"));
				ENCHANT_CHANCE_WEAPON_1015  = Integer.parseInt(enchantSettings.getProperty("EnchantChanceWeaponTenToFifteen", "66"));
                ENCHANT_CHANCE_ARMOR_1015  = Integer.parseInt(enchantSettings.getProperty("EnchantChanceArmorTenToFifteen", "66"));
                ENCHANT_CHANCE_JEWELRY_1015  = Integer.parseInt(enchantSettings.getProperty("EnchantChanceJewelryTenToFifteen", "66"));
				ENCHANT_CHANCE_WEAPON_16  = Integer.parseInt(enchantSettings.getProperty("EnchantChanceWeaponAboveFifteen", "66"));
                ENCHANT_CHANCE_ARMOR_16  = Integer.parseInt(enchantSettings.getProperty("EnchantChanceArmorAboveFifteen", "66"));
                ENCHANT_CHANCE_JEWELRY_16  = Integer.parseInt(enchantSettings.getProperty("EnchantChanceJewelryAboveFifteen", "66"));
				BLESSED_CHANCE_WEAPON  = Integer.parseInt(enchantSettings.getProperty("BlessedChanceWeaponToTen", "66"));
                BLESSED_CHANCE_ARMOR  = Integer.parseInt(enchantSettings.getProperty("BlessedChanceArmorToTen", "66"));
                BLESSED_CHANCE_JEWELRY  = Integer.parseInt(enchantSettings.getProperty("BlessedChanceJewelryToTen", "66"));
				BLESSED_CHANCE_WEAPON_1015  = Integer.parseInt(enchantSettings.getProperty("BlessedChanceWeaponTenToFifteen", "66"));
                BLESSED_CHANCE_ARMOR_1015  = Integer.parseInt(enchantSettings.getProperty("BlessedChanceArmorTenToFifteen", "66"));
                BLESSED_CHANCE_JEWELRY_1015  = Integer.parseInt(enchantSettings.getProperty("BlessedChanceJewelryTenToFifteen", "66"));
				BLESSED_CHANCE_WEAPON_16  = Integer.parseInt(enchantSettings.getProperty("BlessedChanceWeaponAboveFifteen", "66"));
                BLESSED_CHANCE_ARMOR_16  = Integer.parseInt(enchantSettings.getProperty("BlessedChanceArmorAboveFifteen", "66"));
                BLESSED_CHANCE_JEWELRY_16  = Integer.parseInt(enchantSettings.getProperty("BlessedChanceJewelryAboveFifteen", "66"));
				CRYSTAL_CHANCE_WEAPON  = Integer.parseInt(enchantSettings.getProperty("CrystalChanceWeaponToTen", "66"));
                CRYSTAL_CHANCE_ARMOR  = Integer.parseInt(enchantSettings.getProperty("CrystalChanceArmorToTen", "66"));
                CRYSTAL_CHANCE_JEWELRY  = Integer.parseInt(enchantSettings.getProperty("CrystalChanceJewelryToTen", "66"));
				CRYSTAL_CHANCE_WEAPON_1015  = Integer.parseInt(enchantSettings.getProperty("CrystalChanceWeaponTenToFifteen", "66"));
                CRYSTAL_CHANCE_ARMOR_1015  = Integer.parseInt(enchantSettings.getProperty("CrystalChanceArmorTenToFifteen", "66"));
                CRYSTAL_CHANCE_JEWELRY_1015  = Integer.parseInt(enchantSettings.getProperty("CrystalChanceJewelryTenToFifteen", "66"));
				CRYSTAL_CHANCE_WEAPON_16  = Integer.parseInt(enchantSettings.getProperty("CrystalChanceWeaponAboveFifteen", "66"));
                CRYSTAL_CHANCE_ARMOR_16  = Integer.parseInt(enchantSettings.getProperty("CrystalChanceArmorAboveFifteen", "66"));
                CRYSTAL_CHANCE_JEWELRY_16  = Integer.parseInt(enchantSettings.getProperty("CrystalChanceJewelryAboveFifteen", "66"));
                ENCHANT_MAX_WEAPON = Integer.parseInt(enchantSettings.getProperty("EnchantMaxWeapon", "16"));
                ENCHANT_MAX_ARMOR = Integer.parseInt(enchantSettings.getProperty("EnchantMaxArmor", "16"));
                ENCHANT_MAX_JEWELRY = Integer.parseInt(enchantSettings.getProperty("EnchantMaxJewelry", "16"));
                ENCHANT_SAFE_MAX = Integer.parseInt(enchantSettings.getProperty("EnchantSafeMax", "3"));
                ENCHANT_SAFE_MAX_FULL = Integer.parseInt(enchantSettings.getProperty("EnchantSafeMaxFull", "4"));
		        ENCHANT_BREAK = Integer.parseInt(enchantSettings.getProperty("EnchantBreak", "0"));
				ENABLE_MODIFY_ENCHANT_CHANCE_WEAPON = Boolean.parseBoolean(enchantSettings.getProperty("EnableModifyEnchantChanceWeapon", "False"));
                if (ENABLE_MODIFY_ENCHANT_CHANCE_WEAPON)
                {
                    ENCHANT_CHANCE_LIST_WEAPON = new FastMap<Integer, Integer>();
                    String[] propertySplit;
                    propertySplit = enchantSettings.getProperty("EnchantChanceListWeapon", "").split(";");
                    for (String enchant : propertySplit)
                    {
                        String[] enchantSplit = enchant.split(",");
                        if (enchantSplit.length != 2)
                        {
                            System.out.println("[EnchantChanceListWeapon]: invalid config property -> EnchantChanceListWeapon \"" + enchant + "\"");
                        }
                        else
                        {
                            try
                            {
                                ENCHANT_CHANCE_LIST_WEAPON.put(Integer.parseInt(enchantSplit[0]), Integer.parseInt(enchantSplit[1]));
                            }
                            catch (NumberFormatException nfe)
                            {
                                if (!enchant.equals(""))
                                {
                                    System.out.println("[EnchantChanceListWeapon]: invalid config property -> EnchantListWeapon \"" + enchantSplit[0] + "\"" + enchantSplit[1]);
                                }
                            }
                        }
                    }
                }
				ENABLE_MODIFY_ENCHANT_CHANCE_ARMOR = Boolean.parseBoolean(enchantSettings.getProperty("EnableModifyEnchantChanceArmor", "False"));
				if (ENABLE_MODIFY_ENCHANT_CHANCE_ARMOR)
                {
                    ENCHANT_CHANCE_LIST_ARMOR = new FastMap<Integer, Integer>();
                    String[] propertySplit;
                    propertySplit = enchantSettings.getProperty("EnchantChanceListArmor", "").split(";");
                    for (String enchant : propertySplit)
                    {
                        String[] enchantSplit = enchant.split(",");
                        if (enchantSplit.length != 2)
                        {
                            System.out.println("[EnchantChanceListArmor]: invalid config property -> EnchantChanceListArmor \"" + enchant + "\"");
                        }
                        else
                        {
                            try
                            {
                                ENCHANT_CHANCE_LIST_ARMOR.put(Integer.parseInt(enchantSplit[0]), Integer.parseInt(enchantSplit[1]));
                            }
                            catch (NumberFormatException nfe)
                            {
                                if (!enchant.equals(""))
                                {
                                    System.out.println("[EnchantChanceListArmor]: invalid config property -> EnchantListArmor \"" + enchantSplit[0] + "\"" + enchantSplit[1]);
                                }
                            }
                        }
                    }
                }
				ENABLE_MODIFY_ENCHANT_CHANCE_JEWELRY = Boolean.parseBoolean(enchantSettings.getProperty("EnableModifyEnchantChanceJewelry", "False"));
				if (ENABLE_MODIFY_ENCHANT_CHANCE_JEWELRY)
                {
                    ENCHANT_CHANCE_LIST_JEWELRY = new FastMap<Integer, Integer>();
                    String[] propertySplit;
                    propertySplit = enchantSettings.getProperty("EnchantChanceListJewelry", "").split(";");
                    for (String enchant : propertySplit)
                    {
                        String[] enchantSplit = enchant.split(",");
                        if (enchantSplit.length != 2)
                        {
                            System.out.println("[EnchantChanceListJewelry]: invalid config property -> EnchantChanceListJewelry \"" + enchant + "\"");
                        }
                        else
                        {
                            try
                            {
                                ENCHANT_CHANCE_LIST_JEWELRY.put(Integer.parseInt(enchantSplit[0]), Integer.parseInt(enchantSplit[1]));
                            }
                            catch (NumberFormatException nfe)
                            {
                                if (!enchant.equals(""))
                                {
                                    System.out.println("[EnchantChanceListJewelry]: invalid config property -> EnchantListJewelry \"" + enchantSplit[0] + "\"" + enchantSplit[1]);
                                }
                            }
                        }
                    }
                }
				ENABLE_MODIFY_ENCHANT_MULTISELL = Boolean.parseBoolean(enchantSettings.getProperty("EnableModifyEnchantMultisell", "False"));
				if (ENABLE_MODIFY_ENCHANT_MULTISELL)
                {
                    ENCHANT_MULTISELL_LIST = new FastMap<Integer, Integer>();
                    String[] propertySplit;
                    propertySplit = enchantSettings.getProperty("EnchantMultisellList", "").split(";");
                    for (String enchant : propertySplit)
                    {
                        String[] enchantSplit = enchant.split(",");
                        if (enchantSplit.length != 2)
                        {
                            System.out.println("[EnchantMultisellList]: invalid config property -> EnchantMultisellList \"" + enchant + "\"");
                        }
                        else
                        {
                            try
                            {
                                ENCHANT_MULTISELL_LIST.put(Integer.parseInt(enchantSplit[0]), Integer.parseInt(enchantSplit[1]));
                            }
                            catch (NumberFormatException nfe)
                            {
                                if (!enchant.equals(""))
                                {
                                    System.out.println("[EnchantMultisellList]: invalid config property -> EnchantMultisellList \"" + enchantSplit[0] + "\"" + enchantSplit[1]);
                                }
                            }
                        }
                    }
                }
                PREMIUM_ENCH_BONUS      = Boolean.parseBoolean(enchantSettings.getProperty("PremiumEnchBonus", "False"));
            if (PREMIUM_ENCH_BONUS)
            {
                PREMIUM_ENCH_CHANCE_BONUS = Integer.parseInt(enchantSettings.getProperty("PremiumEnchantChanceBonus", "0"));
            }
			}
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+ENCHANT_CONFIG_FILE+" File.");
            }

			try
            {
                Properties chatSettings    = new Properties();
                InputStream is               = new FileInputStream(new File(CHAT_CONFIG_FILE));
                chatSettings.load(is);
				is.close();
				DEFAULT_GLOBAL_CHAT = chatSettings.getProperty("GlobalChat", "ON");
                DEFAULT_TRADE_CHAT = chatSettings.getProperty("TradeChat", "ON");
				MAX_MESSAGE_LENGHT = Integer.parseInt(chatSettings.getProperty("MaxChatLenght", "75"));
			}
			catch (Exception e)
			{
                e.printStackTrace();
                throw new Error("Failed to Load "+CHAT_CONFIG_FILE+" File.");
            }

            try
            {
				Properties CTFSettings    = new Properties();
				InputStream is            = new FileInputStream(new File(EVENT_CTF));
                CTFSettings.load(is);
                is.close();
                CTF_EVEN_TEAMS = CTFSettings.getProperty("CTFEvenTeams", "BALANCE");
                CTF_ALLOW_INTERFERENCE = Boolean.parseBoolean(CTFSettings.getProperty("CTFAllowInterference", "False"));
                CTF_ALLOW_POTIONS = Boolean.parseBoolean(CTFSettings.getProperty("CTFAllowPotions", "False"));
                CTF_ALLOW_SUMMON = Boolean.parseBoolean(CTFSettings.getProperty("CTFAllowSummon", "False"));
                CTF_ON_START_REMOVE_ALL_EFFECTS = Boolean.parseBoolean(CTFSettings.getProperty("CTFOnStartRemoveAllEffects", "True"));
                CTF_ON_START_UNSUMMON_PET = Boolean.parseBoolean(CTFSettings.getProperty("CTFOnStartUnsummonPet", "True"));
                CTF_ANNOUNCE_TEAM_STATS = Boolean.parseBoolean(CTFSettings.getProperty("CTFAnnounceTeamStats", "False"));
                CTF_JOIN_CURSED = Boolean.parseBoolean(CTFSettings.getProperty("CTFJoinWithCursedWeapon", "True"));
                CTF_REVIVE_RECOVERY = Boolean.parseBoolean(CTFSettings.getProperty("CTFReviveRecovery", "False"));
                CTF_COMMAND = Boolean.parseBoolean(CTFSettings.getProperty("CTFCommand", "True"));
            }
			catch (Exception e)
			{
				e.printStackTrace();
                throw new Error("Failed to Load "+EVENT_CTF+" File.");
			}

            try
            {
				Properties voiced    = new Properties();
				InputStream is               = new FileInputStream(new File(Voiced_Command));
                voiced.load(is);
                is.close();
                ALLOW_EXP_GAIN_COMMAND = Boolean.parseBoolean(voiced.getProperty("AllowExpGainCommand", "False"));
                ALLOW_ONLINE = Boolean.parseBoolean(voiced.getProperty("AllowOnlineCommand", "False"));
                ALLOW_IpBlock = Boolean.parseBoolean(voiced.getProperty("AllowIpBlockCommand", "False"));
                ALLOW_PLAYERS_REFUSAL = Boolean.parseBoolean(voiced.getProperty("AllowPlayersRefusal", "False"));
                ALLOW_TRADEOFF_COMMAND = Boolean.parseBoolean(voiced.getProperty("AllowTradeoffCommand", "False"));   
            }
			catch (Exception e)
			{
				e.printStackTrace();
                throw new Error("Failed to Load "+Voiced_Command+" File.");
			}

			try
            {
				Properties geodataSettings    = new Properties();
				InputStream is               = new FileInputStream(new File(GEODATA_CONFIG_FILE));
                geodataSettings.load(is);
                is.close();
			    GEODATA	= Integer.parseInt(geodataSettings.getProperty("GeoData", "0"));
			    FORCE_GEODATA = Boolean.parseBoolean(geodataSettings.getProperty("ForceGeoData", "True"));
			    ALLOW_WATER = Boolean.valueOf(geodataSettings.getProperty("AllowWater", "False"));
                COORD_SYNCHRONIZE = Integer.parseInt(geodataSettings.getProperty("CoordSynchronize", "-1"));
                MOVE_BASED_KNOWNLIST = Boolean.parseBoolean(geodataSettings.getProperty("MoveBasedKnownlist", "False"));
	            KNOWNLIST_UPDATE_INTERVAL = Long.parseLong(geodataSettings.getProperty("KnownListUpdateInterval", "1250"));
				ACCEPT_GEOEDITOR_CONN = Boolean.parseBoolean(geodataSettings.getProperty("AcceptGeoeditorConn", "False"));
			}
			catch (Exception e)
			{
				e.printStackTrace();
                throw new Error("Failed to Load "+GEODATA_CONFIG_FILE+" File.");
			}

			try
            {
				Properties protectSettings    = new Properties();
				InputStream is               = new FileInputStream(new File(PROTECT_CONFIG_FILE));
                protectSettings.load(is);
                is.close();
				FLOOD_PROTECTION = Boolean.parseBoolean(protectSettings.getProperty("EnableFloodProtection","True"));
                CHECK_SKILLS_ON_ENTER = Boolean.valueOf(protectSettings.getProperty("CheckSkillsOnEnter", "False"));
			    CHECK_HERO_SKILLS = Boolean.valueOf(protectSettings.getProperty("CheckHeroSkills", "True"));
			    CHECK_NOBLE_SKILLS = Boolean.valueOf(protectSettings.getProperty("CheckNobleSkills", "True"));
				NON_CHECK_SKILLS = protectSettings.getProperty("NonCheckSkills", "10000");
                LIST_NON_CHECK_SKILLS = new FastList<Integer>();
                for (String id : NON_CHECK_SKILLS.split(","))
                {
                    LIST_NON_CHECK_SKILLS.add(Integer.parseInt(id));
                }
				BYPASS_VALIDATION = Boolean.valueOf(protectSettings.getProperty("BypassValidation", "True"));
				ONLY_GM_ITEMS_FREE = Boolean.valueOf(protectSettings.getProperty("OnlyGMItemsFree", "True"));
				GAMEGUARD_ENFORCE = Boolean.valueOf(protectSettings.getProperty("GameGuardEnforce", "False"));
                GAMEGUARD_PROHIBITACTION = Boolean.valueOf(protectSettings.getProperty("GameGuardProhibitAction", "False"));
				FAST_CONNECTION_LIMIT = Integer.parseInt(protectSettings.getProperty("FastConnectionLimit","15"));
                NORMAL_CONNECTION_TIME = Integer.parseInt(protectSettings.getProperty("NormalConnectionTime","700"));
                FAST_CONNECTION_TIME = Integer.parseInt(protectSettings.getProperty("FastConnectionTime","350"));
                MAX_CONNECTION_PER_IP = Integer.parseInt(protectSettings.getProperty("MaxConnectionPerIP","50"));
				ENABLE_PACKET_PROTECTION = Boolean.parseBoolean(protectSettings.getProperty("PacketProtection", "false"));
				MAX_UNKNOWN_PACKETS = Integer.parseInt(protectSettings.getProperty("UnknownPacketsBeforeBan", "50"));
				UNKNOWN_PACKETS_PUNISHMENT = Integer.parseInt(protectSettings.getProperty("UnknownPacketsPunishment", "2"));
				IPTABLES = Boolean.parseBoolean(protectSettings.getProperty("IPTables", "False"));
                IPTABLES_URL = protectSettings.getProperty("IPTablesURL", "/sbin/iptables");
                BOT_PROTECTOR = Boolean.parseBoolean(protectSettings.getProperty("BotProtect", "False"));
			    BOT_PROTECTOR_FIRST_CHECK = Integer.parseInt(protectSettings.getProperty("BotProtectFirstCheck", "15"));
			    BOT_PROTECTOR_NEXT_CHECK = Integer.parseInt(protectSettings.getProperty("BotProtectNextCheck", "60"));
			    BOT_PROTECTOR_WAIT_ANSVER = Integer.parseInt(protectSettings.getProperty("BotProtectAnsver", "180"));
                SAFE_REBOOT                               = Boolean.parseBoolean(protectSettings.getProperty("SafeReboot", "False"));
			    SAFE_REBOOT_TIME                          = Integer.parseInt(protectSettings.getProperty("SafeRebootTime", "10"));
			    SAFE_REBOOT_DISABLE_ENCHANT               = Boolean.parseBoolean(protectSettings.getProperty("SafeRebootDisableEnchant", "False"));
			    SAFE_REBOOT_DISABLE_TELEPORT              = Boolean.parseBoolean(protectSettings.getProperty("SafeRebootDisableTeleport", "False"));
			    SAFE_REBOOT_DISABLE_CREATEITEM            = Boolean.parseBoolean(protectSettings.getProperty("SafeRebootDisableCreateItem", "False"));
			    SAFE_REBOOT_DISABLE_TRANSACTION           = Boolean.parseBoolean(protectSettings.getProperty("SafeRebootDisableTransaction", "False"));
			    SAFE_REBOOT_DISABLE_PC_ITERACTION         = Boolean.parseBoolean(protectSettings.getProperty("SafeRebootDisablePcIteraction", "False"));
			    SAFE_REBOOT_DISABLE_NPC_ITERACTION        = Boolean.parseBoolean(protectSettings.getProperty("SafeRebootDisableNpcIteraction", "False"));
                ALLOW_DUALBOX_OLY = Boolean.parseBoolean(protectSettings.getProperty("AllowDualBoxInOly", "True"));
			    ALLOW_DUALBOX_EVENT = Boolean.parseBoolean(protectSettings.getProperty("AllowDualBoxInEvent", "True"));
			    ALLOWED_BOXES = Integer.parseInt(protectSettings.getProperty("AllowedBoxes", "2"));
			    ALLOW_DUALBOX = Boolean.parseBoolean(protectSettings.getProperty("AllowDualBox", "True"));
            }
			catch (Exception e)
			{
				e.printStackTrace();
                throw new Error("Failed to Load "+PROTECT_CONFIG_FILE+" File.");
			}

			try
            {
				Properties questionfile    = new Properties();
				InputStream is               = new FileInputStream(new File(QUESTION_FILE));
                questionfile.load(is);
                is.close();
                LineNumberReader lnr = new LineNumberReader(new BufferedReader(new FileReader(new File(QUESTION_FILE))));
			    String line = null;
			    while((line = lnr.readLine()) != null)
			        {
				    if(line.trim().length() < 10 || line.trim().length() > 16 || line.startsWith("#"))
				    {
				    	continue;
				    }
				    QUESTION_LIST.add(line.trim());
			    }
			}
			catch (Exception e)
			{
				e.printStackTrace();
                throw new Error("Failed to Load "+QUESTION_FILE+" File.");
			}

			try
            {
				Properties l2ddtSettings    = new Properties();
                InputStream is               = new FileInputStream(new File(L2DDT_CONFIG_FILE));
                l2ddtSettings.load(is);
                is.close();
                ALT_DEV_NO_AI = Boolean.parseBoolean(l2ddtSettings.getProperty("AltDevNoAI", "False"));
                Loaded_Frintezza = Boolean.parseBoolean(l2ddtSettings.getProperty("AltDevNoManagerFrintezza", "False"));
                CLAN_MEMBER_LVLUP6 = Integer.parseInt(l2ddtSettings.getProperty("ClanMemberLvLUp6", "30"));
                CLAN_MEMBER_LVLUP7 = Integer.parseInt(l2ddtSettings.getProperty("ClanMemberLvLUp7", "80"));
                CLAN_MEMBER_LVLUP8 = Integer.parseInt(l2ddtSettings.getProperty("ClanMemberLvLUp8", "120"));
                REWARD_KILL_WAR = Integer.parseInt(l2ddtSettings.getProperty("RewardKillWar", "2"));
                CLAN_SCORE_SIEGE = Integer.parseInt(l2ddtSettings.getProperty("ClanScoreSiege", "500"));
                BONUS_CLAN_SCORE_SIEGE = Integer.parseInt(l2ddtSettings.getProperty("BonusClanScoreSiege", "1000"));
                SHOW_NPC_LVL = Boolean.parseBoolean(l2ddtSettings.getProperty("ShowNpcLevel", "false"));
                DUEL_SPAWN_X = Integer.parseInt(l2ddtSettings.getProperty("PartyDuelSpawnX", "149319"));
                DUEL_SPAWN_Y = Integer.parseInt(l2ddtSettings.getProperty("PartyDuelSpawnY", "46710"));
                DUEL_SPAWN_Z = Integer.parseInt(l2ddtSettings.getProperty("PartyDuelSpawnZ", "-3413"));
                DAY_TO_SIEGE = Integer.parseInt(l2ddtSettings.getProperty("DayToSiege", "14"));
				KICK_L2WALKER = Boolean.parseBoolean(l2ddtSettings.getProperty("L2WalkerProtection","True"));
				ONLINE_PLAYERS_AT_STARTUP = Boolean.parseBoolean(l2ddtSettings.getProperty("ShowOnlinePlayers", "true"));
				INVUL_NPC_LIST = new FastList();
			    String t = l2ddtSettings.getProperty("InvulNpcList", "30001-32132,35092-35103,35142-35146,35176-35187,35218-35232,35261-35278,35308-35319,35352-35367,35382-35407,35417-35427,35433-35469,35497-35513,35544-35587,35600-35617,35623-35628,35638-35640,35644,35645,50007,70010,99999");
			    String as[];
			    int k = (as = t.split(",")).length;
				for(int j = 0; j < k; j++)
				{
					String t2 = as[j];
					if(t2.contains("-"))
					{
						int a1 = Integer.parseInt(t2.split("-")[0]);
						int a2 = Integer.parseInt(t2.split("-")[1]);
						for(int i = a1; i <= a2; i++)
							INVUL_NPC_LIST.add(i);
					}
                    else
					{
						INVUL_NPC_LIST.add(Integer.parseInt(t2));
					}
			    }
				MAX_MULTISELL = Integer.parseInt(l2ddtSettings.getProperty("MaxMultisell","5000"));
				MAX_SUBCLASS = Integer.parseInt(l2ddtSettings.getProperty("MaxSubclass","3"));
				EXPERTISE_PENALTY = Boolean.valueOf(l2ddtSettings.getProperty("ExpertisePenalty", "true"));
				ALT_DISABLE_BOW_CLASSES = Boolean.parseBoolean(l2ddtSettings.getProperty("AltDisableBow", "False"));
                DISABLE_BOW_CLASSES_STRING = l2ddtSettings.getProperty("DisableBowForClasses", "");
                DISABLE_BOW_CLASSES = new FastList<Integer>();
                  for (String class_id : DISABLE_BOW_CLASSES_STRING.split(","))
                     {
                          if(!class_id.equals(""))
                          DISABLE_BOW_CLASSES.add(Integer.parseInt(class_id));
                     }
				LEVEL_ON_ENTER = Byte.parseByte(l2ddtSettings.getProperty("LevelOnEnter", "0"));
                SP_ON_ENTER = Integer.parseInt(l2ddtSettings.getProperty("SPOnEnter", "0"));
			    NOT_CONSUME_SHOTS = Boolean.valueOf(l2ddtSettings.getProperty("UnlimShots", "false"));
		   	    ALT_DROP_ADENA = Boolean.valueOf(l2ddtSettings.getProperty("AltDropAdena", "False"));
			    NPC_ATTACKABLE = Boolean.valueOf(l2ddtSettings.getProperty("NpcAttackable", "False"));
			    CLASSMASTER_MSG = Boolean.valueOf(l2ddtSettings.getProperty("ClassmasterMessage", "True"));
			    CLASS_MASTER_STRIDER_UPDATE = Boolean.parseBoolean(l2ddtSettings.getProperty("ClassMasterUpdateStrider", "False"));
			    if (!l2ddtSettings.getProperty("ConfigClassMaster").trim().equalsIgnoreCase("False"))
				    CLASS_MASTER_SETTINGS_LINE = l2ddtSettings.getProperty("ConfigClassMaster");
                CLASS_MASTER_SETTINGS = new ClassMasterSettings(CLASS_MASTER_SETTINGS_LINE);
			    STRIDER_LEVEL_FOR_UP = Integer.parseInt(l2ddtSettings.getProperty("StrideLevelForUp", "55"));
                PRICE_FOR_STRIDER = Integer.parseInt(l2ddtSettings.getProperty("PriceForStrider", "6000000"));
			    SPIRIT_TIME_MULTIPLIER = Float.parseFloat(l2ddtSettings.getProperty("SpiritMultiplier", "1"));
			    BUFF_TIME_MULTIPLIER = Float.parseFloat(l2ddtSettings.getProperty("BuffMultiplier", "1"));
			    VIEW_SKILL_CHANCE = Boolean.parseBoolean(l2ddtSettings.getProperty("SkillChance", "True"));
			    DANCE_TIME_MULTIPLIER = Float.parseFloat(l2ddtSettings.getProperty("DanceTimeMultiplier", "1"));
			    LIMITED_ENTRY_CATACOMB = Boolean.valueOf(l2ddtSettings.getProperty("LimitedEntryCat", "False"));
                LIMITED_ENTRY_NECRO = Boolean.valueOf(l2ddtSettings.getProperty("LimitedEntryNec", "False"));
			    ALLOW_CLASS_MASTERS = Boolean.valueOf(l2ddtSettings.getProperty("ClassMasters", "False"));
                BUFFS_MAX_AMOUNT = Byte.parseByte(l2ddtSettings.getProperty("MaxBuffAmount","24"));
                ALT_WEIGHT_LIMIT = Double.parseDouble(l2ddtSettings.getProperty("WeightLimit", "1"));
                STARTING_ADENA = Integer.parseInt(l2ddtSettings.getProperty("StartingAdena", "100"));
			    DEATH_PENALTY_CHANCE = Integer.parseInt(l2ddtSettings.getProperty("DeathPenaltyChance", "20"));
                MAX_DRIFT_RANGE = Integer.parseInt(l2ddtSettings.getProperty("MaxDriftRange", "300"));
                MIN_NPC_ANIMATION = Integer.parseInt(l2ddtSettings.getProperty("MinNPCAnimation", "10"));
                MAX_NPC_ANIMATION = Integer.parseInt(l2ddtSettings.getProperty("MaxNPCAnimation", "20"));
                MIN_MONSTER_ANIMATION = Integer.parseInt(l2ddtSettings.getProperty("MinMonsterAnimation", "5"));
                MAX_MONSTER_ANIMATION = Integer.parseInt(l2ddtSettings.getProperty("MaxMonsterAnimation", "20"));
                SERVER_NEWS = Boolean.valueOf(l2ddtSettings.getProperty("ShowServerNews", "False"));
				ENABLE_MODIFY_SKILL_DURATION = Boolean.parseBoolean(l2ddtSettings.getProperty("EnableModifySkillDuration", "False"));
				if (ENABLE_MODIFY_SKILL_DURATION)
				{
					SKILL_DURATION_LIST = new FastMap<Integer, Integer>();
					String[] propertySplit;
					propertySplit = l2ddtSettings.getProperty("SkillDurationList", "").split(";");
					for (String skill : propertySplit)
					{
						String[] skillSplit = skill.split(",");
						if (skillSplit.length != 2)
						{
							System.out.println("[SkillDurationList]: invalid config property -> SkillDurationList \"" + skill + "\"");
						}
                        else
						{
							try
							{
								SKILL_DURATION_LIST.put(Integer.parseInt(skillSplit[0]), Integer.parseInt(skillSplit[1]));
							}
							catch (NumberFormatException nfe)
							{
								if (!skill.isEmpty())
								{
									System.out.println("[SkillDurationList]: invalid config property -> SkillList \"" + skillSplit[0] + "\"" + skillSplit[1]);
								}
							}
						}
					}
				}
                ALLOW_REMOTE_CLASS_MASTERS = Boolean.valueOf(l2ddtSettings.getProperty("AllowRemoteClassMasters", "False"));
                NOBLE_CUSTOM_ITEMS = Boolean.parseBoolean(l2ddtSettings.getProperty("EnableNobleCustomItem", "True"));
			    NOOBLE_CUSTOM_ITEM_ID = Integer.parseInt(l2ddtSettings.getProperty("NoobleCustomItemId", "6673"));
			    HERO_CUSTOM_ITEMS = Boolean.parseBoolean(l2ddtSettings.getProperty("EnableHeroCustomItem", "True"));
			    HERO_CUSTOM_ITEM_ID = Integer.parseInt(l2ddtSettings.getProperty("HeroCustomItemId", "3481"));
			    HERO_CUSTOM_DAY = Integer.parseInt(l2ddtSettings.getProperty("HeroCustomDay", "0"));
                ALLOW_HERO_SUBSKILL = Boolean.parseBoolean(l2ddtSettings.getProperty("CustomHeroSubSkill", "False"));
                HERO_COUNT = Integer.parseInt(l2ddtSettings.getProperty("HeroCount", "1"));
                SPAWN_CHAR = Boolean.parseBoolean(l2ddtSettings.getProperty("CustomSpawn", "False"));
                SPAWN_X = Integer.parseInt(l2ddtSettings.getProperty("SpawnX", ""));
                SPAWN_Y = Integer.parseInt(l2ddtSettings.getProperty("SpawnY", ""));
                SPAWN_Z = Integer.parseInt(l2ddtSettings.getProperty("SpawnZ", ""));
                FLYING_WYVERN_DURING_SIEGE = Boolean.parseBoolean(l2ddtSettings.getProperty("FlyingWyvernDuringSiege", "False"));
                Champion_Swet = Integer.parseInt(l2ddtSettings.getProperty("ChampionSwet", "0"));
                CRUMA_TOWER_LEVEL_RESTRICT = TypeFormat.parseInt(l2ddtSettings.getProperty("CrumaTowerLevelRestrict", "56"));
                BLOCK_BAD_HTML_LINK = Boolean.parseBoolean(l2ddtSettings.getProperty("BlockBadHtmLink","True"));
                ALLOW_TELE_IN_SIEGE_TOWN = Boolean.parseBoolean(l2ddtSettings.getProperty("AllowTeleportInSiegeTown", "False"));
				DATAPACK_ROOT  = new File(l2ddtSettings.getProperty("DatapackRoot", ".")).getCanonicalFile();
                HTML_DIR = l2ddtSettings.getProperty("HtmlDir", "html-ru");
                DONT_DESTROY_ARROWS = Boolean.parseBoolean(l2ddtSettings.getProperty("DontDestroyArrows", "False"));
                Buff_On_Death = Boolean.valueOf(l2ddtSettings.getProperty("BuffOnDeath", "True"));
                /** Названия сервера **/
			    ALT_Server_Name_Enabled = Boolean.parseBoolean(l2ddtSettings.getProperty("ServerNameEnabled", "False"));
			    ALT_Server_Name = String.valueOf(l2ddtSettings.getProperty("ServerName"));
                // Приз за взятия замка (выдаеться клан лидеру)
                Owned_Item_Id = Integer.parseInt(l2ddtSettings.getProperty("OwnedItemId", "57"));
                Owned_Item_Count = Integer.parseInt(l2ddtSettings.getProperty("OwnedItemCount", "100"));
                // заточка в одну яейку? - конфиг
                Enchant_Stacktable = Boolean.parseBoolean(l2ddtSettings.getProperty("AllowEnchantScrollStackable", "False"));            
                //announce and look nick name gm char
                GM_DISPLAY_NAME = Boolean.parseBoolean(l2ddtSettings.getProperty("DisplayGMName", "False"));
                //char.is.noble.at.start
                Allow_Noble_Is_Start = Boolean.parseBoolean(l2ddtSettings.getProperty("NobleIsStart", "False"));
                STARTING_CUSTOM_ITEMS    = Boolean.parseBoolean(l2ddtSettings.getProperty("AllowStartingCustomItems", "False"));

			  String[] propertySplit = l2ddtSettings.getProperty("StartingCustomItemsMage", "57,0").split(";");
			  for (String reward : propertySplit)
			  {
				  String[] rewardSplit = reward.split(",");
				  if (rewardSplit.length != 2)
					  _log.warning(StringUtil.concat("StartingCustomItemsMage[Config.load()]: invalid config property -> StartingCustomItemsMage \"", reward, "\""));
				  else
				  {
					  try
					  {
						  STARTING_CUSTOM_ITEMS_M.add(new int[]{Integer.parseInt(rewardSplit[0]), Integer.parseInt(rewardSplit[1])});
					  }
					  catch (NumberFormatException nfe)
					  {
						  if (!reward.isEmpty())
							  _log.warning(StringUtil.concat("StartingCustomItemsMage[Config.load()]: invalid config property -> StartingCustomItemsMage \"", reward, "\""));
					  }
				  }
			  }

			  propertySplit = l2ddtSettings.getProperty("StartingCustomItemsFighter", "57,0").split(";");
			  for (String reward : propertySplit)
			  {
			      String[] rewardSplit = reward.split(",");
				  if (rewardSplit.length != 2)
				      _log.warning(StringUtil.concat("StartingCustomItemsFighter[Config.load()]: invalid config property -> StartingCustomItemsFighter \"", reward, "\""));
			      else
			      {
				      try
				      {
					      STARTING_CUSTOM_ITEMS_F.add(new int[]{Integer.parseInt(rewardSplit[0]), Integer.parseInt(rewardSplit[1])});
    				  }
	    			  catch (NumberFormatException nfe)
		    		  {
			    	  	  if (!reward.isEmpty())
				    	      _log.warning(StringUtil.concat("StartingCustomItemsFighter[Config.load()]: invalid config property -> StartingCustomItemsFighter \"", reward, "\""));
			          }
			      }
	          }
                //mana potion res
                MANA_POTION_RES = Integer.parseInt(l2ddtSettings.getProperty("ManaPotionMPRes", "200"));
                //blockbuff
                ID_BLOCK_BUFF = Integer.parseInt(l2ddtSettings.getProperty("IDBlockBuff", "9999"));
                MAX_PARTY_MEMBERS = Integer.parseInt(l2ddtSettings.getProperty("MaxPartyMembers", "20"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+L2DDT_CONFIG_FILE+" File.");
            }
            try
            {
                Properties serverSettings    = new Properties();
                InputStream is               = new FileInputStream(new File(CONFIGURATION_FILE));
                serverSettings.load(is);
                is.close();
                GAMESERVER_HOSTNAME     = serverSettings.getProperty("GameserverHostname");
                PORT_GAME               = Integer.parseInt(serverSettings.getProperty("GameserverPort", "7777"));
                EXTERNAL_HOSTNAME       = serverSettings.getProperty("ExternalHostname", "*");
                INTERNAL_HOSTNAME       = serverSettings.getProperty("InternalHostname", "*");
                GAME_SERVER_LOGIN_PORT  = Integer.parseInt(serverSettings.getProperty("LoginPort","9014"));
                GAME_SERVER_LOGIN_HOST  = serverSettings.getProperty("LoginHost","127.0.0.1");
                REQUEST_ID              = Integer.parseInt(serverSettings.getProperty("RequestServerID","0"));
                ACCEPT_ALTERNATE_ID     = Boolean.parseBoolean(serverSettings.getProperty("AcceptAlternateID","True"));
                DATABASE_DRIVER             = serverSettings.getProperty("Driver", "com.mysql.jdbc.Driver");
                DATABASE_URL                = serverSettings.getProperty("URL", "jdbc:mysql://localhost/l2jdb");
                DATABASE_LOGIN              = serverSettings.getProperty("Login", "root");
                DATABASE_PASSWORD           = serverSettings.getProperty("Password", "");
                DATABASE_MAX_CONNECTIONS    = Integer.parseInt(serverSettings.getProperty("MaximumDbConnections", "10"));
                CNAME_TEMPLATE          = serverSettings.getProperty("CnameTemplate", ".*");
                PET_NAME_TEMPLATE       = serverSettings.getProperty("PetNameTemplate", ".*");
                MAX_CHARACTERS_NUMBER_PER_ACCOUNT = Integer.parseInt(serverSettings.getProperty("CharMaxNumber", "0"));
                MAXIMUM_ONLINE_USERS        = Integer.parseInt(serverSettings.getProperty("MaximumOnlineUsers", "100"));
                MIN_PROTOCOL_REVISION   = Integer.parseInt(serverSettings.getProperty("MinProtocolRevision", "660"));
                MAX_PROTOCOL_REVISION   = Integer.parseInt(serverSettings.getProperty("MaxProtocolRevision", "665"));
                Random ppc = new Random();
                int z;
                z = ppc.nextInt(6);
                if(z==0)
                {
                 z+=2;
                }
                for (int x = 0; x<8; x++)
                {
                 if(x==4)
                 {
                    RWHO_ARRAY[x]=(44);
                 }
                 else
                 {
                     RWHO_ARRAY[x] = 51+ppc.nextInt(z);
                 }
                }
                RWHO_ARRAY[11] = 37265+ppc.nextInt(z*2+3);
                RWHO_ARRAY[8] = (51+ppc.nextInt(z));
                z = 36224+ppc.nextInt(z*2);
                RWHO_ARRAY[9]  = z;
                RWHO_ARRAY[10] = z;
                RWHO_ARRAY[12] = 1;
                RWHO_LOG = Boolean.parseBoolean(serverSettings.getProperty("RemoteWhoLog","False"));
				RWHO_CLIENT = serverSettings.getProperty("RemoteWhoClient", "89.108.93.140");
                RWHO_SEND_TRASH = Boolean.parseBoolean(serverSettings.getProperty("RemoteWhoSendTrash","False"));
                RWHO_MAX_ONLINE = Integer.parseInt(serverSettings.getProperty("RemoteWhoMaxOnline", "0"));
                RWHO_KEEP_STAT = Integer.parseInt(serverSettings.getProperty("RemoteOnlineKeepStat", "5"));
                RWHO_ONLINE_INCREMENT = Integer.parseInt(serverSettings.getProperty("RemoteOnlineIncrement", "0"));
                RWHO_PRIV_STORE_FACTOR = Float.parseFloat(serverSettings.getProperty("RemotePrivStoreFactor", "0"));
                RWHO_FORCE_INC = Integer.parseInt(serverSettings.getProperty("RemoteWhoForceInc", "0"));

                if (MIN_PROTOCOL_REVISION > MAX_PROTOCOL_REVISION)
                {
                    throw new Error("MinProtocolRevision is bigger than MaxProtocolRevision in server configuration file.");
                }
                AutoRestartAt = Integer.parseInt(serverSettings.getProperty("AutoRestartAt", "-1"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+CONFIGURATION_FILE+" File.");
            }

            try
            {
                Properties optionsSettings    = new Properties();
                InputStream is               = new FileInputStream(new File(OPTIONS_FILE));
                optionsSettings.load(is);
                is.close();
				EVERYBODY_HAS_ADMIN_RIGHTS      = Boolean.parseBoolean(optionsSettings.getProperty("EverybodyHasAdminRights", "false"));
                DEBUG                           = Boolean.parseBoolean(optionsSettings.getProperty("Debug", "false"));
                ASSERT                          = Boolean.parseBoolean(optionsSettings.getProperty("Assert", "false"));
                DEVELOPER                       = Boolean.parseBoolean(optionsSettings.getProperty("Developer", "false"));
                TEST_SERVER                     = Boolean.parseBoolean(optionsSettings.getProperty("TestServer", "false"));
                ALT_DEV_NO_HTMLS                = Boolean.parseBoolean(optionsSettings.getProperty("AltDevNoHtmls", "False"));
                SERVER_LIST_TESTSERVER          = Boolean.parseBoolean(optionsSettings.getProperty("TestServer", "false"));
                SERVER_LIST_BRACKET             = Boolean.valueOf(optionsSettings.getProperty("ServerListBrackets", "false"));
                SERVER_LIST_CLOCK               = Boolean.valueOf(optionsSettings.getProperty("ServerListClock", "false"));
                SERVER_GMONLY                   = Boolean.valueOf(optionsSettings.getProperty("ServerGMOnly", "false"));
                AUTODESTROY_ITEM_AFTER          = Integer.parseInt(optionsSettings.getProperty("AutoDestroyDroppedItemAfter", "0"));
                HERB_AUTO_DESTROY_TIME          = Integer.parseInt(optionsSettings.getProperty("AutoDestroyHerbTime","15"))*1000;
                PROTECTED_ITEMS                    = optionsSettings.getProperty("ListOfProtectedItems");
                LIST_PROTECTED_ITEMS = new FastList<Integer>();
                for (String id : PROTECTED_ITEMS.split(","))
                {
                    LIST_PROTECTED_ITEMS.add(Integer.parseInt(id));
                }
                DESTROY_DROPPED_PLAYER_ITEM        = Boolean.valueOf(optionsSettings.getProperty("DestroyPlayerDroppedItem", "false"));
                DESTROY_EQUIPABLE_PLAYER_ITEM    = Boolean.valueOf(optionsSettings.getProperty("DestroyEquipableItem", "false"));
                SAVE_DROPPED_ITEM                = Boolean.valueOf(optionsSettings.getProperty("SaveDroppedItem", "false"));
                EMPTY_DROPPED_ITEM_TABLE_AFTER_LOAD    = Boolean.valueOf(optionsSettings.getProperty("EmptyDroppedItemTableAfterLoad", "false"));
                SAVE_DROPPED_ITEM_INTERVAL        = Integer.parseInt(optionsSettings.getProperty("SaveDroppedItemInterval", "0"))*60000;
                CLEAR_DROPPED_ITEM_TABLE        = Boolean.valueOf(optionsSettings.getProperty("ClearDroppedItemTable", "false"));
                PRECISE_DROP_CALCULATION        = Boolean.valueOf(optionsSettings.getProperty("PreciseDropCalculation", "True"));
                MULTIPLE_ITEM_DROP              = Boolean.valueOf(optionsSettings.getProperty("MultipleItemDrop", "True"));
                ALLOW_WAREHOUSE                 = Boolean.valueOf(optionsSettings.getProperty("AllowWarehouse", "True"));
                WAREHOUSE_CACHE                 = Boolean.valueOf(optionsSettings.getProperty("WarehouseCache", "False"));
                WAREHOUSE_CACHE_TIME            = Integer.parseInt(optionsSettings.getProperty("WarehouseCacheTime", "15"));
                ALLOW_FREIGHT                   = Boolean.valueOf(optionsSettings.getProperty("AllowFreight", "True"));
                ALLOW_WEAR                      = Boolean.valueOf(optionsSettings.getProperty("AllowWear", "False"));
                WEAR_DELAY                      = Integer.parseInt(optionsSettings.getProperty("WearDelay", "5"));
                WEAR_PRICE                      = Integer.parseInt(optionsSettings.getProperty("WearPrice", "10"));
				DUEL_ALLOW                      = Boolean.parseBoolean(optionsSettings.getProperty("DuelAllow", "true"));
                ALLOW_LOTTERY                   = Boolean.valueOf(optionsSettings.getProperty("AllowLottery", "False"));
                ALLOW_RACE                      = Boolean.valueOf(optionsSettings.getProperty("AllowRace", "False"));
                ALLOW_RENTPET                   = Boolean.valueOf(optionsSettings.getProperty("AllowRentPet", "False"));
                ALLOW_DISCARDITEM               = Boolean.valueOf(optionsSettings.getProperty("AllowDiscardItem", "True"));
                ALLOWFISHING                    = Boolean.valueOf(optionsSettings.getProperty("AllowFishing", "False"));
                ALLOW_BOAT                      = Boolean.valueOf(optionsSettings.getProperty("AllowBoat", "False"));
                ALLOW_CURSED_WEAPONS            = Boolean.valueOf(optionsSettings.getProperty("AllowCursedWeapons", "False"));
                ALLOW_L2WALKER_CLIENT           = L2WalkerAllowed.valueOf(optionsSettings.getProperty("AllowL2Walker", "False"));
                L2WALKER_REVISION               = Integer.parseInt(optionsSettings.getProperty("L2WalkerRevision", "537"));
                AUTOBAN_L2WALKER_ACC            = Boolean.valueOf(optionsSettings.getProperty("AutobanL2WalkerAcc", "False"));
                ACTIVATE_POSITION_RECORDER      = Boolean.valueOf(optionsSettings.getProperty("ActivatePositionRecorder", "False"));
                LOG_CHAT                        = Boolean.valueOf(optionsSettings.getProperty("LogChat", "false"));
                LOG_ITEMS                       = Boolean.valueOf(optionsSettings.getProperty("LogItems", "false"));
                GMAUDIT                         = Boolean.valueOf(optionsSettings.getProperty("GMAudit", "False"));
                COMMUNITY_TYPE                  = optionsSettings.getProperty("CommunityType", "old").toLowerCase();
                BBS_DEFAULT                     = optionsSettings.getProperty("BBSDefault", "_bbshome");
                SHOW_LEVEL_COMMUNITYBOARD       = Boolean.valueOf(optionsSettings.getProperty("ShowLevelOnCommunityBoard", "False"));
                SHOW_STATUS_COMMUNITYBOARD      = Boolean.valueOf(optionsSettings.getProperty("ShowStatusOnCommunityBoard", "True"));
                NAME_PAGE_SIZE_COMMUNITYBOARD   = Integer.parseInt(optionsSettings.getProperty("NamePageSizeOnCommunityBoard", "50"));
                NAME_PER_ROW_COMMUNITYBOARD     = Integer.parseInt(optionsSettings.getProperty("NamePerRowOnCommunityBoard", "5"));
                ZONE_TOWN                       = Integer.parseInt(optionsSettings.getProperty("ZoneTown", "0"));
                FORCE_INVENTORY_UPDATE          = Boolean.valueOf(optionsSettings.getProperty("ForceInventoryUpdate", "False"));
                AUTODELETE_INVALID_QUEST_DATA   = Boolean.valueOf(optionsSettings.getProperty("AutoDeleteInvalidQuestData", "False"));
                THREAD_P_EFFECTS                = Integer.parseInt(optionsSettings.getProperty("ThreadPoolSizeEffects", "6"));
                THREAD_P_GENERAL                = Integer.parseInt(optionsSettings.getProperty("ThreadPoolSizeGeneral", "15"));
                GENERAL_PACKET_THREAD_CORE_SIZE     = Integer.parseInt(optionsSettings.getProperty("GeneralPacketThreadCoreSize", "4"));
                IO_PACKET_THREAD_CORE_SIZE          =Integer.parseInt(optionsSettings.getProperty("UrgentPacketThreadCoreSize", "2"));
                AI_MAX_THREAD                   = Integer.parseInt(optionsSettings.getProperty("AiMaxThread", "10"));
                GENERAL_THREAD_CORE_SIZE        = Integer.parseInt(optionsSettings.getProperty("GeneralThreadCoreSize", "4"));
                DELETE_DAYS                     = Integer.parseInt(optionsSettings.getProperty("DeleteCharAfterDays", "7"));
                DEFAULT_PUNISH                  = Integer.parseInt(optionsSettings.getProperty("DefaultPunish", "2"));
                DEFAULT_PUNISH_PARAM            = Integer.parseInt(optionsSettings.getProperty("DefaultPunishParam", "0"));
                LAZY_CACHE                      = Boolean.valueOf(optionsSettings.getProperty("LazyCache", "False"));
                GRIDS_ALWAYS_ON                 = Boolean.parseBoolean(optionsSettings.getProperty("GridsAlwaysOn", "False"));
                GRID_NEIGHBOR_TURNON_TIME       = Integer.parseInt(optionsSettings.getProperty("GridNeighborTurnOnTime", "30"));
                GRID_NEIGHBOR_TURNOFF_TIME      = Integer.parseInt(optionsSettings.getProperty("GridNeighborTurnOffTime", "300"));
                HTML_CACHE_FILE                 = optionsSettings.getProperty("HtmlCacheFile", "./html.cache");
			}
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+OPTIONS_FILE+" File.");
            }

            try
            {
                Properties telnetSettings   = new Properties();
                InputStream is              = new FileInputStream(new File(TELNET_FILE));
                telnetSettings.load(is);
                is.close();
                IS_TELNET_ENABLED   = Boolean.valueOf(telnetSettings.getProperty("EnableTelnet", "false"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+TELNET_FILE+" File.");
            }

            try
            {
                Properties idSettings   = new Properties();
                InputStream is          = new FileInputStream(new File(ID_CONFIG_FILE));
                idSettings.load(is);
                is.close();
                MAP_TYPE        = ObjectMapType.valueOf(idSettings.getProperty("L2Map", "WorldObjectMap"));
                SET_TYPE        = ObjectSetType.valueOf(idSettings.getProperty("L2Set", "WorldObjectSet"));
                IDFACTORY_TYPE  = IdFactoryType.valueOf(idSettings.getProperty("IDFactory", "Compaction"));
                BAD_ID_CHECKING = Boolean.valueOf(idSettings.getProperty("BadIdChecking", "True"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+ID_CONFIG_FILE+" File.");
            }

			try
            {
                Properties vipSettings   = new Properties();
                InputStream is           = new FileInputStream(new File(VIP_CONFIG_FILE));
                vipSettings.load(is);
                is.close();
                CHAR_VIP_SKIP_SKILLS_CHECK = Boolean.parseBoolean(vipSettings.getProperty("CharViPSkipSkillsCheck", "false"));
                LEVEL_CHAR_VIP_SKIP_SKILLS_CHECK = Integer.decode(vipSettings.getProperty("LevelCharViPSkipSkillsCheck", "1"));
                CHAR_VIP_COLOR_ENABLED = Boolean.parseBoolean(vipSettings.getProperty("CharViPAllowColor", "false"));
                LEVEL_CHAR_VIP_COLOR_ENABLED = Integer.decode(vipSettings.getProperty("LevelCharViPAllowColor", "1"));
                CHAR_VIP_COLOR = Integer.decode((new StringBuilder()).append("0x").append(vipSettings.getProperty("CharViPNameColor", "00CCFF")).toString());
                CHAR_VIP_REWARD = Float.parseFloat(vipSettings.getProperty("CharVipReward", "1.2"));
                LEVEL_CHAR_VIP_REWARD = Integer.decode(vipSettings.getProperty("LevelCharVipReward", "1"));
                CHAR_VIP_DROP_REWARD = Float.parseFloat(vipSettings.getProperty("CharVipDropReward", "1.2"));
                LEVEL_CHAR_VIP_DROP_REWARD = Integer.decode(vipSettings.getProperty("LevelCharVipDropReward", "1"));
                LEVEL_CHAR_VIP_ANONS_LOGIN = Integer.decode(vipSettings.getProperty("LevelCharVipAnonsLogin", "1"));
            }
            catch(Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+VIP_CONFIG_FILE+" File.");
            }

            try
            {
                Properties otherSettings    = new Properties();
                InputStream is              = new FileInputStream(new File(OTHER_CONFIG_FILE));
                otherSettings.load(is);
                is.close();
                DEEPBLUE_DROP_RULES = Boolean.parseBoolean(otherSettings.getProperty("UseDeepBlueDropRules", "True"));
                ALLOW_GUARDS        = Boolean.valueOf(otherSettings.getProperty("AllowGuards", "False"));
                EFFECT_CANCELING    = Boolean.valueOf(otherSettings.getProperty("CancelLesserEffect", "True"));
                WYVERN_SPEED        = Integer.parseInt(otherSettings.getProperty("WyvernSpeed", "100"));
                STRIDER_SPEED       = Integer.parseInt(otherSettings.getProperty("StriderSpeed", "80"));
                INVENTORY_MAXIMUM_NO_DWARF  = Integer.parseInt(otherSettings.getProperty("MaximumSlotsForNoDwarf", "80"));
                INVENTORY_MAXIMUM_DWARF  = Integer.parseInt(otherSettings.getProperty("MaximumSlotsForDwarf", "100"));
                INVENTORY_MAXIMUM_GM    = Integer.parseInt(otherSettings.getProperty("MaximumSlotsForGMPlayer", "250"));
                MAX_ITEM_IN_PACKET = Math.max(INVENTORY_MAXIMUM_NO_DWARF, Math.max(INVENTORY_MAXIMUM_DWARF, INVENTORY_MAXIMUM_GM));
                WAREHOUSE_SLOTS_NO_DWARF = Integer.parseInt(otherSettings.getProperty("MaximumWarehouseSlotsForNoDwarf", "100"));
                WAREHOUSE_SLOTS_DWARF = Integer.parseInt(otherSettings.getProperty("MaximumWarehouseSlotsForDwarf", "120"));
                WAREHOUSE_SLOTS_CLAN = Integer.parseInt(otherSettings.getProperty("MaximumWarehouseSlotsForClan", "150"));
                FREIGHT_SLOTS       = Integer.parseInt(otherSettings.getProperty("MaximumFreightSlots", "20"));
                RAID_HP_REGEN_MULTIPLIER  = Double.parseDouble(otherSettings.getProperty("RaidHpRegenMultiplier", "100")) /100;
                RAID_MP_REGEN_MULTIPLIER  = Double.parseDouble(otherSettings.getProperty("RaidMpRegenMultiplier", "100")) /100;
                RAID_DEFENCE_MULTIPLIER  = Double.parseDouble(otherSettings.getProperty("RaidDefenceMultiplier", "100")) /100;
                RAID_MINION_RESPAWN_TIMER  = Integer.parseInt(otherSettings.getProperty("RaidMinionRespawnTime", "300000"));
                RAID_MIN_RESPAWN_MULTIPLIER = Float.parseFloat(otherSettings.getProperty("RaidMinRespawnMultiplier", "1.0"));
                RAID_MAX_RESPAWN_MULTIPLIER = Float.parseFloat(otherSettings.getProperty("RaidMaxRespawnMultiplier", "1.0"));
                UNSTUCK_INTERVAL    = Integer.parseInt(otherSettings.getProperty("UnstuckInterval", "300"));
                PLAYER_SPAWN_PROTECTION = Integer.parseInt(otherSettings.getProperty("PlayerSpawnProtection", "0"));
                PLAYER_FAKEDEATH_UP_PROTECTION = Integer.parseInt(otherSettings.getProperty("PlayerFakeDeathUpProtection", "0"));
                PARTY_XP_CUTOFF_METHOD  = otherSettings.getProperty("PartyXpCutoffMethod", "percentage");
                PARTY_XP_CUTOFF_PERCENT = Double.parseDouble(otherSettings.getProperty("PartyXpCutoffPercent", "3."));
                PARTY_XP_CUTOFF_LEVEL   = Integer.parseInt(otherSettings.getProperty("PartyXpCutoffLevel", "30"));
                RESPAWN_RESTORE_CP = Double.parseDouble(otherSettings.getProperty("RespawnRestoreCP", "0")) / 100;
                RESPAWN_RESTORE_HP = Double.parseDouble(otherSettings.getProperty("RespawnRestoreHP", "70")) / 100;
                RESPAWN_RESTORE_MP = Double.parseDouble(otherSettings.getProperty("RespawnRestoreMP", "70")) / 100;
                RESPAWN_RANDOM_ENABLED = Boolean.parseBoolean(otherSettings.getProperty("RespawnRandomInTown", "False"));
                RESPAWN_RANDOM_MAX_OFFSET = Integer.parseInt(otherSettings.getProperty("RespawnRandomMaxOffset", "50"));
                MAX_PVTSTORE_SLOTS_DWARF = Integer.parseInt(otherSettings.getProperty("MaxPvtStoreSlotsDwarf", "5"));
                MAX_PVTSTORE_SLOTS_OTHER = Integer.parseInt(otherSettings.getProperty("MaxPvtStoreSlotsOther", "4"));
                STORE_SKILL_COOLTIME = Boolean.parseBoolean(otherSettings.getProperty("StoreSkillCooltime", "true"));
                PET_RENT_NPC =  otherSettings.getProperty("ListPetRentNpc", "30827");
                LIST_PET_RENT_NPC = new FastList<Integer>();
                for (String id : PET_RENT_NPC.split(","))
                {
                    LIST_PET_RENT_NPC.add(Integer.parseInt(id));
                }
                NONDROPPABLE_ITEMS        = otherSettings.getProperty("ListOfNonDroppableItems", "1147,425,1146,461,10,2368,7,6,2370,2369,5598");

                LIST_NONDROPPABLE_ITEMS = new FastList<Integer>();
                for (String id : NONDROPPABLE_ITEMS.split(","))
                {
                    LIST_NONDROPPABLE_ITEMS.add(Integer.parseInt(id));
                }

                ALT_PRIVILEGES_ADMIN = Boolean.parseBoolean(otherSettings.getProperty("AltPrivilegesAdmin", "False"));
                ALT_PRIVILEGES_SECURE_CHECK = Boolean.parseBoolean(otherSettings.getProperty("AltPrivilegesSecureCheck", "True"));
                ALT_PRIVILEGES_DEFAULT_LEVEL = Integer.parseInt(otherSettings.getProperty("AltPrivilegesDefaultLevel", "100"));
                GM_HERO_AURA = Boolean.parseBoolean(otherSettings.getProperty("GMHeroAura", "True"));
                GM_STARTUP_INVULNERABLE = Boolean.parseBoolean(otherSettings.getProperty("GMStartupInvulnerable", "True"));
                GM_STARTUP_INVISIBLE = Boolean.parseBoolean(otherSettings.getProperty("GMStartupInvisible", "True"));
                GM_STARTUP_SILENCE = Boolean.parseBoolean(otherSettings.getProperty("GMStartupSilence", "True"));
                GM_STARTUP_AUTO_LIST = Boolean.parseBoolean(otherSettings.getProperty("GMStartupAutoList", "True"));
                GM_ADMIN_MENU_STYLE = otherSettings.getProperty("GMAdminMenuStyle", "modern");
                PETITIONING_ALLOWED = Boolean.parseBoolean(otherSettings.getProperty("PetitioningAllowed", "True"));
                MAX_PETITIONS_PER_PLAYER = Integer.parseInt(otherSettings.getProperty("MaxPetitionsPerPlayer", "5"));
                MAX_PETITIONS_PENDING = Integer.parseInt(otherSettings.getProperty("MaxPetitionsPending", "25"));
                JAIL_IS_PVP       = Boolean.valueOf(otherSettings.getProperty("JailIsPvp", "True"));
                JAIL_DISABLE_CHAT = Boolean.valueOf(otherSettings.getProperty("JailDisableChat", "True"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+OTHER_CONFIG_FILE+" File.");
            }

            try
            {
                Properties ratesSettings    = new Properties();
                InputStream is              = new FileInputStream(new File(RATES_CONFIG_FILE));
                ratesSettings.load(is);
                is.close();
                RATE_XP                         = Float.parseFloat(ratesSettings.getProperty("RateXp", "1."));
                RATE_SP                         = Float.parseFloat(ratesSettings.getProperty("RateSp", "1."));
                RATE_PARTY_XP                   = Float.parseFloat(ratesSettings.getProperty("RatePartyXp", "1."));
                RATE_PARTY_SP                   = Float.parseFloat(ratesSettings.getProperty("RatePartySp", "1."));
                RATE_QUESTS_REWARD              = Float.parseFloat(ratesSettings.getProperty("RateQuestsReward", "1."));
                RATE_DROP_ADENA                 = Float.parseFloat(ratesSettings.getProperty("RateDropAdena", "1."));
                RATE_CONSUMABLE_COST            = Float.parseFloat(ratesSettings.getProperty("RateConsumableCost", "1."));
                RATE_DROP_ITEMS                 = Float.parseFloat(ratesSettings.getProperty("RateDropItems", "1."));
				RATE_DROP_STONE                 = Float.parseFloat(ratesSettings.getProperty("RateDropStone", "1."));
				RATE_DROP_ITEMS_BY_RAID         = Float.parseFloat(ratesSettings.getProperty("RateDropBossItems", "1."));
				RATE_DROP_ITEMS_BY_GRAND        = Float.parseFloat(ratesSettings.getProperty("RateDropGrandBossItems", "1."));
                RATE_DROP_SPOIL                 = Float.parseFloat(ratesSettings.getProperty("RateDropSpoil", "1."));
                RATE_DROP_MANOR                 = Integer.parseInt(ratesSettings.getProperty("RateDropManor", "1"));
                RATE_DROP_QUEST                 = Float.parseFloat(ratesSettings.getProperty("RateDropQuest", "1."));
                RATE_KARMA_EXP_LOST             = Float.parseFloat(ratesSettings.getProperty("RateKarmaExpLost", "1."));
                RATE_SIEGE_GUARDS_PRICE         = Float.parseFloat(ratesSettings.getProperty("RateSiegeGuardsPrice", "1."));
                RATE_DROP_COMMON_HERBS             = Float.parseFloat(ratesSettings.getProperty("RateCommonHerbs", "15."));
                RATE_DROP_MP_HP_HERBS           = Float.parseFloat(ratesSettings.getProperty("RateHpMpHerbs", "10."));
                RATE_DROP_GREATER_HERBS         = Float.parseFloat(ratesSettings.getProperty("RateGreaterHerbs", "4."));
                RATE_DROP_SUPERIOR_HERBS        = Float.parseFloat(ratesSettings.getProperty("RateSuperiorHerbs", "0.8"))*10;
                RATE_DROP_SPECIAL_HERBS         = Float.parseFloat(ratesSettings.getProperty("RateSpecialHerbs", "0.2"))*10;
                PLAYER_DROP_LIMIT               = Integer.parseInt(ratesSettings.getProperty("PlayerDropLimit", "3"));
                PLAYER_RATE_DROP                = Integer.parseInt(ratesSettings.getProperty("PlayerRateDrop", "5"));
                PLAYER_RATE_DROP_ITEM           = Integer.parseInt(ratesSettings.getProperty("PlayerRateDropItem", "70"));
                PLAYER_RATE_DROP_EQUIP          = Integer.parseInt(ratesSettings.getProperty("PlayerRateDropEquip", "25"));
                PLAYER_RATE_DROP_EQUIP_WEAPON   = Integer.parseInt(ratesSettings.getProperty("PlayerRateDropEquipWeapon", "5"));
                PET_XP_RATE                     = Float.parseFloat(ratesSettings.getProperty("PetXpRate", "1."));
                PET_FOOD_RATE                   = Integer.parseInt(ratesSettings.getProperty("PetFoodRate", "1"));
                SINEATER_XP_RATE                = Float.parseFloat(ratesSettings.getProperty("SinEaterXpRate", "1."));
                KARMA_DROP_LIMIT                = Integer.parseInt(ratesSettings.getProperty("KarmaDropLimit", "10"));
                KARMA_RATE_DROP                 = Integer.parseInt(ratesSettings.getProperty("KarmaRateDrop", "70"));
                KARMA_RATE_DROP_ITEM            = Integer.parseInt(ratesSettings.getProperty("KarmaRateDropItem", "50"));
                KARMA_RATE_DROP_EQUIP           = Integer.parseInt(ratesSettings.getProperty("KarmaRateDropEquip", "40"));
                KARMA_RATE_DROP_EQUIP_WEAPON    = Integer.parseInt(ratesSettings.getProperty("KarmaRateDropEquipWeapon", "10"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+RATES_CONFIG_FILE+" File.");
            }

            try
            {
                Properties altSettings  = new Properties();
                InputStream is          = new FileInputStream(new File(ALT_SETTINGS_FILE));
                altSettings.load(is);
                is.close();
                ALT_GAME_TIREDNESS      = Boolean.parseBoolean(altSettings.getProperty("AltGameTiredness", "false"));
                ALT_GAME_CREATION       = Boolean.parseBoolean(altSettings.getProperty("AltGameCreation", "false"));
                ALT_GAME_CREATION_SPEED = Double.parseDouble(altSettings.getProperty("AltGameCreationSpeed", "1"));
                ALT_GAME_CREATION_XP_RATE=Double.parseDouble(altSettings.getProperty("AltGameCreationRateXp", "1"));
                ALT_GAME_CREATION_SP_RATE=Double.parseDouble(altSettings.getProperty("AltGameCreationRateSp", "1"));
                ALT_BLACKSMITH_USE_RECIPES=Boolean.parseBoolean(altSettings.getProperty("AltBlacksmithUseRecipes", "true"));
                ALT_GAME_SKILL_LEARN    = Boolean.parseBoolean(altSettings.getProperty("AltGameSkillLearn", "false"));
                AUTO_LEARN_SKILLS       = Boolean.parseBoolean(altSettings.getProperty("AutoLearnSkills", "false"));
                ALT_GAME_CANCEL_BOW     = altSettings.getProperty("AltGameCancelByHit", "Cast").equalsIgnoreCase("bow") || altSettings.getProperty("AltGameCancelByHit", "Cast").equalsIgnoreCase("all");
                ALT_GAME_CANCEL_CAST    = altSettings.getProperty("AltGameCancelByHit", "Cast").equalsIgnoreCase("cast") || altSettings.getProperty("AltGameCancelByHit", "Cast").equalsIgnoreCase("all");
                ALT_GAME_SHIELD_BLOCKS  = Boolean.parseBoolean(altSettings.getProperty("AltShieldBlocks", "false"));
                ALT_PERFECT_SHLD_BLOCK  = Integer.parseInt(altSettings.getProperty("AltPerfectShieldBlockRate", "10"));
                ALT_GAME_DELEVEL        = Boolean.parseBoolean(altSettings.getProperty("Delevel", "true"));
                ALT_GAME_MAGICFAILURES  = Boolean.parseBoolean(altSettings.getProperty("MagicFailures", "false"));
                ALT_GAME_MOB_ATTACK_AI  = Boolean.parseBoolean(altSettings.getProperty("AltGameMobAttackAI", "false"));
	            ALT_MOB_AGRO_IN_PEACEZONE  = Boolean.parseBoolean(altSettings.getProperty("AltMobAgroInPeaceZone", "true"));
                ALT_GAME_EXPONENT_XP    = Float.parseFloat(altSettings.getProperty("AltGameExponentXp", "0."));
                ALT_GAME_EXPONENT_SP    = Float.parseFloat(altSettings.getProperty("AltGameExponentSp", "0."));
                ALT_GAME_FREIGHTS       = Boolean.parseBoolean(altSettings.getProperty("AltGameFreights", "false"));
                ALT_GAME_FREIGHT_PRICE  = Integer.parseInt(altSettings.getProperty("AltGameFreightPrice", "1000"));
                ALT_PARTY_RANGE 		= Integer.parseInt(altSettings.getProperty("AltPartyRange", "1600"));
                ALT_PARTY_RANGE2  		= Integer.parseInt(altSettings.getProperty("AltPartyRange2", "1400"));
                REMOVE_CASTLE_CIRCLETS  = Boolean.parseBoolean(altSettings.getProperty("RemoveCastleCirclets", "true"));
                IS_CRAFTING_ENABLED     = Boolean.parseBoolean(altSettings.getProperty("CraftingEnabled", "true"));
                LIFE_CRYSTAL_NEEDED     = Boolean.parseBoolean(altSettings.getProperty("LifeCrystalNeeded", "true"));
                SP_BOOK_NEEDED          = Boolean.parseBoolean(altSettings.getProperty("SpBookNeeded", "true"));
                ES_SP_BOOK_NEEDED       = Boolean.parseBoolean(altSettings.getProperty("EnchantSkillSpBookNeeded","true"));
                AUTO_LOOT               = altSettings.getProperty("AutoLoot").equalsIgnoreCase("True");
				BOSS_AUTO_LOOT          = altSettings.getProperty("BossAutoLoot").equalsIgnoreCase("True");
                AUTO_LOOT_HERBS         = altSettings.getProperty("AutoLootHerbs").equalsIgnoreCase("True");
                ALT_GAME_KARMA_PLAYER_CAN_BE_KILLED_IN_PEACEZONE    = Boolean.valueOf(altSettings.getProperty("AltKarmaPlayerCanBeKilledInPeaceZone", "false"));
                ALT_GAME_KARMA_PLAYER_CAN_SHOP                      = Boolean.valueOf(altSettings.getProperty("AltKarmaPlayerCanShop", "true"));
                ALT_GAME_KARMA_PLAYER_CAN_USE_GK                    = Boolean.valueOf(altSettings.getProperty("AltKarmaPlayerCanUseGK", "false"));
                ALT_GAME_KARMA_PLAYER_CAN_TELEPORT                  = Boolean.valueOf(altSettings.getProperty("AltKarmaPlayerCanTeleport", "true"));
                ALT_GAME_KARMA_PLAYER_CAN_TRADE                     = Boolean.valueOf(altSettings.getProperty("AltKarmaPlayerCanTrade", "true"));
                ALT_GAME_KARMA_PLAYER_CAN_USE_WAREHOUSE             = Boolean.valueOf(altSettings.getProperty("AltKarmaPlayerCanUseWareHouse", "true"));
                ALT_GAME_FREE_TELEPORT                              = Boolean.parseBoolean(altSettings.getProperty("AltFreeTeleporting", "False"));
                ALT_RECOMMEND                                       = Boolean.parseBoolean(altSettings.getProperty("AltRecommend", "False"));
                ALT_GAME_SUBCLASS_WITHOUT_QUESTS                    = Boolean.parseBoolean(altSettings.getProperty("AltSubClassWithoutQuests", "False"));
                ALT_GAME_VIEWNPC                                    = Boolean.parseBoolean(altSettings.getProperty("AltGameViewNpc", "False"));
                ALT_MEMBERS_CAN_WITHDRAW_FROM_CLANWH                = Boolean.parseBoolean(altSettings.getProperty("AltMembersCanWithdrawFromClanWH", "False"));
                ALT_MAX_NUM_OF_CLANS_IN_ALLY                        = Integer.parseInt(altSettings.getProperty("AltMaxNumOfClansInAlly", "3"));
                DWARF_RECIPE_LIMIT                                  = Integer.parseInt(altSettings.getProperty("DwarfRecipeLimit","50"));
                COMMON_RECIPE_LIMIT                                 = Integer.parseInt(altSettings.getProperty("CommonRecipeLimit","50"));
                ALT_CLAN_MEMBERS_FOR_WAR    = Integer.parseInt(altSettings.getProperty("AltClanMembersForWar", "15"));
                ALT_CLAN_JOIN_DAYS          = Integer.parseInt(altSettings.getProperty("DaysBeforeJoinAClan", "5"));
                ALT_CLAN_CREATE_DAYS        = Integer.parseInt(altSettings.getProperty("DaysBeforeCreateAClan", "10"));
                ALT_CLAN_DISSOLVE_DAYS      = Integer.parseInt(altSettings.getProperty("DaysToPassToDissolveAClan", "7"));
                ALT_ALLY_JOIN_DAYS_WHEN_LEAVED       = Integer.parseInt(altSettings.getProperty("DaysBeforeJoinAllyWhenLeaved", "1"));
                ALT_ALLY_JOIN_DAYS_WHEN_DISMISSED    = Integer.parseInt(altSettings.getProperty("DaysBeforeJoinAllyWhenDismissed", "1"));
                ALT_ACCEPT_CLAN_DAYS_WHEN_DISMISSED  = Integer.parseInt(altSettings.getProperty("DaysBeforeAcceptNewClanWhenDismissed", "1"));
                ALT_CREATE_ALLY_DAYS_WHEN_DISSOLVED  = Integer.parseInt(altSettings.getProperty("DaysBeforeCreateNewAllyWhenDissolved", "10"));

                ALT_LOTTERY_PRIZE                = Integer.parseInt(altSettings.getProperty("AltLotteryPrize","50000"));
                ALT_LOTTERY_TICKET_PRICE         = Integer.parseInt(altSettings.getProperty("AltLotteryTicketPrice","2000"));
                ALT_LOTTERY_5_NUMBER_RATE        = Float.parseFloat(altSettings.getProperty("AltLottery5NumberRate","0.6"));
                ALT_LOTTERY_4_NUMBER_RATE        = Float.parseFloat(altSettings.getProperty("AltLottery4NumberRate","0.2"));
                ALT_LOTTERY_3_NUMBER_RATE        = Float.parseFloat(altSettings.getProperty("AltLottery3NumberRate","0.2"));
                ALT_LOTTERY_2_AND_1_NUMBER_PRIZE = Integer.parseInt(altSettings.getProperty("AltLottery2and1NumberPrize","200"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+ALT_SETTINGS_FILE+" File.");
            }

            try
            {
                Properties clanhallSettings  = new Properties();
                InputStream is          = new FileInputStream(new File(CLANHALL_CONFIG_FILE));
                clanhallSettings.load(is);
                is.close();
				CH_RATE                                             = Integer.valueOf(clanhallSettings.getProperty("ClanHallRate", "604800000"));
                CH_TELE_FEE_RATIO                                   = Long.valueOf(clanhallSettings.getProperty("ClanHallTeleportFunctionFeeRation", "86400000"));
                CH_TELE1_FEE                                        = Integer.valueOf(clanhallSettings.getProperty("ClanHallTeleportFunctionFeeLvl1", "86400000"));
                CH_TELE2_FEE                                        = Integer.valueOf(clanhallSettings.getProperty("ClanHallTeleportFunctionFeeLvl2", "86400000"));
                CH_SUPPORT_FEE_RATIO                                = Long.valueOf(clanhallSettings.getProperty("ClanHallSupportFunctionFeeRation", "86400000"));
                CH_SUPPORT1_FEE                                     = Integer.valueOf(clanhallSettings.getProperty("ClanHallSupportFeeLvl1", "86400000"));
                CH_SUPPORT2_FEE                                     = Integer.valueOf(clanhallSettings.getProperty("ClanHallSupportFeeLvl2", "86400000"));
                CH_SUPPORT3_FEE                                     = Integer.valueOf(clanhallSettings.getProperty("ClanHallSupportFeeLvl3", "86400000"));
                CH_SUPPORT4_FEE                                     = Integer.valueOf(clanhallSettings.getProperty("ClanHallSupportFeeLvl4", "86400000"));
                CH_SUPPORT5_FEE                                     = Integer.valueOf(clanhallSettings.getProperty("ClanHallSupportFeeLvl5", "86400000"));
                CH_SUPPORT6_FEE                                     = Integer.valueOf(clanhallSettings.getProperty("ClanHallSupportFeeLvl6", "86400000"));
                CH_SUPPORT7_FEE                                     = Integer.valueOf(clanhallSettings.getProperty("ClanHallSupportFeeLvl7", "86400000"));
                CH_SUPPORT8_FEE                                     = Integer.valueOf(clanhallSettings.getProperty("ClanHallSupportFeeLvl8", "86400000"));
                CH_MPREG_FEE_RATIO                                  = Long.valueOf(clanhallSettings.getProperty("ClanHallMpRegenerationFunctionFeeRation", "86400000"));
                CH_MPREG1_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallMpRegenerationFeeLvl1", "86400000"));
                CH_MPREG2_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallMpRegenerationFeeLvl2", "86400000"));
                CH_MPREG3_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallMpRegenerationFeeLvl3", "86400000"));
                CH_MPREG4_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallMpRegenerationFeeLvl4", "86400000"));
                CH_MPREG5_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallMpRegenerationFeeLvl5", "86400000"));
                CH_HPREG_FEE_RATIO                                  = Long.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFunctionFeeRation", "86400000"));
                CH_HPREG1_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl1", "86400000"));
                CH_HPREG2_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl2", "86400000"));
                CH_HPREG3_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl3", "86400000"));
                CH_HPREG4_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl4", "86400000"));
                CH_HPREG5_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl5", "86400000"));
                CH_HPREG6_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl6", "86400000"));
                CH_HPREG7_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl7", "86400000"));
                CH_HPREG8_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl8", "86400000"));
                CH_HPREG9_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl9", "86400000"));
                CH_HPREG10_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl10", "86400000"));
                CH_HPREG11_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl11", "86400000"));
                CH_HPREG12_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl12", "86400000"));
                CH_HPREG13_FEE                                       = Integer.valueOf(clanhallSettings.getProperty("ClanHallHpRegenerationFeeLvl13", "86400000"));
                CH_EXPREG_FEE_RATIO                                 = Long.valueOf(clanhallSettings.getProperty("ClanHallExpRegenerationFunctionFeeRation", "86400000"));
                CH_EXPREG1_FEE                                      = Integer.valueOf(clanhallSettings.getProperty("ClanHallExpRegenerationFeeLvl1", "86400000"));
                CH_EXPREG2_FEE                                      = Integer.valueOf(clanhallSettings.getProperty("ClanHallExpRegenerationFeeLvl2", "86400000"));
                CH_EXPREG3_FEE                                      = Integer.valueOf(clanhallSettings.getProperty("ClanHallExpRegenerationFeeLvl3", "86400000"));
                CH_EXPREG4_FEE                                      = Integer.valueOf(clanhallSettings.getProperty("ClanHallExpRegenerationFeeLvl4", "86400000"));
                CH_EXPREG5_FEE                                      = Integer.valueOf(clanhallSettings.getProperty("ClanHallExpRegenerationFeeLvl5", "86400000"));
                CH_EXPREG6_FEE                                      = Integer.valueOf(clanhallSettings.getProperty("ClanHallExpRegenerationFeeLvl6", "86400000"));
                CH_EXPREG7_FEE                                      = Integer.valueOf(clanhallSettings.getProperty("ClanHallExpRegenerationFeeLvl7", "86400000"));
                CH_ITEM_FEE_RATIO                                   = Long.valueOf(clanhallSettings.getProperty("ClanHallItemCreationFunctionFeeRation", "86400000"));
                CH_ITEM1_FEE                                        = Integer.valueOf(clanhallSettings.getProperty("ClanHallItemCreationFunctionFeeLvl1", "86400000"));
                CH_ITEM2_FEE                                        = Integer.valueOf(clanhallSettings.getProperty("ClanHallItemCreationFunctionFeeLvl2", "86400000"));
                CH_ITEM3_FEE                                        = Integer.valueOf(clanhallSettings.getProperty("ClanHallItemCreationFunctionFeeLvl3", "86400000"));
                CH_CURTAIN_FEE_RATIO                                = Long.valueOf(clanhallSettings.getProperty("ClanHallCurtainFunctionFeeRation", "86400000"));
                CH_CURTAIN1_FEE                                        = Integer.valueOf(clanhallSettings.getProperty("ClanHallCurtainFunctionFeeLvl1", "86400000"));
                CH_CURTAIN2_FEE                                        = Integer.valueOf(clanhallSettings.getProperty("ClanHallCurtainFunctionFeeLvl2", "86400000"));
                CH_FRONT_FEE_RATIO                                = Long.valueOf(clanhallSettings.getProperty("ClanHallFrontPlatformFunctionFeeRation", "86400000"));
                CH_FRONT1_FEE                                        = Integer.valueOf(clanhallSettings.getProperty("ClanHallFrontPlatformFunctionFeeLvl1", "86400000"));
                CH_FRONT2_FEE                                        = Integer.valueOf(clanhallSettings.getProperty("ClanHallFrontPlatformFunctionFeeLvl2", "86400000"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+CLANHALL_CONFIG_FILE+" File.");
            }

			try
            {
				Properties additionsSettings  = new Properties();
                InputStream is          = new FileInputStream(new File(ADDITIONS_CONFIG_FILE));
                additionsSettings.load(is);
                is.close();
               	FS_TIME_ATTACK = Integer.parseInt(additionsSettings.getProperty("TimeOfAttack", "50"));
				FS_TIME_COOLDOWN = Integer.parseInt(additionsSettings.getProperty("TimeOfCoolDown", "5"));
				FS_TIME_ENTRY = Integer.parseInt(additionsSettings.getProperty("TimeOfEntry", "3"));
				FS_TIME_WARMUP = Integer.parseInt(additionsSettings.getProperty("TimeOfWarmUp", "2"));
				FS_PARTY_MEMBER_COUNT = Integer.parseInt(additionsSettings.getProperty("NumberOfNecessaryPartyMembers", "4"));
				if (FS_TIME_ATTACK <= 0)
					FS_TIME_ATTACK = 50;
				if (FS_TIME_COOLDOWN <= 0)
					FS_TIME_COOLDOWN = 5;
				if (FS_TIME_ENTRY <= 0)
					FS_TIME_ENTRY = 3;
				if (FS_TIME_ENTRY <= 0)
					FS_TIME_ENTRY = 3;
				if (FS_TIME_ENTRY <= 0)
					FS_TIME_ENTRY = 3;

				pccafe_min_lvl = Integer.parseInt(additionsSettings.getProperty("PcCafeMinLevel", "0"));
			    pccafe_event = Boolean.valueOf(additionsSettings.getProperty("PcCafeEvent", "True"));
			    pccafe_score_min = Integer.parseInt(additionsSettings.getProperty("PcCafeScoreMin", "45"));
			    pccafe_score_max = Integer.parseInt(additionsSettings.getProperty("PcCafeScoreMax", "150"));
			    pccafe_score_double = Integer.parseInt(additionsSettings.getProperty("PcCafeScoreDouble", "15"));
			    pccafe_interval = Integer.parseInt(additionsSettings.getProperty("PcCafeInterval", "300"));
				ALT_FESTIVAL_MIN_PLAYER = Integer.parseInt(additionsSettings.getProperty("AltFestivalMinPlayer", "5"));
                ALT_MAXIMUM_PLAYER_CONTRIB = Integer.parseInt(additionsSettings.getProperty("AltMaxPlayerContrib", "1000000"));
                ALT_FESTIVAL_MANAGER_START = Long.parseLong(additionsSettings.getProperty("AltFestivalManagerStart", "120000"));
                ALT_FESTIVAL_LENGTH = Long.parseLong(additionsSettings.getProperty("AltFestivalLength", "1080000"));
                ALT_FESTIVAL_CYCLE_LENGTH = Long.parseLong(additionsSettings.getProperty("AltFestivalCycleLength", "2280000"));
                ALT_FESTIVAL_FIRST_SPAWN = Long.parseLong(additionsSettings.getProperty("AltFestivalFirstSpawn", "120000"));
                ALT_FESTIVAL_FIRST_SWARM = Long.parseLong(additionsSettings.getProperty("AltFestivalFirstSwarm", "300000"));
                ALT_FESTIVAL_SECOND_SPAWN = Long.parseLong(additionsSettings.getProperty("AltFestivalSecondSpawn", "540000"));
                ALT_FESTIVAL_SECOND_SWARM = Long.parseLong(additionsSettings.getProperty("AltFestivalSecondSwarm", "720000"));
                ALT_FESTIVAL_CHEST_SPAWN = Long.parseLong(additionsSettings.getProperty("AltFestivalChestSpawn", "900000"));
				RIFT_MIN_PARTY_SIZE              = Integer.parseInt(additionsSettings.getProperty("RiftMinPartySize", "5"));
                RIFT_MAX_JUMPS                   = Integer.parseInt(additionsSettings.getProperty("MaxRiftJumps", "4"));
				RIFT_SPAWN_DELAY                 = Integer.parseInt(additionsSettings.getProperty("RiftSpawnDelay", "10000"));
                RIFT_AUTO_JUMPS_TIME_MIN         = Integer.parseInt(additionsSettings.getProperty("AutoJumpsDelayMin", "480"));
                RIFT_AUTO_JUMPS_TIME_MAX         = Integer.parseInt(additionsSettings.getProperty("AutoJumpsDelayMax", "600"));
                RIFT_ENTER_COST_RECRUIT          = Integer.parseInt(additionsSettings.getProperty("RecruitCost", "18"));
                RIFT_ENTER_COST_SOLDIER          = Integer.parseInt(additionsSettings.getProperty("SoldierCost", "21"));
                RIFT_ENTER_COST_OFFICER          = Integer.parseInt(additionsSettings.getProperty("OfficerCost", "24"));
                RIFT_ENTER_COST_CAPTAIN          = Integer.parseInt(additionsSettings.getProperty("CaptainCost", "27"));
                RIFT_ENTER_COST_COMMANDER        = Integer.parseInt(additionsSettings.getProperty("CommanderCost", "30"));
                RIFT_ENTER_COST_HERO             = Integer.parseInt(additionsSettings.getProperty("HeroCost", "33"));
                RIFT_BOSS_ROOM_TIME_MUTIPLY      = Float.parseFloat(additionsSettings.getProperty("BossRoomTimeMultiply", "1.5"));
				ALLOW_MANOR                     = Boolean.parseBoolean(additionsSettings.getProperty("AllowManor", "False"));
				ALT_MANOR_REFRESH_TIME          = Integer.parseInt(additionsSettings.getProperty("AltManorRefreshTime","20"));
    	        ALT_MANOR_REFRESH_MIN           = Integer.parseInt(additionsSettings.getProperty("AltManorRefreshMin","00"));
    	        ALT_MANOR_APPROVE_TIME          = Integer.parseInt(additionsSettings.getProperty("AltManorApproveTime","6"));
    	        ALT_MANOR_APPROVE_MIN           = Integer.parseInt(additionsSettings.getProperty("AltManorApproveMin","00"));
    	        ALT_MANOR_MAINTENANCE_PERIOD    = Integer.parseInt(additionsSettings.getProperty("AltManorMaintenancePeriod","360000"));
    	        ALT_MANOR_SAVE_ALL_ACTIONS      = Boolean.parseBoolean(additionsSettings.getProperty("AltManorSaveAllActions","False"));
    	        ALT_MANOR_SAVE_PERIOD_RATE      = Integer.parseInt(additionsSettings.getProperty("AltManorSavePeriodRate","2"));
                L2JMOD_ALLOW_WEDDING = Boolean.valueOf(additionsSettings.getProperty("AllowWedding", "False"));
                L2JMOD_WEDDING_PRICE = Integer.parseInt(additionsSettings.getProperty("WeddingPrice", "250000000"));
                L2JMOD_WEDDING_PUNISH_INFIDELITY = Boolean.parseBoolean(additionsSettings.getProperty("WeddingPunishInfidelity", "True"));
                L2JMOD_WEDDING_TELEPORT = Boolean.parseBoolean(additionsSettings.getProperty("WeddingTeleport", "True"));
                L2JMOD_WEDDING_TELEPORT_PRICE = Integer.parseInt(additionsSettings.getProperty("WeddingTeleportPrice", "50000"));
                L2JMOD_WEDDING_TELEPORT_DURATION = Integer.parseInt(additionsSettings.getProperty("WeddingTeleportDuration", "60"));
                L2JMOD_WEDDING_SAMESEX = Boolean.parseBoolean(additionsSettings.getProperty("WeddingAllowSameSex", "False"));
                L2JMOD_WEDDING_FORMALWEAR = Boolean.parseBoolean(additionsSettings.getProperty("WeddingFormalWear", "True"));
                L2JMOD_WEDDING_DIVORCE_COSTS = Integer.parseInt(additionsSettings.getProperty("WeddingDivorceCosts", "20"));
				COLOR_WEDDING_NAME = Boolean.parseBoolean(additionsSettings.getProperty("ColorWeddingName", "True"));
                COLOR_WEDDING_NAMES = Integer.decode((new StringBuilder()).append("0x").append(additionsSettings.getProperty("WeddingNameColor", "FFFF00")).toString());
                COLOR_WEDDING_NAMES_GEY = Integer.decode((new StringBuilder()).append("0x").append(additionsSettings.getProperty("WeddingNameGeyColor", "FF0000")).toString());
                COLOR_WEDDING_NAMES_LIZ = Integer.decode((new StringBuilder()).append("0x").append(additionsSettings.getProperty("WeddingNameLizColor", "F0F000")).toString());
				BANKING_SYSTEM_ENABLED	= Boolean.parseBoolean(additionsSettings.getProperty("BankingEnabled", "False"));
				BANKING_SYSTEM_GOLDBARS	= Integer.parseInt(additionsSettings.getProperty("BankingGoldbarCount", "1"));
				BANKING_SYSTEM_ADENA	= Integer.parseInt(additionsSettings.getProperty("BankingAdenaCount", "500000000"));
				BANKING_SYSTEM_ITEM = Integer.parseInt(additionsSettings.getProperty("BankingItemId", "3470"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+ADDITIONS_CONFIG_FILE+" File.");
            }
            try
            {
                Properties sevensings      = new Properties();
                InputStream is              = new FileInputStream(new File(SEVEN_SIGNS_DATA_FILE));
                sevensings.load(is);
                is.close();
                ALT_GAME_REQUIRE_CASTLE_DAWN = Boolean.parseBoolean(sevensings.getProperty("AltRequireCastleForDawn", "False"));
                ALT_GAME_REQUIRE_CLAN_CASTLE = Boolean.parseBoolean(sevensings.getProperty("AltRequireClanCastle", "False"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+SEVEN_SIGNS_DATA_FILE+" File.");
            }

            try
            {
                Properties pvpSettings      = new Properties();
                InputStream is              = new FileInputStream(new File(PVP_CONFIG_FILE));
                pvpSettings.load(is);
                is.close();
				PVPPK_PROTECT = Integer.parseInt(pvpSettings.getProperty("PvpPkProtect", "30"));
				ATTACK_STANCE_TASKS = Integer.parseInt(pvpSettings.getProperty("AttackStanceTasks", "15000"));
                KARMA_MIN_KARMA = Integer.parseInt(pvpSettings.getProperty("MinKarma", "240"));
                KARMA_MAX_KARMA = Integer.parseInt(pvpSettings.getProperty("MaxKarma", "10000"));
                KARMA_XP_DIVIDER = Integer.parseInt(pvpSettings.getProperty("XPDivider", "260"));
                KARMA_LOST_BASE = Integer.parseInt(pvpSettings.getProperty("BaseKarmaLost", "0"));
                KARMA_DROP_GM = Boolean.parseBoolean(pvpSettings.getProperty("CanGMDropEquipment", "false"));
                KARMA_AWARD_PK_KILL = Boolean.parseBoolean(pvpSettings.getProperty("AwardPKKillPVPPoint", "true"));
                KARMA_PK_LIMIT = Integer.parseInt(pvpSettings.getProperty("MinimumPKRequiredToDrop", "5"));
                KARMA_NONDROPPABLE_PET_ITEMS = pvpSettings.getProperty("ListOfPetItems", "2375,3500,3501,3502,4422,4423,4424,4425,6648,6649,6650");
                KARMA_NONDROPPABLE_ITEMS = pvpSettings.getProperty("ListOfNonDroppableItems", "57,1147,425,1146,461,10,2368,7,6,2370,2369,6842,6611,6612,6613,6614,6615,6616,6617,6618,6619,6620,6621");
                KARMA_LIST_NONDROPPABLE_PET_ITEMS = new FastList<Integer>();
                for (String id : KARMA_NONDROPPABLE_PET_ITEMS.split(","))
                {
                    KARMA_LIST_NONDROPPABLE_PET_ITEMS.add(Integer.parseInt(id));
                }
                KARMA_LIST_NONDROPPABLE_ITEMS = new FastList<Integer>();
                for (String id : KARMA_NONDROPPABLE_ITEMS.split(","))
                {
                    KARMA_LIST_NONDROPPABLE_ITEMS.add(Integer.parseInt(id));
                }
                PVP_NORMAL_TIME = Integer.parseInt(pvpSettings.getProperty("PvPVsNormalTime", "15000"));
                PVP_PVP_TIME = Integer.parseInt(pvpSettings.getProperty("PvPVsPvPTime", "30000"));
				PVP_ITEM_ID = Integer.parseInt(pvpSettings.getProperty("PvPItemId", "4037"));
                PVP_ITEM_COUNT = Integer.parseInt(pvpSettings.getProperty("PvPItemCount", "0"));
                PVP_EXP_COUNT = Long.parseLong(pvpSettings.getProperty("PvPExpCount", "0"));
                PVP_SP_COUNT = Integer.parseInt(pvpSettings.getProperty("PvPSPCount", "0"));
                PVP_LEVEL_DIFFERENCE = Integer.parseInt(pvpSettings.getProperty("PvPLevelDifference", "10"));
                PVP_STRICT_IP = Boolean.parseBoolean(pvpSettings.getProperty("StrictPvPIp", "True"));
                PK_ITEM_ID = Integer.parseInt(pvpSettings.getProperty("PKItemId", "4037"));
                PK_ITEM_COUNT = Integer.parseInt(pvpSettings.getProperty("PKItemCount", "0"));
                PK_EXP_COUNT = Long.parseLong(pvpSettings.getProperty("PKExpCount", "0"));
                PK_SP_COUNT = Integer.parseInt(pvpSettings.getProperty("PKSPCount", "0"));
                PK_LEVEL_DIFFERENCE = Integer.parseInt(pvpSettings.getProperty("PKLevelDifference", "10"));
                PK_STRICT_IP = Boolean.parseBoolean(pvpSettings.getProperty("StrictPKIp", "True"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+PVP_CONFIG_FILE+" File.");
            }

            try
            {
                Properties gmSettings   = new Properties();
                InputStream is          = new FileInputStream(new File(GM_ACCESS_FILE));
                gmSettings.load(is);
                is.close();
                GM_ACCESSLEVEL  = Integer.parseInt(gmSettings.getProperty("GMAccessLevel", "100"));
                GM_MIN          = Integer.parseInt(gmSettings.getProperty("GMMinLevel", "100"));
                GM_ALTG_MIN_LEVEL = Integer.parseInt(gmSettings.getProperty("GMCanAltG", "100"));
                GM_ANNOUNCE     = Integer.parseInt(gmSettings.getProperty("GMCanAnnounce", "100"));
                GM_BAN          = Integer.parseInt(gmSettings.getProperty("GMCanBan", "100"));
                GM_BAN_CHAT     = Integer.parseInt(gmSettings.getProperty("GMCanBanChat", "100"));
                GM_CREATE_ITEM  = Integer.parseInt(gmSettings.getProperty("GMCanShop", "100"));
                GM_DELETE       = Integer.parseInt(gmSettings.getProperty("GMCanDelete", "100"));
                GM_KICK         = Integer.parseInt(gmSettings.getProperty("GMCanKick", "100"));
                GM_MENU         = Integer.parseInt(gmSettings.getProperty("GMMenu", "100"));
                GM_GODMODE      = Integer.parseInt(gmSettings.getProperty("GMGodMode", "100"));
                GM_CHAR_EDIT    = Integer.parseInt(gmSettings.getProperty("GMCanEditChar", "100"));
                GM_CHAR_EDIT_OTHER    = Integer.parseInt(gmSettings.getProperty("GMCanEditCharOther", "100"));
                GM_CHAR_VIEW    = Integer.parseInt(gmSettings.getProperty("GMCanViewChar", "100"));
                GM_NPC_EDIT     = Integer.parseInt(gmSettings.getProperty("GMCanEditNPC", "100"));
                GM_NPC_VIEW     = Integer.parseInt(gmSettings.getProperty("GMCanViewNPC", "100"));
                GM_TELEPORT     = Integer.parseInt(gmSettings.getProperty("GMCanTeleport", "100"));
                GM_TELEPORT_OTHER     = Integer.parseInt(gmSettings.getProperty("GMCanTeleportOther", "100"));
                GM_RESTART      = Integer.parseInt(gmSettings.getProperty("GMCanRestart", "100"));
                GM_MONSTERRACE  = Integer.parseInt(gmSettings.getProperty("GMMonsterRace", "100"));
                GM_RIDER        = Integer.parseInt(gmSettings.getProperty("GMRider", "100"));
                GM_ESCAPE       = Integer.parseInt(gmSettings.getProperty("GMFastUnstuck", "100"));
                GM_FIXED        = Integer.parseInt(gmSettings.getProperty("GMResurectFixed", "100"));
                GM_CREATE_NODES = Integer.parseInt(gmSettings.getProperty("GMCreateNodes", "100"));
                GM_ENCHANT      = Integer.parseInt(gmSettings.getProperty("GMEnchant", "100"));
                GM_DOOR         = Integer.parseInt(gmSettings.getProperty("GMDoor", "100"));
                GM_RES          = Integer.parseInt(gmSettings.getProperty("GMRes", "100"));
                GM_PEACEATTACK  = Integer.parseInt(gmSettings.getProperty("GMPeaceAttack", "100"));
                GM_HEAL         = Integer.parseInt(gmSettings.getProperty("GMHeal", "100"));
                GM_UNBLOCK      = Integer.parseInt(gmSettings.getProperty("GMUnblock", "100"));
                GM_CACHE        = Integer.parseInt(gmSettings.getProperty("GMCache", "100"));
                GM_TALK_BLOCK   = Integer.parseInt(gmSettings.getProperty("GMTalkBlock", "100"));
                GM_TEST         = Integer.parseInt(gmSettings.getProperty("GMTest", "100"));

                String gmTrans = gmSettings.getProperty("GMDisableTransaction", "False");

                if (!gmTrans.equalsIgnoreCase("false"))
                {
                    String[] params = gmTrans.split(",");
                    GM_DISABLE_TRANSACTION = true;
                    GM_TRANSACTION_MIN = Integer.parseInt(params[0]);
                    GM_TRANSACTION_MAX = Integer.parseInt(params[1]);
                }
                else
                {
                    GM_DISABLE_TRANSACTION = false;
                }
                GM_CAN_GIVE_DAMAGE = Integer.parseInt(gmSettings.getProperty("GMCanGiveDamage", "90"));
                GM_DONT_TAKE_AGGRO = Integer.parseInt(gmSettings.getProperty("GMDontTakeAggro", "90"));
                GM_DONT_TAKE_EXPSP = Integer.parseInt(gmSettings.getProperty("GMDontGiveExpSp", "90"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+GM_ACCESS_FILE+" File.");
            }

            try
            {
                Properties Settings   = new Properties();
                InputStream is          = new FileInputStream(HEXID_FILE);
                Settings.load(is);
                is.close();
                SERVER_ID = Integer.parseInt(Settings.getProperty("ServerID"));
                HEX_ID = new BigInteger(Settings.getProperty("HexID"), 16).toByteArray();
            }
            catch (Exception e)
            {
                _log.warning("Could not load HexID file ("+HEXID_FILE+"). Hopefully login will give us one.");
            }
        }
        else if(Server.serverMode == Server.MODE_LOGINSERVER)
        {
            _log.info("Load LoginServer Config");
            try
            {
                Properties serverSettings    = new Properties();
                InputStream is               = new FileInputStream(new File(LOGIN_CONFIGURATION_FILE));
                serverSettings.load(is);
                is.close();
                GAME_SERVER_LOGIN_HOST = serverSettings.getProperty("LoginHostname","*");
                GAME_SERVER_LOGIN_PORT = Integer.parseInt(serverSettings.getProperty("LoginPort","9013"));
                LOGIN_BIND_ADDRESS     = serverSettings.getProperty("LoginserverHostname", "*");
                PORT_LOGIN            = Integer.parseInt(serverSettings.getProperty("LoginserverPort", "2106"));
                DEBUG        = Boolean.parseBoolean(serverSettings.getProperty("Debug", "false"));
                DEVELOPER    = Boolean.parseBoolean(serverSettings.getProperty("Developer", "false"));
                ASSERT       = Boolean.parseBoolean(serverSettings.getProperty("Assert", "false"));
                ACCEPT_NEW_GAMESERVER = Boolean.parseBoolean(serverSettings.getProperty("AcceptNewGameServer","True"));
                REQUEST_ID = Integer.parseInt(serverSettings.getProperty("RequestServerID","0"));
                ACCEPT_ALTERNATE_ID = Boolean.parseBoolean(serverSettings.getProperty("AcceptAlternateID","True"));
                LOGIN_TRY_BEFORE_BAN    = Integer.parseInt(serverSettings.getProperty("LoginTryBeforeBan", "10"));
                LOGIN_BLOCK_AFTER_BAN   = Integer.parseInt(serverSettings.getProperty("LoginBlockAfterBan", "600"));
                GM_MIN          = Integer.parseInt(serverSettings.getProperty("GMMinLevel", "100"));
                INTERNAL_HOSTNAME   = serverSettings.getProperty("InternalHostname", "localhost");
                EXTERNAL_HOSTNAME   = serverSettings.getProperty("ExternalHostname", "localhost");
                DATABASE_DRIVER             = serverSettings.getProperty("Driver", "com.mysql.jdbc.Driver");
                DATABASE_URL                = serverSettings.getProperty("URL", "jdbc:mysql://localhost/l2jdb");
                DATABASE_LOGIN              = serverSettings.getProperty("Login", "root");
                DATABASE_PASSWORD           = serverSettings.getProperty("Password", "");
                DATABASE_MAX_CONNECTIONS    = Integer.parseInt(serverSettings.getProperty("MaximumDbConnections", "10"));
                SHOW_LICENCE = Boolean.parseBoolean(serverSettings.getProperty("ShowLicence", "true"));
                IP_UPDATE_TIME                = Integer.parseInt(serverSettings.getProperty("IpUpdateTime","15"));
                AUTO_CREATE_ACCOUNTS = Boolean.parseBoolean(serverSettings.getProperty("AutoCreateAccounts","True"));
                NETWORK_IP_LIST = serverSettings.getProperty("NetworkList", "");
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+CONFIGURATION_FILE+" File.");
            }

            try
            {
                Properties telnetSettings   = new Properties();
                InputStream is              = new FileInputStream(new File(TELNET_FILE));
                telnetSettings.load(is);
                is.close();

                IS_TELNET_ENABLED   = Boolean.valueOf(telnetSettings.getProperty("EnableTelnet", "false"));
            }
            catch (Exception e)
            {
                e.printStackTrace();
                throw new Error("Failed to Load "+TELNET_FILE+" File.");
            }

        }
        else
        {
            _log.severe("Could not Load Config: server mode was not set");
        }

    }

    public static boolean setParameterValue(String pName, String pValue)
    {
        if (pName.equalsIgnoreCase("RateXp")) RATE_XP = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RateSp")) RATE_SP = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RatePartyXp")) RATE_PARTY_XP = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RatePartySp")) RATE_PARTY_SP = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RateQuestsReward")) RATE_QUESTS_REWARD = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RateDropAdena")) RATE_DROP_ADENA = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RateConsumableCost")) RATE_CONSUMABLE_COST = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RateDropItems")) RATE_DROP_ITEMS = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RateDropSpoil")) RATE_DROP_SPOIL = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RateDropManor")) RATE_DROP_MANOR = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("RateDropQuest")) RATE_DROP_QUEST = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RateKarmaExpLost")) RATE_KARMA_EXP_LOST = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("RateSiegeGuardsPrice")) RATE_SIEGE_GUARDS_PRICE = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("PlayerDropLimit")) PLAYER_DROP_LIMIT = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("PlayerRateDrop")) PLAYER_RATE_DROP = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("PlayerRateDropItem")) PLAYER_RATE_DROP_ITEM = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("PlayerRateDropEquip")) PLAYER_RATE_DROP_EQUIP = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("PlayerRateDropEquipWeapon")) PLAYER_RATE_DROP_EQUIP_WEAPON = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("KarmaDropLimit")) KARMA_DROP_LIMIT = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("KarmaRateDrop")) KARMA_RATE_DROP = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("KarmaRateDropItem")) KARMA_RATE_DROP_ITEM = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("KarmaRateDropEquip")) KARMA_RATE_DROP_EQUIP = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("KarmaRateDropEquipWeapon")) KARMA_RATE_DROP_EQUIP_WEAPON = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("AutoDestroyDroppedItemAfter")) AUTODESTROY_ITEM_AFTER = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("DestroyPlayerDroppedItem")) DESTROY_DROPPED_PLAYER_ITEM = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("DestroyEquipableItem")) DESTROY_EQUIPABLE_PLAYER_ITEM = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("SaveDroppedItem")) SAVE_DROPPED_ITEM = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("EmptyDroppedItemTableAfterLoad")) EMPTY_DROPPED_ITEM_TABLE_AFTER_LOAD = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("SaveDroppedItemInterval")) SAVE_DROPPED_ITEM_INTERVAL = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("ClearDroppedItemTable")) CLEAR_DROPPED_ITEM_TABLE = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("PreciseDropCalculation")) PRECISE_DROP_CALCULATION = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("MultipleItemDrop")) MULTIPLE_ITEM_DROP = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("DeleteCharAfterDays")) DELETE_DAYS = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("AllowDiscardItem")) ALLOW_DISCARDITEM = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AllowFreight")) ALLOW_FREIGHT = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AllowWarehouse")) ALLOW_WAREHOUSE = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AllowWear")) ALLOW_WEAR = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("WearDelay")) WEAR_DELAY = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("WearPrice")) WEAR_PRICE = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("AllowWater")) ALLOW_WATER = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AllowRentPet")) ALLOW_RENTPET = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AllowBoat")) ALLOW_BOAT = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AllowCursedWeapons")) ALLOW_CURSED_WEAPONS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AllowManor")) ALLOW_MANOR = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("BypassValidation")) BYPASS_VALIDATION = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("CommunityType")) COMMUNITY_TYPE = pValue.toLowerCase();
        else if (pName.equalsIgnoreCase("BBSDefault")) BBS_DEFAULT = pValue;
        else if (pName.equalsIgnoreCase("ShowLevelOnCommunityBoard")) SHOW_LEVEL_COMMUNITYBOARD = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("ShowStatusOnCommunityBoard")) SHOW_STATUS_COMMUNITYBOARD = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("NamePageSizeOnCommunityBoard")) NAME_PAGE_SIZE_COMMUNITYBOARD = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("NamePerRowOnCommunityBoard")) NAME_PER_ROW_COMMUNITYBOARD = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("ShowServerNews")) SERVER_NEWS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("ForceInventoryUpdate")) FORCE_INVENTORY_UPDATE = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AutoDeleteInvalidQuestData")) AUTODELETE_INVALID_QUEST_DATA = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("MaximumOnlineUsers")) MAXIMUM_ONLINE_USERS = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("ZoneTown")) ZONE_TOWN = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("CheckKnownList")) CHECK_KNOWN = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("UseDeepBlueDropRules")) DEEPBLUE_DROP_RULES = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AllowGuards")) ALLOW_GUARDS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("CancelLesserEffect")) EFFECT_CANCELING = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("WyvernSpeed")) WYVERN_SPEED = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("StriderSpeed")) STRIDER_SPEED = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MaximumSlotsForNoDwarf")) INVENTORY_MAXIMUM_NO_DWARF = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MaximumSlotsForDwarf")) INVENTORY_MAXIMUM_DWARF = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MaximumSlotsForGMPlayer")) INVENTORY_MAXIMUM_GM = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MaximumWarehouseSlotsForNoDwarf")) WAREHOUSE_SLOTS_NO_DWARF = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MaximumWarehouseSlotsForDwarf")) WAREHOUSE_SLOTS_DWARF = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MaximumWarehouseSlotsForClan")) WAREHOUSE_SLOTS_CLAN = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MaximumFreightSlots")) FREIGHT_SLOTS = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("HpRegenMultiplier")) HP_REGEN_MULTIPLIER = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("MpRegenMultiplier")) MP_REGEN_MULTIPLIER = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("CpRegenMultiplier")) CP_REGEN_MULTIPLIER = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("RaidHpRegenMultiplier")) RAID_HP_REGEN_MULTIPLIER = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("RaidMpRegenMultiplier")) RAID_MP_REGEN_MULTIPLIER = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("RaidDefenceMultiplier")) RAID_DEFENCE_MULTIPLIER = Double.parseDouble(pValue) /100;
        else if (pName.equalsIgnoreCase("RaidMinionRespawnTime")) RAID_MINION_RESPAWN_TIMER =Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("StartingAdena")) STARTING_ADENA = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("UnstuckInterval")) UNSTUCK_INTERVAL = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("PlayerSpawnProtection")) PLAYER_SPAWN_PROTECTION = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("PlayerFakeDeathUpProtection")) PLAYER_FAKEDEATH_UP_PROTECTION = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("PartyXpCutoffMethod")) PARTY_XP_CUTOFF_METHOD = pValue;
        else if (pName.equalsIgnoreCase("PartyXpCutoffPercent")) PARTY_XP_CUTOFF_PERCENT = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("PartyXpCutoffLevel")) PARTY_XP_CUTOFF_LEVEL = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("RespawnRestoreCP")) RESPAWN_RESTORE_CP = Double.parseDouble(pValue) / 100;
        else if (pName.equalsIgnoreCase("RespawnRestoreHP")) RESPAWN_RESTORE_HP = Double.parseDouble(pValue) / 100;
        else if (pName.equalsIgnoreCase("RespawnRestoreMP")) RESPAWN_RESTORE_MP = Double.parseDouble(pValue) / 100;
        else if (pName.equalsIgnoreCase("MaxPvtStoreSlotsDwarf")) MAX_PVTSTORE_SLOTS_DWARF = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MaxPvtStoreSlotsOther")) MAX_PVTSTORE_SLOTS_OTHER = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("StoreSkillCooltime")) STORE_SKILL_COOLTIME = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AnnounceMammonSpawn")) ANNOUNCE_MAMMON_SPAWN = Boolean.valueOf(pValue);
        //event
                else if(pName.equalsIgnoreCase("TvTEvenTeams"))
		{
			TVT_EVEN_TEAMS = pValue;
		}
		else if(pName.equalsIgnoreCase("TvTAllowInterference"))
		{
			TVT_ALLOW_INTERFERENCE = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("TvTAllowPotions"))
		{
			TVT_ALLOW_POTIONS = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("TvTAllowSummon"))
		{
			TVT_ALLOW_SUMMON = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("TvTOnStartRemoveAllEffects"))
		{
			TVT_ON_START_REMOVE_ALL_EFFECTS = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("TvTOnStartUnsummonPet"))
		{
			TVT_ON_START_UNSUMMON_PET = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("TVTReviveDelay"))
		{
			TVT_REVIVE_DELAY = Long.parseLong(pValue);
		}
        else if(pName.equalsIgnoreCase("CTFEvenTeams"))
		{
			CTF_EVEN_TEAMS = pValue;
		}
		else if(pName.equalsIgnoreCase("CTFAllowInterference"))
		{
			CTF_ALLOW_INTERFERENCE = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("CTFAllowPotions"))
		{
			CTF_ALLOW_POTIONS = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("CTFAllowSummon"))
		{
			CTF_ALLOW_SUMMON = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("CTFOnStartRemoveAllEffects"))
		{
			CTF_ON_START_REMOVE_ALL_EFFECTS = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("CTFOnStartUnsummonPet"))
		{
			CTF_ON_START_UNSUMMON_PET = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("DMAllowInterference"))
		{
			DM_ALLOW_INTERFERENCE = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("DMAllowPotions"))
		{
			DM_ALLOW_POTIONS = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("DMAllowSummon"))
		{
			DM_ALLOW_SUMMON = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("DMJoinWithCursedWeapon"))
		{
			DM_JOIN_CURSED = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("DMOnStartRemoveAllEffects"))
		{
			DM_ON_START_REMOVE_ALL_EFFECTS = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("DMOnStartUnsummonPet"))
		{
			DM_ON_START_UNSUMMON_PET = Boolean.parseBoolean(pValue);
		}
		else if(pName.equalsIgnoreCase("DMReviveDelay"))
		{
			DM_REVIVE_DELAY = Long.parseLong(pValue);
		}
        // Alternative settings
        else if (pName.equalsIgnoreCase("AltGameTiredness")) ALT_GAME_TIREDNESS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltGameCreation")) ALT_GAME_CREATION = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltGameCreationSpeed")) ALT_GAME_CREATION_SPEED = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("AltGameCreationXpRate")) ALT_GAME_CREATION_XP_RATE = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("AltGameCreationSpRate")) ALT_GAME_CREATION_SP_RATE = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("AltWeightLimit")) ALT_WEIGHT_LIMIT = Double.parseDouble(pValue);
        else if (pName.equalsIgnoreCase("AltBlacksmithUseRecipes")) ALT_BLACKSMITH_USE_RECIPES = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltGameSkillLearn")) ALT_GAME_SKILL_LEARN = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("RemoveCastleCirclets")) REMOVE_CASTLE_CIRCLETS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltGameCancelByHit"))
        {
            ALT_GAME_CANCEL_BOW     = pValue.equalsIgnoreCase("bow") || pValue.equalsIgnoreCase("all");
            ALT_GAME_CANCEL_CAST    = pValue.equalsIgnoreCase("cast") || pValue.equalsIgnoreCase("all");
        }
        else if(pName.equalsIgnoreCase("ServerNameEnabled"))
		{
			ALT_Server_Name_Enabled = Boolean.valueOf(pValue);
		}
		else if(pName.equalsIgnoreCase("ServerName"))
		{
			ALT_Server_Name = String.valueOf(pValue);
		}
        else if (pName.equalsIgnoreCase("AltShieldBlocks")) ALT_GAME_SHIELD_BLOCKS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltPerfectShieldBlockRate")) ALT_PERFECT_SHLD_BLOCK = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("Delevel")) ALT_GAME_DELEVEL = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("MagicFailures")) ALT_GAME_MAGICFAILURES = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltGameMobAttackAI")) ALT_GAME_MOB_ATTACK_AI = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltMobAgroInPeaceZone")) ALT_MOB_AGRO_IN_PEACEZONE = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltGameExponentXp")) ALT_GAME_EXPONENT_XP = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("AltGameExponentSp")) ALT_GAME_EXPONENT_SP = Float.parseFloat(pValue);
        else if (pName.equalsIgnoreCase("AllowClassMasters")) ALLOW_CLASS_MASTERS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltGameFreights")) ALT_GAME_FREIGHTS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltGameFreightPrice")) ALT_GAME_FREIGHT_PRICE = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("AltPartyRange")) ALT_PARTY_RANGE = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("AltPartyRange2")) ALT_PARTY_RANGE2 = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("CraftingEnabled")) IS_CRAFTING_ENABLED = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("LifeCrystalNeeded")) LIFE_CRYSTAL_NEEDED = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("SpBookNeeded")) SP_BOOK_NEEDED = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AutoLoot")) AUTO_LOOT = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AutoLootHerbs")) AUTO_LOOT_HERBS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltKarmaPlayerCanBeKilledInPeaceZone")) ALT_GAME_KARMA_PLAYER_CAN_BE_KILLED_IN_PEACEZONE = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltKarmaPlayerCanShop")) ALT_GAME_KARMA_PLAYER_CAN_SHOP = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltKarmaPlayerCanUseGK")) ALT_GAME_KARMA_PLAYER_CAN_USE_GK = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltKarmaPlayerCanTeleport")) ALT_GAME_KARMA_PLAYER_CAN_TELEPORT = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltKarmaPlayerCanTrade")) ALT_GAME_KARMA_PLAYER_CAN_TRADE = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltKarmaPlayerCanUseWareHouse")) ALT_GAME_KARMA_PLAYER_CAN_USE_WAREHOUSE = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltRequireCastleForDawn")) ALT_GAME_REQUIRE_CASTLE_DAWN = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltRequireClanCastle")) ALT_GAME_REQUIRE_CLAN_CASTLE = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltFreeTeleporting")) ALT_GAME_FREE_TELEPORT = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltSubClassWithoutQuests")) ALT_GAME_SUBCLASS_WITHOUT_QUESTS = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AltMembersCanWithdrawFromClanWH")) ALT_MEMBERS_CAN_WITHDRAW_FROM_CLANWH = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("DwarfRecipeLimit")) DWARF_RECIPE_LIMIT = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("CommonRecipeLimit")) COMMON_RECIPE_LIMIT = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("AllowWedding")) L2JMOD_ALLOW_WEDDING = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("WeddingPrice")) L2JMOD_WEDDING_PRICE = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("WeddingPunishInfidelity")) L2JMOD_WEDDING_PUNISH_INFIDELITY = Boolean.parseBoolean(pValue);
        else if (pName.equalsIgnoreCase("WeddingTeleport")) L2JMOD_WEDDING_TELEPORT = Boolean.parseBoolean(pValue);
        else if (pName.equalsIgnoreCase("WeddingTeleportPrice")) L2JMOD_WEDDING_TELEPORT_PRICE = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("WeddingTeleportDuration")) L2JMOD_WEDDING_TELEPORT_DURATION = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("WeddingAllowSameSex")) L2JMOD_WEDDING_SAMESEX = Boolean.parseBoolean(pValue);
        else if (pName.equalsIgnoreCase("WeddingFormalWear")) L2JMOD_WEDDING_FORMALWEAR = Boolean.parseBoolean(pValue);
        else if (pName.equalsIgnoreCase("WeddingDivorceCosts")) L2JMOD_WEDDING_DIVORCE_COSTS = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MinKarma")) KARMA_MIN_KARMA = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("MaxKarma")) KARMA_MAX_KARMA = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("XPDivider")) KARMA_XP_DIVIDER = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("BaseKarmaLost")) KARMA_LOST_BASE = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("CanGMDropEquipment")) KARMA_DROP_GM = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("AwardPKKillPVPPoint")) KARMA_AWARD_PK_KILL = Boolean.valueOf(pValue);
        else if (pName.equalsIgnoreCase("MinimumPKRequiredToDrop")) KARMA_PK_LIMIT = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("PvPVsNormalTime")) PVP_NORMAL_TIME = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("PvPVsPvPTime")) PVP_PVP_TIME = Integer.parseInt(pValue);
        else if (pName.equalsIgnoreCase("GlobalChat")) DEFAULT_GLOBAL_CHAT = pValue;
        else if (pName.equalsIgnoreCase("TradeChat"))  DEFAULT_TRADE_CHAT = pValue;
        else if (pName.equalsIgnoreCase("MenuStyle"))  GM_ADMIN_MENU_STYLE = pValue;
        else return false;
        return true;
    }

	public static class ClassMasterSettings
	{
		private final FastMap<Integer, FastMap<Integer, Integer>> _claimItems;
		private final FastMap<Integer, FastMap<Integer, Integer>> _rewardItems;
		private final FastMap<Integer, Boolean> _allowedClassChange;

		public ClassMasterSettings(String _configLine)
		{
			_claimItems = new FastMap<Integer, FastMap<Integer, Integer>>();
			_rewardItems = new FastMap<Integer, FastMap<Integer, Integer>>();
			_allowedClassChange = new FastMap<Integer, Boolean>();
			if (_configLine != null)
				parseConfigLine(_configLine.trim());
		}
		private void parseConfigLine(String _configLine)
		{
			StringTokenizer st = new StringTokenizer(_configLine, ";");

			while (st.hasMoreTokens())
			{
				// get allowed class change
				int job = Integer.parseInt(st.nextToken());

				_allowedClassChange.put(job, true);

				FastMap<Integer, Integer> _items = new FastMap<Integer, Integer>();
				// parse items needed for class change
				if (st.hasMoreTokens())
				{
					StringTokenizer st2 = new StringTokenizer(st.nextToken(), "[],");

					while (st2.hasMoreTokens())
					{
						StringTokenizer st3 = new StringTokenizer(st2.nextToken(), "()");
						int _itemId = Integer.parseInt(st3.nextToken());
						int _quantity = Integer.parseInt(st3.nextToken());
						_items.put(_itemId, _quantity);
					}
				}

				_claimItems.put(job, _items);

				_items = new FastMap<Integer, Integer>();
				// parse gifts after class change
				if (st.hasMoreTokens())
				{
					StringTokenizer st2 = new StringTokenizer(st.nextToken(), "[],");

					while (st2.hasMoreTokens())
					{
						StringTokenizer st3 = new StringTokenizer(st2.nextToken(), "()");
						int _itemId = Integer.parseInt(st3.nextToken());
						int _quantity = Integer.parseInt(st3.nextToken());
						_items.put(_itemId, _quantity);
					}
				}

				_rewardItems.put(job, _items);
			}
		}

		public boolean isAllowed(int job)
		{
            return _allowedClassChange != null && _allowedClassChange.containsKey(job) && _allowedClassChange.get(job);
        }

		public FastMap<Integer, Integer> getRewardItems(int job)
		{
			if (_rewardItems.containsKey(job))
				return _rewardItems.get(job);
			else
				return null;
		}

		public FastMap<Integer, Integer> getRequireItems(int job)
		{
			if (_claimItems.containsKey(job))
				return _claimItems.get(job);
			else
				return null;
		}
	}

    public static boolean allowL2Walker(L2PcInstance player)
    {
        return (ALLOW_L2WALKER_CLIENT == L2WalkerAllowed.True ||(ALLOW_L2WALKER_CLIENT == L2WalkerAllowed.GM && player != null && player.isGM()));
    }
    private Config()
    {
    }
    public static void saveHexid(int serverId, String string)
    {
        Config.saveHexid(serverId, string, HEXID_FILE);
    }

    public static void saveHexid(int serverId, String hexId, String fileName)
    {
        try
        {
            Properties hexSetting = new Properties();
            File file = new File(fileName);
            file.createNewFile();
            OutputStream out = new FileOutputStream(file);
            hexSetting.setProperty("ServerID",String.valueOf(serverId));
            hexSetting.setProperty("HexID",hexId);
            hexSetting.store(out,"the hexID to auth into login");
            out.close();
        }
        catch (Exception e)
        {
            _log.warning("Failed to save hex id to "+fileName+" File.");
            e.printStackTrace();
        }
    }
}